2010-12-06  Yael Aharon  <yael.aharon@nokia.com>

        Reviewed by Andreas Kling.

        [Qt] Support focus ring outline color for links.
        https://bugs.webkit.org/show_bug.cgi?id=50428

        Take width and offset into account when drawing focus ring.

        Tests: fast/css/focus-ring-outline-color.html
               fast/css/focus-ring-outline-offset.html
               fast/css/focus-ring-outline-width.html

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::drawFocusRing):

2010-12-06  Yael Aharon  <yael.aharon@nokia.com>

        Reviewed by Andreas Kling.

        [Qt] Fix focus ring outline color support
        https://bugs.webkit.org/show_bug.cgi?id=50325

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::drawFocusRing):

        Take the outline width into account when drawing the focus ring of image map.
        Change the outline-style from dotted to solid. The default outline-width is 
        5 pixels, and dotted lines just don't make sense anymore.
        Give the focus ring alpha of 50%, following what other ports do.
        Save and restore the pen when drawing a focus ring.

2010-12-06  Andras Becsi  <abecsi@webkit.org>

        Reviewed by Csaba Osztrogonác.

        [Qt][V8] Build fix after r73283.

        No new tests needed.

        * WebCore.pri: Add missing webaudio directory
        to IDL generator includes.

2010-12-06  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Martin Robinson.

        [soup] implement ResourceHandle::platformSetDefersLoading
        https://bugs.webkit.org/show_bug.cgi?id=44158

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::platformSetDefersLoading): Implemented
        using the soup_session_{,un}pause_message APIs.

2010-12-06  Sergio Villar Senin  <svillar@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Leak in webkit_soup_cache_load if file contents load fails
        https://bugs.webkit.org/show_bug.cgi?id=50558

        g_file_get_contents() could return an error after allocating a
        buffer for file contents. We must free that memory before
        returning.

        * platform/network/soup/cache/webkit/soup-cache.c:
        (webkit_soup_cache_load): Added a missing g_free().

2010-12-06  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r73351.
        http://trac.webkit.org/changeset/73351
        https://bugs.webkit.org/show_bug.cgi?id=50560

        "The change broke plugin tests in Chromium" (Requested by
        yurys on #webkit).

        * bindings/js/ScriptCallStackFactory.cpp:
        (WebCore::ScriptCallStack::stackTrace):
        * bindings/js/ScriptCallStackFactory.h:
        * bindings/v8/ScriptCallStackFactory.cpp:
        (WebCore::toScriptCallFrame):
        (WebCore::toScriptCallFramesVector):
        (WebCore::createScriptCallStack):
        (WebCore::ScriptCallStack::stackTrace):
        * bindings/v8/ScriptCallStackFactory.h:
        * bindings/v8/V8ConsoleMessage.cpp:
        (WebCore::V8ConsoleMessage::handler):
        * inspector/ScriptCallFrame.cpp:
        (WebCore::ScriptCallFrame::ScriptCallFrame):
        (WebCore::ScriptCallFrame::isEqual):
        (WebCore::ScriptCallFrame::buildInspectorObject):
        * inspector/ScriptCallFrame.h:
        (WebCore::ScriptCallFrame::sourceURL):
        * inspector/ScriptCallStack.h:
        * inspector/TimelineRecordFactory.cpp:
        (WebCore::TimelineRecordFactory::createGenericRecord):
        * inspector/front-end/ConsoleView.js:
        (WebInspector.ConsoleMessage.prototype._populateStackTraceTreeElement):

2010-12-06  Robert Hogan  <robert@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] Report zero width for zero size fonts

        Report zero width when font size is zero.

        Fixes fast/text/font-size-zero.html

        https://bugs.webkit.org/show_bug.cgi?id=50539

        * platform/graphics/qt/FontQt.cpp:
        (WebCore::Font::floatWidthForSimpleText):
        (WebCore::Font::floatWidthForComplexText):

2010-12-03  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Pavel Feldman.

        [v8] Web Inspector: remove duplicate code for capturing stack trace
        https://bugs.webkit.org/show_bug.cgi?id=50461

        No new tests. Covered with existing inspector tests.

        * bindings/js/ScriptCallStackFactory.cpp:
        (WebCore::createScriptCallStack):
        * bindings/js/ScriptCallStackFactory.h:
        * bindings/v8/ScriptCallStackFactory.cpp:
        (WebCore::toScriptCallFrame):
        (WebCore::toScriptCallFramesVector):
        (WebCore::createScriptCallStack):
        * bindings/v8/ScriptCallStackFactory.h:
        * bindings/v8/V8ConsoleMessage.cpp:
        (WebCore::V8ConsoleMessage::handler):
        * inspector/ScriptCallFrame.cpp:
        (WebCore::ScriptCallFrame::ScriptCallFrame):
        (WebCore::ScriptCallFrame::isEqual):
        (WebCore::ScriptCallFrame::buildInspectorObject):
        * inspector/ScriptCallFrame.h:
        (WebCore::ScriptCallFrame::sourceURL):
        * inspector/ScriptCallStack.h:
        * inspector/TimelineRecordFactory.cpp:
        (WebCore::TimelineRecordFactory::createGenericRecord):
        * inspector/front-end/ConsoleView.js:
        (WebInspector.ConsoleMessage.prototype._populateStackTraceTreeElement):

2010-12-06  Sergio Villar Senin  <svillar@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] webkit_soup_cache_clear() does not delete all entries in the cache
        https://bugs.webkit.org/show_bug.cgi?id=50462

        Do not use g_hash_table_foreach to remove entries from the cache
        entries hashtable. Iterate over a list of entries to remove them
        from the hash table.

        * platform/network/soup/ResourceHandleSoup.cpp:
        * platform/network/soup/cache/webkit/soup-cache.c:
        (remove_cache_item):
        (webkit_soup_cache_finalize):
        (clear_cache_item):
        (webkit_soup_cache_clear):

2010-12-05  Kent Tamura  <tkent@chromium.org>

        Unreviewed. Run sort-Xcode-project-file.

        * WebCore.xcodeproj/project.pbxproj:

2010-11-30  Luiz Agostini  <luiz.agostini@openbossa.org>

        Reviewed by Darin Adler.

        HTML5 <details> and <summary> initial implementation
        https://bugs.webkit.org/show_bug.cgi?id=50309

        HTML5 <details> and <summary> elements initial implementation. The main objective is
        to add the files for html element and renderers, and to get rid of build system issues
        in future patches.

        See: http://www.w3.org/TR/html5/interactive-elements.html#the-details-element
             http://www.w3.org/TR/html5/interactive-elements.html#the-summary-element

        build systems

        * CMakeLists.txt:
        * DerivedSources.cpp:
        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pri:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/gobject/GNUmakefile.am:

        Some css properties to the new html elements.

        * css/html.css:
        (details):
        (summary):

        New html element associated with the corresponding tag.

        * html/HTMLAttributeNames.in:
        * html/HTMLTagNames.in:

        1 html element and 3 renderers were added.

        * html/HTMLDetailsElement.cpp: Added.
        * html/HTMLDetailsElement.h: Added.
        * html/HTMLDetailsElement.idl: Added.
        * html/HTMLElementsAllInOne.cpp:
        * rendering/RenderDetails.cpp: Added.
        * rendering/RenderDetails.h: Added.
        * rendering/RenderDetailsMarker.cpp: Added.
        * rendering/RenderDetailsMarker.h: Added.
        * rendering/RenderSummary.cpp: Added.
        * rendering/RenderSummary.h: Added.
        * rendering/RenderingAllInOne.cpp:

        New renderer type checkers.

        * rendering/RenderObject.h:
        (WebCore::RenderObject::isDetails):
        (WebCore::RenderObject::isDetailsMarker):
        (WebCore::RenderObject::isSummary):

2010-12-05  Rob Buis  <rwlbuis@gmail.com>

        Reviewed by Nikolas Zimmermann.

        createSVGTransformFromMatrix(undefined) => NULL ptr
        https://bugs.webkit.org/show_bug.cgi?id=49564

        Throw TYPE_MISMATCH_ERR when using undefined or null as value for matrix parameter.

        * svg/SVGTransformList.idl:
        * svg/properties/SVGTransformListPropertyTearOff.h:
        (WebCore::SVGTransformListPropertyTearOff::createSVGTransformFromMatrix):

2010-12-05  Alejandro G. Castro  <alex@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] Fix compilation warnings reported by clang
        https://bugs.webkit.org/show_bug.cgi?id=50252

        * platform/graphics/Path.h: CairoPath is now a class, not a
        struct.
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::sendRequestCallback): Cast the status_code to int.

2010-12-05  Alejandro G. Castro  <alex@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Remove setColor functions it was replicated in
        CairoUtilities: setSourceRGBAFromColor.

        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::setPlatformFill):
        (WebCore::setPlatformStroke):
        (WebCore::fillRectSourceOver):
        (WebCore::GraphicsContext::drawRect):
        (WebCore::GraphicsContext::drawLine):
        (WebCore::GraphicsContext::drawEllipse):
        (WebCore::GraphicsContext::strokeArc):
        (WebCore::GraphicsContext::drawConvexPolygon):
        (WebCore::GraphicsContext::drawFocusRing):
        (WebCore::GraphicsContext::fillRoundedRect):

2010-12-05  Adam Roben  <aroben@apple.com>

        Windows production build fix

        Put spaces after trailing backslashes when setting
        %WebKitVSPropsRedirectionDir%. According to MSDN
        <http://msdn.microsoft.com/en-us/library/2kzfk8c7(v=VS.80).aspx>:

           A backslash ( \ ) followed by a newline character is interpreted as
           a space in the command; use a backslash at the end of a line to
           continue a command onto the next line. NMAKE interprets the
           backslash literally if any other character, including a space or
           tab, follows the backslash.

        * WebCore.vcproj/WebCore.make:

2010-12-05  Robert Hogan  <robert@webkit.org>

        Reviewed by Andreas Kling.

        [Qt] Zero-sized font does not yet work

        Fix fast/text/font-size-zero.html

        Copy other ports by setting minimumFontSize to 0 for DRT runs,
        copy a fix to SimpleFontData from chromium/safari, and set font
        size in FontPlatformData to zero if size zero is requested
        and QFont::pixelSize otherwise. (Note that QFont doesn't accept
        a pixel size of zero).

        Also fix QFont::setPixelSize in FontPlatformData to use
        description.computedPixelSize rather than computedSize and
        pixelSize() rather than pointSizeF - since the latter gets
        set to -1 if pixelSize is set at all.

        https://bugs.webkit.org/show_bug.cgi?id=49759

        * platform/graphics/qt/FontPlatformData.h:
        (WebCore::FontPlatformDataPrivate::FontPlatformDataPrivate):
        (WebCore::FontPlatformData::pixelSize):
        * platform/graphics/qt/FontPlatformDataQt.cpp:
        (WebCore::FontPlatformData::FontPlatformData):
        * platform/graphics/qt/FontQt.cpp:
        (WebCore::drawTextCommon):
        * platform/graphics/qt/SimpleFontDataQt.cpp:
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::platformGlyphInit):
        (WebCore::SimpleFontData::platformCharWidthInit):

2010-12-04  Daniel Bates  <dbates@rim.com>

        Reviewed by Darin Adler.

        Add support for lower-armenian and upper-armenian
        https://bugs.webkit.org/show_bug.cgi?id=49641

        Implement support for list-style-types lower-armenian and upper-armenian
        for lowercase Armenian and uppercase Armenian numerals, respectively.

        Tests: fast/lists/w3-css3-lower-armenian.html
               fast/lists/w3-css3-upper-armenian.html

        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue): Added enum values LowerArmenian
        and UpperArmenian.
        * css/CSSValueKeywords.in: Added "upper-armenian" and "lower-armenian".
        * inspector/front-end/SourceCSSTokenizer.re2js: Ditto.
        * rendering/RenderListMarker.cpp:
        (WebCore::effectiveListMarkerType): Added enum values LowerArmenian
        and UpperArmenian.
        (WebCore::listMarkerSuffix): Ditto.
        (WebCore::listMarkerText): Ditto.
        (WebCore::RenderListMarker::paint): Ditto.
        (WebCore::RenderListMarker::computePreferredLogicalWidths): Ditto.
        (WebCore::RenderListMarker::getRelativeMarkerRect): Ditto.
        * rendering/style/RenderStyleConstants.h: Ditto.

2010-12-04  Dan Bernstein  <mitz@apple.com>

        Reviewed by Sam Weinig.

        WebCore part of <rdar://problem/8145955> Add text search API for counting/marking/highlighting matches in a range
        https://bugs.webkit.org/show_bug.cgi?id=50530

        * WebCore.exp.in: Export Range version of countMatchesForText().
        * editing/Editor.cpp:
        (WebCore::isFrameInRange): Added this helper method.
        (WebCore::Editor::countMatchesForText): Added a Range parameter and restricted the result to
        matches that occur in the range.
        * editing/Editor.h:

2010-12-04  Gavin Peters  <gavinp@chromium.org>

        Reviewed by Adam Barth.

        Implement onload events for <link rel=prefetch>
        https://bugs.webkit.org/show_bug.cgi?id=50187

        Tests: fast/dom/HTMLLinkElement/link-and-subresource-test.html
               fast/dom/HTMLLinkElement/prefetch-onload.html

        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::HTMLLinkElement):
        (WebCore::HTMLLinkElement::~HTMLLinkElement):
        (WebCore::HTMLLinkElement::parseMappedAttribute):
        (WebCore::HTMLLinkElement::process):
        (WebCore::HTMLLinkElement::onloadTimerFired):
        (WebCore::HTMLLinkElement::notifyFinished):
        * html/HTMLLinkElement.h:
        * loader/cache/CachedResource.cpp:
        (WebCore::CachedResource::data):

2010-12-04  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Drop GdkDrawable usage, it's deprecated in GTK+3.x and we can use GdkWindow
        https://bugs.webkit.org/show_bug.cgi?id=50451

        GdkDrawable has been removed in GTK+3.x. To cope with this we can
        actually stop using it altogether, since GdkWindow is just a
        typedef for it and that seems to be good enough for us.

        * platform/graphics/GraphicsContext.h: s/GdkDrawable/GdkWindow/.
        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::GraphicsContext::gdkWindow): ditto.
        * platform/gtk/GtkVersioning.h: declare GDK_WINDOW_XWINDOW for GTK 3.x builds.
        * platform/gtk/PlatformScreenGtk.cpp:
        (WebCore::screenAvailableRect): s/GdkDrawable/GdkWindow/.
        * platform/gtk/WidgetGtk.cpp:
        (WebCore::gdkWindow): ditto.
        (WebCore::Widget::setCursor): ditto.
        * platform/gtk/WidgetRenderingContextGtk2.cpp: ditto.

2010-12-03  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Darin Adler.

        REGRESSION(r71934): input event fires twice when editing text inside a text input.
        https://bugs.webkit.org/show_bug.cgi?id=50477

        Now that events escape the shadow DOM boundary, the input event is fired twice
        for each input, once triggered by editing, once triggered by value change.

        Test: fast/forms/text-input-event.html

        * dom/InputElement.cpp:
        (WebCore::InputElement::setValueFromRenderer): Added a check to ensure editable fields
            don't fire an extra input event.

2010-12-03  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r73302.
        http://trac.webkit.org/changeset/73302
        https://bugs.webkit.org/show_bug.cgi?id=50499

        Causes crashes in debug LayoutTests (Requested by xan_ on
        #webkit).

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::renderParentObject):
        (WebCore::AccessibilityRenderObject::addChildren):
        * accessibility/AccessibilityRenderObject.h:
        * accessibility/chromium/AccessibilityObjectChromium.cpp:
        (WebCore::AccessibilityObject::accessibilityIgnoreAttachment):

2010-12-01  Ilya Tikhonovsky  <loislo@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: Inspector protocol cleanup task.

        The patch has just small renames and adjustments for the protocol things.
        'handler' keyword in idl file was replaced with 'domain'.
        'domain' property was assigned for the each backend to frontend messages.
        At the next step WebInspector wrapper functions will be removed and 'agents' will be called directly.

        https://bugs.webkit.org/show_bug.cgi?id=50337

        * inspector/CodeGeneratorInspector.pm:
        * inspector/Inspector.idl:
        * inspector/front-end/inspector.js:
        (WebInspector_syncDispatch):

2010-12-03  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: Duplicate "!important" for !important properties displayed in the Styles pane
        https://bugs.webkit.org/show_bug.cgi?id=50460

        * inspector/front-end/StylesSidebarPane.js:
        * inspector/front-end/inspector.css:

2010-12-03  Xan Lopez  <xlopez@igalia.com>

        Unreviewed build fix.

        The JS code generator includes headers unconditionally, so we need
        to generate them unconditionally and disable the feature. The
        WebAudio files hadn't been added to our sources list.

        * GNUmakefile.am:

2010-12-03  Patrick Gansterer  <paroga@webkit.org>

        Unreviewed build fix.

        Try to fix EFL build after r73273.

        * CMakeLists.txt:

2010-12-03  Chris Guillory  <chris.guillory@google.com>

        Reviewed by Chris Fleizach.

        Include the FrameView widget of a RenderWidget in the accessibility tree.
        https://bugs.webkit.org/show_bug.cgi?id=49106

        Include render widget children in the accessibility tree for not mac webkit ports.

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::renderParentObject):
        (WebCore::AccessibilityRenderObject::addChildren):
        (WebCore::AccessibilityRenderObject::addRenderWidgetChildren):
        * accessibility/AccessibilityRenderObject.h:
        * accessibility/chromium/AccessibilityObjectChromium.cpp:
        (WebCore::AccessibilityObject::accessibilityIgnoreAttachment):

2010-11-30  Abhishek Arya  <inferno@chromium.org>

        Reviewed by Dave Hyatt.

        Don't clone an anonymous block, instead create a new one in splitBlocks. Also,
        when beforeChild is not in one of our children, then do the processing first
        to get its anonymous container before calling splitBlocks.
        https://bugs.webkit.org/show_bug.cgi?id=49928

        Tests: fast/multicol/span/anonymous-before-child-parent-crash.html
               fast/multicol/span/anonymous-split-block-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::splitBlocks):
        (WebCore::RenderBlock::addChildIgnoringAnonymousColumnBlocks):

2010-12-03  Mark Rowe  <mrowe@apple.com>

        Reviewed by Eric Seidel.

        Animated GIF animates much more slowly in Safari than Firefox
        <rdar://problem/7689300> / <http://webkit.org/b/26455>

        Adopt Firefox's behavior for frame duration clamping. Images that specify a frame duration
        of <= 10ms are treated as having a frame duration of 100ms, while all other images use the
        frame duration that they specify.

        ImageIO currently implements its own clamping of frame durations (<rdar://problem/7689297>)
        which will result in this change having no observable effect on platforms where it is used
        until an updated version of ImageIO becomes available.

        * platform/graphics/ImageSource.cpp:
        (WebCore::ImageSource::frameDurationAtIndex): Update the formatting of the comment and style
        of the code to match that in ImageSourceCG.
        * platform/graphics/cg/ImageSourceCG.cpp:
        (WebCore::ImageSource::frameDurationAtIndex):

2010-12-03  Chris Rogers  <crogers@google.com>

        Unreviewed build fix.

        Fix M_E compile error on Chromium Win
        https://bugs.webkit.org/show_bug.cgi?id=50479

        * platform/audio/AudioUtilities.cpp:
        (WebCore::AudioUtilities::discreteTimeConstantForSampleRate):

2010-12-03  Chris Rogers  <crogers@google.com>

        Unreviewed build fix.

        Try to fix GTK build due to recent web audio makefile changes (disable ENABLE_WEB_AUDIO explicitly)
        https://bugs.webkit.org/show_bug.cgi?id=50478

        * GNUmakefile.am:

2010-12-03  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dirk Schulze.

        Clean up some text-related code on GraphicsContext
        https://bugs.webkit.org/show_bug.cgi?id=50464

        Save 8 bytes in GraphicsContextState by rearranging the
        data members to reduce padding.

        * platform/graphics/GraphicsContextPrivate.h:
        (WebCore::GraphicsContextState::GraphicsContextState):

2010-12-03  Simon Fraser  <simon.fraser@apple.com>

        Another Chromium build fix.

        * platform/graphics/skia/GraphicsContextSkia.cpp:
        (WebCore::GraphicsContext::setPlatformTextDrawingMode):

2010-12-03  Simon Fraser  <simon.fraser@apple.com>

        Fix Chromium build.

        * platform/graphics/skia/PlatformContextSkia.h:

2010-12-03  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        [CMake] Remove WebCore_IDL_PURE_FILES
        https://bugs.webkit.org/show_bug.cgi?id=50445

        * CMakeLists.txt:

2010-12-03  Jia Pu  <jpu@apple.com>

        Reviewed by Darin Adler.

        Need to move all code that applies correction into correction panel callback.
        https://bugs.webkit.org/show_bug.cgi?id=50426
        <rdar://problem/8720832>

        No new test, since there's no behavioral change.

        This patch is to prepare WebKit to work with upcoming AppKit changes. The main changes are:
        1. Moved all calls to applyCorrectionPanelInfo() into handleCorrectionPanelResult().
        2. Added more user dictionary learning code.
        3. Removed m_ prefix in all member variables of CorrectionPanelInfo.

        * editing/CorrectionPanelInfo.h: Remove m_ prefix on member variables. Added ReasonForDismissingCorrectionPanel enum type.

        * editing/Editor.cpp: Moved all calls to applyCorrectionPanelInfo() into handleCorrectionPanelResult().
          Adopted new member variable naming in class CorrectionPanelInfo.
        (WebCore::Editor::respondToChangedSelection):
        (WebCore::Editor::~Editor):
        (WebCore::Editor::markMisspellingsAfterTypingToWord):
        (WebCore::Editor::markAllMisspellingsAndBadGrammarInRanges):
        (WebCore::Editor::correctionPanelTimerFired):
        (WebCore::Editor::handleCorrectionPanelResult):
        (WebCore::Editor::startCorrectionPanelTimer):
        (WebCore::Editor::stopCorrectionPanelTimer):
        (WebCore::Editor::handleCancelOperation):
        (WebCore::Editor::dismissCorrectionPanel):
        (WebCore::Editor::applyCorrectionPanelInfo):

        * editing/Editor.h: Changed signature of dismissCorrectionPanel to use ReasonForDismissingCorrectionPanel.

        * loader/EmptyClients.h: Ditto.
        (WebCore::EmptyEditorClient::dismissCorrectionPanel):

        * page/EditorClient.h: Ditto.

2010-12-03  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: reveal in elements panel does not switch the panel itself.
        https://bugs.webkit.org/show_bug.cgi?id=50408

        * inspector/front-end/ElementsTreeOutline.js:
        (WebInspector.ElementsTreeOutline.prototype._contextMenuEventFired.focusElement):
        (WebInspector.ElementsTreeOutline.prototype._contextMenuEventFired):
        * inspector/front-end/ObjectPropertiesSection.js:
        (WebInspector.ObjectPropertyTreeElement.prototype._contextMenuEventFired):

2010-12-03  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Nikolas Zimmermann.

        Clean up some text-related code on GraphicsContext
        https://bugs.webkit.org/show_bug.cgi?id=50464

        Use defined types for textDrawingMode and it's associated flags.

        * html/canvas/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::drawTextInternal):
        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContext::textDrawingMode):
        (WebCore::GraphicsContext::setTextDrawingMode):
        (WebCore::GraphicsContext::setPlatformTextDrawingMode):
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/GraphicsContextPrivate.h:
        (WebCore::GraphicsContextState::GraphicsContextState):
        * platform/graphics/cairo/FontCairo.cpp:
        (WebCore::drawGlyphsShadow):
        (WebCore::Font::drawGlyphs):
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::setPlatformTextDrawingMode):
        * platform/graphics/chromium/FontLinux.cpp:
        (WebCore::Font::drawGlyphs):
        (WebCore::Font::drawComplexText):
        * platform/graphics/gtk/FontGtk.cpp:
        (WebCore::drawGlyphsShadow):
        (WebCore::Font::drawComplexText):
        * platform/graphics/mac/FontMac.mm:
        (WebCore::Font::drawGlyphs):
        * platform/graphics/openvg/PainterOpenVG.cpp:
        (WebCore::PlatformPainterState::PlatformPainterState):
        (WebCore::PainterOpenVG::textDrawingMode):
        (WebCore::PainterOpenVG::setTextDrawingMode):
        (WebCore::PainterOpenVG::drawText):
        * platform/graphics/qt/FontQt.cpp:
        (WebCore::drawTextCommon):
        * platform/graphics/skia/PlatformContextSkia.cpp:
        (WebCore::PlatformContextSkia::State::State):
        (WebCore::PlatformContextSkia::getTextDrawingMode):
        (WebCore::PlatformContextSkia::setTextDrawingMode):
        * platform/graphics/skia/SkiaFontWin.cpp:
        (WebCore::windowsCanHandleTextDrawing):
        (WebCore::paintSkiaText):
        * platform/graphics/texmap/TextureMapper.h:
        (WebCore::TextureMapper::setTextDrawingMode):
        (WebCore::TextureMapper::textDrawingMode):
        (WebCore::TextureMapper::TextureMapper):
        * platform/graphics/win/FontCGWin.cpp:
        (WebCore::drawGDIGlyphs):
        (WebCore::Font::drawGlyphs):
        * platform/graphics/wince/GraphicsContextWinCE.cpp:
        (WebCore::GraphicsContext::drawText):
        * rendering/InlineTextBox.cpp:
        (WebCore::updateGraphicsContext):
        * rendering/RenderSVGResourceGradient.cpp:
        (WebCore::RenderSVGResourceGradient::applyResource):
        * rendering/RenderSVGResourcePattern.cpp:
        (WebCore::RenderSVGResourcePattern::applyResource):
        * rendering/RenderSVGResourceSolidColor.cpp:
        (WebCore::RenderSVGResourceSolidColor::applyResource):
        * svg/SVGFont.cpp:
        (WebCore::Font::drawTextUsingSVGFont):

2010-12-03  Chris Rogers  <crogers@google.com>

        Reviewed by Kenneth Russell.

        First steps to adding web audio files to build systems
        https://bugs.webkit.org/show_bug.cgi?id=49952

        No new tests since audio API is not yet implemented.

        * CMakeLists.txt:
        * DerivedSources.make:
        * ForwardingHeaders/wtf/Complex.h: Added.
        * GNUmakefile.am:
        * WebCore.gyp/WebCore.gyp:
        * WebCore.gypi:
        * WebCore.pri:
        * WebCore.pro:
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::audioContext):
        * features.pri:
        * page/DOMWindow.idl:
        * platform/audio/HRTFElevation.cpp:

2010-12-03  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by David Levin.

        Use String::adopt in TextCodecWinCE::decode
        https://bugs.webkit.org/show_bug.cgi?id=50319

        * platform/text/wince/TextCodecWinCE.cpp:
        (WebCore::TextCodecWinCE::decode):

2010-12-03  Brady Eidson  <beidson@apple.com>

        Reviewed by Anders Carlsson.

        Groundwork for <rdar://problem/7660733> and https://bugs.webkit.org/show_bug.cgi?id=50191
        WebKit2 Authentication Support

        * WebCore.exp.in:

        Expose the AuthenticationClient for WK2 platforms (Windows already does this):
        * platform/network/mac/AuthenticationChallenge.h:
        * platform/network/mac/AuthenticationMac.mm:
        (-[WebCoreAuthenticationClientAsChallengeSender client]):
        (WebCore::AuthenticationChallenge::authenticationClient):

        * platform/network/qt/AuthenticationChallenge.h:
        (WebCore::AuthenticationChallenge::authenticationClient):

2010-12-03  Ryosuke Niwa  <rniwa@webkit.org>

        Reviewed by Darin Adler.

        REGRESSION: Crash when deleting text after textarea's value is modified on input event
        https://bugs.webkit.org/show_bug.cgi?id=49962

        The crash was caused by TypingCommand::deleteKeyPressed's reusing a typing command for
        textarea's shadow DOM after its input event handler rewrote the value set by the typing command.
        Because the reused typing command's ending selection was pointing at a shadow node
        that has been detached from the document when the event handler set the new value,
        rootEditableElement of the ending selection was null and caused the crash.

        Fixed the bug by updating the ending selection of the last typing command when it differsfrom
        that of the current selection held by the SelectionController in TypingCommand::deleteKeyPressed.
        Also fixed similar bugs in forwardDeleteKeyPressed and insertText, and insertTextRunWithoutNewlines.

        Tests: editing/input/set-value-on-input-and-delete.html
               editing/input/set-value-on-input-and-forward-delete.html
               editing/input/set-value-on-input-and-type-input.html
               editing/input/set-value-on-input-and-type-textarea.html

        * editing/InsertTextCommand.h: Added TypingCommand as a friend because it needs to update selection.
        * editing/TypingCommand.cpp:
        (WebCore::TypingCommand::deleteKeyPressed): Updates the last typing command's selection as needed.
        (WebCore::TypingCommand::forwardDeleteKeyPressed): Ditto.
        (WebCore::TypingCommand::insertText): Ditto.
        (WebCore::TypingCommand::updateSelectionIfDifferentFromCurrentSelection): Added.
        (WebCore::TypingCommand::insertTextRunWithoutNewlines): Updates InsertTextCommand's selection as needed.
        * editing/TypingCommand.h:

2010-12-03  Daniel Cheng  <dcheng@chromium.org>

        Reviewed by Tony Chang.

        Dragging and dropping into an empty document crashes WebKit.
        https://bugs.webkit.org/show_bug.cgi?id=48793

        Remove the assert and update callers to check for a null return value.

        Test: manual-tests/drop-in-empty-doc.html

        * manual-tests/drop-in-empty-doc.html: Added.
        * manual-tests/resources/drop-in-empty-doc.xhtml: Added.
        * page/DragController.cpp:
        (WebCore::elementUnderMouse):
        (WebCore::DragController::tryDocumentDrag):
        (WebCore::DragController::concludeEditDrag):

2010-12-03  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        Move Inspector generator logic into main CMakeLists.txt file
        https://bugs.webkit.org/show_bug.cgi?id=50445

        * CMakeLists.txt:

2010-12-03 Patrick Gansterer <paroga@webkit.org>

        Reviewed by Andreas Kling.

        Move StringWx.cpp into wtf directory
        https://bugs.webkit.org/show_bug.cgi?id=50060

        * WebCore.gypi:
        * platform/text/wx/StringWx.cpp: Removed.

2010-12-03  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Darin Adler.

        REGRESSION(r72783): DOMActivate fires multiple times from input type=file
        https://bugs.webkit.org/show_bug.cgi?id=50396

        Test: fast/events/shadow-boundary-crossing-2.html

        * dom/EventContext.cpp: Reverted changes made in r72783.
        * dom/EventContext.h: Ditto.
        * dom/Node.cpp:
        (WebCore::Node::containsIncludingShadowDOM): Added.
        (WebCore::Node::dispatchGenericEvent): Reverted changes made in r72783.
        * dom/Node.h: Added decl.
        * html/HTMLLabelElement.cpp:
        (WebCore::HTMLLabelElement::defaultEventHandler): Reverted changes made in r72783.

2010-12-03  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        Move StringBrew.cpp into wtf directory
        https://bugs.webkit.org/show_bug.cgi?id=50058

        * platform/text/brew/StringBrew.cpp: Removed.

2010-12-03  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        Move StringHaiku.cpp into wtf directory
        https://bugs.webkit.org/show_bug.cgi?id=50057

        * platform/text/haiku/StringHaiku.cpp: Removed.

2010-12-03  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Sam Weinig.

        Need a WebKit2 Equivalent of WebSecurityOrigin
        https://bugs.webkit.org/show_bug.cgi?id=50170

        * WebCore.exp.in:
        Export the symbol for SecurityOrigin::createFromDatabaseIdentifier.

2010-12-03  Andras Becsi  <abecsi@inf.u-szeged.hu>

        Unreviewed build fix after r73254.

        [Qt][V8] Add missing headers to $headerIncludes rather than $implIncludes
        because headers are needed by the generated .h files.

        No new tests needed.

        * bindings/scripts/CodeGeneratorV8.pm:

2010-12-03  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Dirk Schulze.

        1336 files in WebCore rebuild when you touch SVGNames
        https://bugs.webkit.org/show_bug.cgi?id=42025

        Remove global SVGNames.h dependency, as SVGAnimatedPropertyMacros.h included it.
        This requires to add the SVGNames.h include to lots of cpp files.

        No functional changes, thus no new tests.

        * css/CSSCursorImageValue.cpp:
        * css/CSSFontFaceSource.cpp:
        * dom/Node.cpp:
        * loader/cache/CachedFont.cpp:
        * rendering/RenderSVGResourceClipper.cpp:
        * rendering/RenderSVGResourceFilter.cpp:
        * rendering/RenderSVGTransformableContainer.cpp:
        * rendering/RenderSVGViewportContainer.cpp:
        * rendering/SVGRenderTreeAsText.cpp:
        * rendering/SVGResources.cpp:
        * rendering/svg/RenderSVGTextPath.cpp:
        * rendering/svg/SVGRootInlineBox.cpp:
        * svg/SVGAnimateElement.cpp:
        * svg/SVGAnimateMotionElement.cpp:
        * svg/SVGAnimateTransformElement.cpp:
        * svg/SVGDefsElement.cpp:
        * svg/SVGFEBlendElement.cpp:
        * svg/SVGFEDisplacementMapElement.cpp:
        * svg/SVGFEMergeElement.cpp:
        * svg/SVGFEMergeNodeElement.cpp:
        * svg/SVGFEOffsetElement.cpp:
        * svg/SVGFETileElement.cpp:
        * svg/SVGFETurbulenceElement.cpp:
        * svg/SVGFont.cpp:
        * svg/SVGGElement.cpp:
        * svg/SVGImageElement.cpp:
        * svg/SVGLength.cpp:
        * svg/SVGMPathElement.cpp:
        * svg/SVGPathElement.cpp:
        * svg/SVGPathSegList.cpp:
        * svg/SVGStyledTransformableElement.cpp:
        * svg/SVGSymbolElement.cpp:
        * svg/SVGTextContentElement.cpp:
        * svg/SVGTextElement.cpp:
        * svg/SVGTextPathElement.cpp:
        * svg/SVGUseElement.cpp:
        * svg/SVGViewSpec.cpp:
        * svg/animation/SMILTimeContainer.cpp:
        * svg/properties/SVGAnimatedPropertyMacros.h:
        * svg/properties/SVGPathSegListPropertyTearOff.cpp:

2010-12-02  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Martin Robinson.

        [GStreamer] hasVideo/Audio return false until the pipeline reaches PAUSED
        https://bugs.webkit.org/show_bug.cgi?id=50382

        Go to PAUSED even if preload is deactivated. In that case don't
        process the GStreamer state changes until commitLoad() has been
        called. This patch also fixes hasVideo and hasAudio methods,
        making them reactive to the playbin2 audio/video tags-changed
        signals.

        Test: media/controls-without-preload.html

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::mediaPlayerPrivateMessageCallback):
        (WebCore::mediaPlayerPrivateVideoTagsChangedCallback):
        (WebCore::mediaPlayerPrivateAudioTagsChangedCallback):
        (WebCore::mediaPlayerPrivateAudioTagsChangeTimeoutCallback):
        (WebCore::mediaPlayerPrivateVideoTagsChangeTimeoutCallback):
        (WebCore::MediaPlayerPrivateGStreamer::MediaPlayerPrivateGStreamer):
        (WebCore::MediaPlayerPrivateGStreamer::~MediaPlayerPrivateGStreamer):
        (WebCore::MediaPlayerPrivateGStreamer::load):
        (WebCore::MediaPlayerPrivateGStreamer::commitLoad):
        (WebCore::MediaPlayerPrivateGStreamer::videoTagsChanged):
        (WebCore::MediaPlayerPrivateGStreamer::notifyPlayerOfVideoTags):
        (WebCore::MediaPlayerPrivateGStreamer::audioTagsChanged):
        (WebCore::MediaPlayerPrivateGStreamer::notifyPlayerOfAudioTags):
        (WebCore::MediaPlayerPrivateGStreamer::createGSTPlayBin):
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.h:
        (WebCore::MediaPlayerPrivateGStreamer::hasVideo):
        (WebCore::MediaPlayerPrivateGStreamer::hasAudio):
        (WebCore::MediaPlayerPrivateGStreamer::loadDelayed):

2010-12-03  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Dirk Schulze.

        Finish splitting DECLARE_ANIMATED_PROPERTY* in DECLARE/DEFINE parts for the remaining SVGAnimated* types
        https://bugs.webkit.org/show_bug.cgi?id=50440

        Continuing the work on bug 42025: Introduce (DECLARE|DEFINE)_ANIMATED_(ANGLE|BOOLEAN|INTEGER|PRESERVEASPECTRATIO|RECT).
        The animated property declaration lives in the header, the definition in the cpp file, to avoid the dependency on SVGNames.h in all headers.

        No functional changes, thus no new tests.

        * svg/SVGAElement.cpp:
        * svg/SVGAElement.h:
        * svg/SVGAnimatedAngle.h:
        * svg/SVGAnimatedBoolean.h:
        * svg/SVGAnimatedInteger.h:
        * svg/SVGAnimatedPreserveAspectRatio.h:
        * svg/SVGAnimatedRect.h:
        * svg/SVGAnimationElement.cpp:
        * svg/SVGAnimationElement.h:
        (WebCore::SVGAnimationElement::calculateDistance):
        (WebCore::SVGAnimationElement::animationPath):
        * svg/SVGCircleElement.cpp:
        * svg/SVGCircleElement.h:
        * svg/SVGClipPathElement.cpp:
        * svg/SVGClipPathElement.h:
        * svg/SVGCursorElement.cpp:
        * svg/SVGCursorElement.h:
        * svg/SVGDefsElement.cpp:
        * svg/SVGDefsElement.h:
        * svg/SVGEllipseElement.cpp:
        * svg/SVGEllipseElement.h:
        * svg/SVGFEConvolveMatrixElement.cpp:
        * svg/SVGFEConvolveMatrixElement.h:
        * svg/SVGFEImageElement.cpp:
        * svg/SVGFEImageElement.h:
        * svg/SVGFETurbulenceElement.cpp:
        * svg/SVGFETurbulenceElement.h:
        * svg/SVGFilterElement.cpp:
        * svg/SVGFilterElement.h:
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/SVGFontElement.cpp:
        (WebCore::SVGFontElement::firstMissingGlyphElement):
        (WebCore::SVGFontElement::ensureGlyphCache):
        * svg/SVGFontElement.h:
        * svg/SVGForeignObjectElement.cpp:
        * svg/SVGForeignObjectElement.h:
        * svg/SVGGElement.cpp:
        * svg/SVGGElement.h:
        (WebCore::SVGGElement::isShadowTreeContainerElement):
        (WebCore::SVGGElement::isValid):
        * svg/SVGGradientElement.cpp:
        * svg/SVGGradientElement.h:
        * svg/SVGImageElement.cpp:
        * svg/SVGImageElement.h:
        * svg/SVGLineElement.cpp:
        * svg/SVGLineElement.h:
        * svg/SVGLinearGradientElement.h:
        * svg/SVGMPathElement.cpp:
        * svg/SVGMPathElement.h:
        * svg/SVGMarkerElement.cpp:
        * svg/SVGMarkerElement.h:
        * svg/SVGMaskElement.cpp:
        * svg/SVGMaskElement.h:
        * svg/SVGPathElement.cpp:
        * svg/SVGPathElement.h:
        * svg/SVGPatternElement.cpp:
        * svg/SVGPatternElement.h:
        * svg/SVGPolyElement.cpp:
        * svg/SVGPolyElement.h:
        * svg/SVGRadialGradientElement.h:
        * svg/SVGRectElement.cpp:
        * svg/SVGRectElement.h:
        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::contentScriptType):
        (WebCore::SVGSVGElement::contentStyleType):
        (WebCore::SVGSVGElement::parseMappedAttribute):
        * svg/SVGSVGElement.h:
        * svg/SVGScriptElement.cpp:
        * svg/SVGScriptElement.h:
        * svg/SVGSwitchElement.cpp:
        * svg/SVGSwitchElement.h:
        (WebCore::SVGSwitchElement::isValid):
        * svg/SVGSymbolElement.cpp:
        * svg/SVGSymbolElement.h:
        (WebCore::SVGSymbolElement::rendererIsNeeded):
        * svg/SVGTextContentElement.cpp:
        * svg/SVGTextContentElement.h:
        * svg/SVGUseElement.cpp:
        * svg/SVGUseElement.h:
        * svg/SVGViewElement.cpp:
        * svg/SVGViewElement.h:
        (WebCore::SVGViewElement::viewTarget):
        (WebCore::SVGViewElement::rendererIsNeeded):
        * svg/SVGViewSpec.cpp:
        * svg/SVGViewSpec.h:
        (WebCore::SVGViewSpec::transform):
        (WebCore::SVGViewSpec::viewTargetString):
        (WebCore::SVGViewSpec::contextElement):
        * svg/properties/SVGAnimatedPropertyMacros.h:

2010-12-03  Noel Gordon  <noel.gordon@gmail.com>

        Reviewed by Darin Fisher.

        [chromium] PNG encoder leaks memory on png_write_row errors.
        https://bugs.webkit.org/show_bug.cgi?id=50439

        Move the creation of needed C++ objects before the setjmp() point so
        those objects have their destructors called if libpng errors invoke
        the setjmp() return path.
   
        Other minor cleanup: use the skia bitmap locker class, and remove the
        PNGDestroyer class - instead directly call png_destroy_write_struct()
        at each of the encodeImpl() return points.

        No change in behaviour, so no new tests.

        * platform/image-encoders/skia/PNGImageEncoder.cpp:
        (WebCore::encodeImpl):
        (WebCore::PNGImageEncoder::encode):

2010-12-02  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Eric Carlson.

        Theme not updated when MediaPlayer m_private engine changes
        https://bugs.webkit.org/show_bug.cgi?id=50228

        Trigger a new rendering of the media element when the private
        media-player backend is updated.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::mediaPlayerEngineUpdated):
        * html/HTMLMediaElement.h:
        * platform/graphics/MediaPlayer.cpp:
        (WebCore::MediaPlayer::MediaPlayer):
        (WebCore::MediaPlayer::load):
        * platform/graphics/MediaPlayer.h:
        (WebCore::MediaPlayerClient::mediaPlayerEngineUpdated):

2010-12-03  Yonathan Randolph  <yonathan@gmail.com>

        Reviewed by Alexey Proskuryakov.

        XPath lexer misinterprets expression starting with "div".
        https://bugs.webkit.org/show_bug.cgi?id=50366

        * xml/XPathParser.cpp:
        * xml/XPathParser.h:
        (WebCore::XPath::Parser::isOperatorContext): removed (renamed)
        (WebCore::XPath::Parser::isBinaryOperatorContext): added

2010-12-02  Rob Buis  <rwlbuis@gmail.com>

        Reviewed by Alexey Proskuryakov.

        CSS 2.1 failure: at-import-*
        https://bugs.webkit.org/show_bug.cgi?id=47153

        Fix at-import-010.htm by only setting m_allowImportRules
        to false when creating valid style or page rules.
 
         Test: css2.1/t040105-import-10-b.html

        * css/CSSParser.cpp:
        (WebCore::CSSParser::createStyleRule):

2010-12-02  Aaron Boodman  <aa@chromium.org>

        Reviewed by David Hyatt.

        Reduce the number of cases where we end up with a stale value for
        minimumPreferredLogicalWidth(). This isn't a complete fix, but fixes a
        large number of cases.

        RenderObject::minimumPreferredLogicalWidth() sometimes reports wrong value.
        https://bugs.webkit.org/show_bug.cgi?id=50119

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::styleDidChange):

2010-12-02  Gregg Tavares  <gman@google.com>

        Reviewed by David Levin.

        Need to initialize destination variables before calling GL
        https://bugs.webkit.org/show_bug.cgi?id=50048

        No new tests because no change in functionality.

        * html/canvas/WebGLFramebuffer.cpp:
        (WebCore::WebGLFramebuffer::initializeRenderbuffers):
        * html/canvas/WebGLProgram.cpp:
        (WebCore::WebGLProgram::cacheActiveAttribLocations):
        * html/canvas/WebGLRenderingContext.cpp:
        (WebCore::WebGLRenderingContext::getAttachedShaders):
        (WebCore::WebGLRenderingContext::getBufferParameter):
        (WebCore::WebGLRenderingContext::getFramebufferAttachmentParameter):
        (WebCore::WebGLRenderingContext::getBooleanParameter):
        (WebCore::WebGLRenderingContext::getFloatParameter):
        (WebCore::WebGLRenderingContext::getLongParameter):
        (WebCore::WebGLRenderingContext::getUnsignedLongParameter):
        * platform/graphics/chromium/LayerChromium.cpp:
        (WebCore::loadShader):
        (WebCore::LayerChromium::createShaderProgram):
        * platform/graphics/chromium/LayerRendererChromium.cpp:
        (WebCore::LayerRendererChromium::initializeSharedObjects):
        * platform/graphics/gpu/DrawingBuffer.cpp:
        (WebCore::DrawingBuffer::reset):
        * platform/graphics/gpu/Shader.cpp:
        (WebCore::Shader::loadProgram):

2010-12-02  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Reviewed by Andreas Kling.

        [Qt] Enable Web Timing for Qt
        https://bugs.webkit.org/show_bug.cgi?id=42433

        * features.pri: Enable Web Timing for trunk (but not yet for
          production)

2010-12-02  Andy Estes  <aestes@apple.com>

        Rubber-stamped by Mark Rowe.

        Update bindings test results with new GObject results.

        * bindings/scripts/test/GObject/WebKitDOMTestCallback.cpp:
        (WebKit::kit):
        * bindings/scripts/test/GObject/WebKitDOMTestCallbackPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestInterface.cpp:
        (WebKit::kit):
        * bindings/scripts/test/GObject/WebKitDOMTestInterfacePrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestMediaQueryListListener.cpp:
        (WebKit::kit):
        * bindings/scripts/test/GObject/WebKitDOMTestMediaQueryListListenerPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestObj.cpp:
        (WebKit::kit):
        (webkit_dom_test_obj_obj_method):
        (webkit_dom_test_obj_obj_method_with_args):
        (webkit_dom_test_obj_method_that_requires_all_args):
        (webkit_dom_test_obj_method_that_requires_all_args_and_throws):
        (webkit_dom_test_obj_with_script_state_obj):
        (webkit_dom_test_obj_with_script_state_obj_exception):
        (webkit_dom_test_obj_get_read_only_test_obj_attr):
        (webkit_dom_test_obj_get_test_obj_attr):
        (webkit_dom_test_obj_get_xml_obj_attr):
        * bindings/scripts/test/GObject/WebKitDOMTestObjPrivate.h:

2010-12-02  Simon Fraser  <simon.fraser@apple.com>

        Revert r73217 and r73227 because of continued bustage.

        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/GraphicsLayer.h:
        (WebCore::GraphicsLayer::nativeLayer):
        * platform/graphics/ca/PlatformCAAnimation.h: Removed.
        * platform/graphics/ca/PlatformCALayer.h: Removed.
        * platform/graphics/ca/mac/PlatformCAAnimationMac.mm: Removed.
        * platform/graphics/ca/mac/PlatformCALayerMac.mm: Removed.
        * platform/graphics/chromium/GraphicsLayerChromium.cpp:
        (WebCore::GraphicsLayerChromium::nativeLayer):
        * platform/graphics/chromium/GraphicsLayerChromium.h:
        * platform/graphics/mac/GraphicsLayerMac.h: Renamed from WebCore/platform/graphics/ca/GraphicsLayerCA.h.
        (WebCore::GraphicsLayerMac::hasContentsLayer):
        (WebCore::GraphicsLayerMac::primaryLayer):
        (WebCore::GraphicsLayerMac::isReplicatedRootClone):
        (WebCore::GraphicsLayerMac::primaryLayerClones):
        (WebCore::GraphicsLayerMac::animationIsRunning):
        (WebCore::GraphicsLayerMac::contentsLayer):
        (WebCore::GraphicsLayerMac::ReplicaState::ReplicaState):
        (WebCore::GraphicsLayerMac::ReplicaState::push):
        (WebCore::GraphicsLayerMac::ReplicaState::setBranchType):
        (WebCore::GraphicsLayerMac::ReplicaState::pop):
        (WebCore::GraphicsLayerMac::ReplicaState::depth):
        (WebCore::GraphicsLayerMac::ReplicaState::replicaDepth):
        (WebCore::GraphicsLayerMac::hasCloneLayers):
        (WebCore::GraphicsLayerMac::LayerPropertyAnimation::LayerPropertyAnimation):
        (WebCore::GraphicsLayerMac::AnimationProcessingAction::AnimationProcessingAction):
        * platform/graphics/mac/GraphicsLayerMac.mm: Renamed from WebCore/platform/graphics/ca/GraphicsLayerCA.cpp.
        (WebCore::currentTimeToMediaTime):
        (WebCore::mediaTimeToCurrentTime):
        (-[WebAnimationDelegate animationDidStart:]):
        (-[WebAnimationDelegate WebCore::]):
        (-[WebAnimationDelegate setLayer:WebCore::]):
        (WebCore::copyTransform):
        (WebCore::getTransformFunctionValue):
        (WebCore::getValueFunctionNameForTransformOperation):
        (WebCore::propertyIdToString):
        (WebCore::animationIdentifier):
        (WebCore::getCAMediaTimingFunction):
        (WebCore::setLayerBorderColor):
        (WebCore::clearBorderColor):
        (WebCore::setLayerBackgroundColor):
        (WebCore::clearLayerBackgroundColor):
        (WebCore::safeSetSublayers):
        (WebCore::caValueFunctionSupported):
        (WebCore::forceSoftwareAnimation):
        (WebCore::nullActionsDictionary):
        (WebCore::animationHasStepsTimingFunction):
        (WebCore::GraphicsLayer::create):
        (WebCore::GraphicsLayerMac::GraphicsLayerMac):
        (WebCore::GraphicsLayerMac::~GraphicsLayerMac):
        (WebCore::GraphicsLayerMac::setName):
        (WebCore::GraphicsLayerMac::nativeLayer):
        (WebCore::GraphicsLayerMac::setChildren):
        (WebCore::GraphicsLayerMac::addChild):
        (WebCore::GraphicsLayerMac::addChildAtIndex):
        (WebCore::GraphicsLayerMac::addChildBelow):
        (WebCore::GraphicsLayerMac::addChildAbove):
        (WebCore::GraphicsLayerMac::replaceChild):
        (WebCore::GraphicsLayerMac::removeFromParent):
        (WebCore::GraphicsLayerMac::setMaskLayer):
        (WebCore::GraphicsLayerMac::setReplicatedLayer):
        (WebCore::GraphicsLayerMac::setReplicatedByLayer):
        (WebCore::GraphicsLayerMac::setPosition):
        (WebCore::GraphicsLayerMac::setAnchorPoint):
        (WebCore::GraphicsLayerMac::setSize):
        (WebCore::GraphicsLayerMac::setTransform):
        (WebCore::GraphicsLayerMac::setChildrenTransform):
        (WebCore::GraphicsLayerMac::moveOrCopyLayerAnimation):
        (WebCore::GraphicsLayerMac::moveOrCopyAnimationsForProperty):
        (WebCore::GraphicsLayerMac::setPreserves3D):
        (WebCore::GraphicsLayerMac::setMasksToBounds):
        (WebCore::GraphicsLayerMac::setDrawsContent):
        (WebCore::GraphicsLayerMac::setBackgroundColor):
        (WebCore::GraphicsLayerMac::clearBackgroundColor):
        (WebCore::GraphicsLayerMac::setContentsOpaque):
        (WebCore::GraphicsLayerMac::setBackfaceVisibility):
        (WebCore::GraphicsLayerMac::setOpacity):
        (WebCore::GraphicsLayerMac::setNeedsDisplay):
        (WebCore::GraphicsLayerMac::setNeedsDisplayInRect):
        (WebCore::GraphicsLayerMac::setContentsNeedsDisplay):
        (WebCore::GraphicsLayerMac::setContentsRect):
        (WebCore::GraphicsLayerMac::addAnimation):
        (WebCore::GraphicsLayerMac::pauseAnimation):
        (WebCore::GraphicsLayerMac::removeAnimation):
        (WebCore::GraphicsLayerMac::animationDidStart):
        (WebCore::GraphicsLayerMac::setContentsToImage):
        (WebCore::GraphicsLayerMac::setContentsToMedia):
        (WebCore::GraphicsLayerMac::didDisplay):
        (WebCore::GraphicsLayerMac::syncCompositingState):
        (WebCore::GraphicsLayerMac::syncCompositingStateForThisLayerOnly):
        (WebCore::GraphicsLayerMac::recursiveCommitChanges):
        (WebCore::GraphicsLayerMac::commitLayerChangesBeforeSublayers):
        (WebCore::GraphicsLayerMac::commitLayerChangesAfterSublayers):
        (WebCore::GraphicsLayerMac::updateLayerNames):
        (WebCore::GraphicsLayerMac::updateSublayerList):
        (WebCore::GraphicsLayerMac::updateLayerPosition):
        (WebCore::GraphicsLayerMac::updateLayerSize):
        (WebCore::GraphicsLayerMac::updateAnchorPoint):
        (WebCore::GraphicsLayerMac::updateTransform):
        (WebCore::GraphicsLayerMac::updateChildrenTransform):
        (WebCore::GraphicsLayerMac::updateMasksToBounds):
        (WebCore::GraphicsLayerMac::updateContentsOpaque):
        (WebCore::GraphicsLayerMac::updateBackfaceVisibility):
        (WebCore::GraphicsLayerMac::updateStructuralLayer):
        (WebCore::GraphicsLayerMac::ensureStructuralLayer):
        (WebCore::GraphicsLayerMac::structuralLayerPurpose):
        (WebCore::GraphicsLayerMac::updateLayerDrawsContent):
        (WebCore::GraphicsLayerMac::updateLayerBackgroundColor):
        (WebCore::GraphicsLayerMac::updateContentsImage):
        (WebCore::GraphicsLayerMac::updateContentsMediaLayer):
        (WebCore::GraphicsLayerMac::updateContentsCanvasLayer):
        (WebCore::GraphicsLayerMac::updateContentsRect):
        (WebCore::GraphicsLayerMac::updateMaskLayer):
        (WebCore::GraphicsLayerMac::updateReplicatedLayers):
        (WebCore::GraphicsLayerMac::ReplicaState::cloneID):
        (WebCore::GraphicsLayerMac::replicatedLayerRoot):
        (WebCore::GraphicsLayerMac::updateLayerAnimations):
        (WebCore::GraphicsLayerMac::setCAAnimationOnLayer):
        (WebCore::bug7311367Workaround):
        (WebCore::GraphicsLayerMac::removeCAAnimationFromLayer):
        (WebCore::copyAnimationProperties):
        (WebCore::GraphicsLayerMac::pauseCAAnimationOnLayer):
        (WebCore::GraphicsLayerMac::setContentsToCanvas):
        (WebCore::GraphicsLayerMac::repaintLayerDirtyRects):
        (WebCore::GraphicsLayerMac::updateContentsNeedsDisplay):
        (WebCore::GraphicsLayerMac::createAnimationFromKeyframes):
        (WebCore::GraphicsLayerMac::createTransformAnimationsFromKeyframes):
        (WebCore::GraphicsLayerMac::createBasicAnimation):
        (WebCore::GraphicsLayerMac::createKeyframeAnimation):
        (WebCore::GraphicsLayerMac::setupAnimation):
        (WebCore::GraphicsLayerMac::timingFunctionForAnimationValue):
        (WebCore::GraphicsLayerMac::setAnimationEndpoints):
        (WebCore::GraphicsLayerMac::setAnimationKeyframes):
        (WebCore::GraphicsLayerMac::setTransformAnimationEndpoints):
        (WebCore::GraphicsLayerMac::setTransformAnimationKeyframes):
        (WebCore::GraphicsLayerMac::suspendAnimations):
        (WebCore::GraphicsLayerMac::resumeAnimations):
        (WebCore::GraphicsLayerMac::hostLayerForSublayers):
        (WebCore::GraphicsLayerMac::layerForSuperlayer):
        (WebCore::GraphicsLayerMac::animatedLayer):
        (WebCore::GraphicsLayerMac::animatedLayerClones):
        (WebCore::GraphicsLayerMac::platformLayer):
        (WebCore::GraphicsLayerMac::setDebugBackgroundColor):
        (WebCore::GraphicsLayerMac::setDebugBorder):
        (WebCore::GraphicsLayerMac::constrainedSize):
        (WebCore::GraphicsLayerMac::requiresTiledLayer):
        (WebCore::GraphicsLayerMac::swapFromOrToTiledLayer):
        (WebCore::GraphicsLayerMac::defaultContentsOrientation):
        (WebCore::GraphicsLayerMac::updateContentsTransform):
        (WebCore::GraphicsLayerMac::setupContentsLayer):
        (WebCore::GraphicsLayerMac::findOrMakeClone):
        (WebCore::GraphicsLayerMac::ensureCloneLayers):
        (WebCore::GraphicsLayerMac::removeCloneLayers):
        (WebCore::GraphicsLayerMac::positionForCloneRootLayer):
        (WebCore::GraphicsLayerMac::propagateLayerChangeToReplicas):
        (WebCore::GraphicsLayerMac::fetchCloneLayers):
        (WebCore::GraphicsLayerMac::cloneLayer):
        (WebCore::GraphicsLayerMac::setOpacityInternal):
        (WebCore::GraphicsLayerMac::updateOpacityOnLayer):
        (WebCore::GraphicsLayerMac::noteSublayersChanged):
        (WebCore::GraphicsLayerMac::noteLayerPropertyChanged):
        * platform/graphics/mac/WebLayer.h:
        * platform/graphics/mac/WebLayer.mm:
        (-[WebLayer initWithLayer:]):
        (-[WebLayer setNeedsDisplay]):
        (-[WebLayer setNeedsDisplayInRect:]):
        (-[WebLayer display]):
        (-[WebLayer drawInContext:]):
        (-[WebLayer setLayerOwner:]):
        (-[WebLayer layerOwner]):
        * platform/graphics/mac/WebTiledLayer.h:
        * platform/graphics/mac/WebTiledLayer.mm:
        (-[WebTiledLayer initWithLayer:]):
        (-[WebTiledLayer setNeedsDisplay]):
        (-[WebTiledLayer setNeedsDisplayInRect:]):
        (-[WebTiledLayer display]):
        (-[WebTiledLayer drawInContext:]):
        (-[WebTiledLayer setLayerOwner:]):
        (-[WebTiledLayer layerOwner]):
        * platform/graphics/qt/GraphicsLayerQt.cpp:
        (WebCore::GraphicsLayerQtImpl::flushChanges):
        (WebCore::GraphicsLayerQt::nativeLayer):
        * platform/graphics/qt/GraphicsLayerQt.h:
        * platform/graphics/win/GraphicsLayerCACF.cpp:
        (WebCore::GraphicsLayerCACF::nativeLayer):
        * platform/graphics/win/GraphicsLayerCACF.h:

2010-12-02  Noel Gordon  <noel.gordon@gmail.com>

        Reviewed by David Levin.
        [chromium] Remove dead code from PNG encoder
        https://bugs.webkit.org/show_bug.cgi?id=50377

        Also webkit style the PNG encoder files.

        No change in behaviour, so no new tests.

        * platform/image-encoders/skia/PNGImageEncoder.cpp:
        (WebCore::encodeImpl):
        (WebCore::PNGImageEncoder::encode):
        * platform/image-encoders/skia/PNGImageEncoder.h:

2010-12-02  Yuta Kitamura  <yutak@chromium.org>

        Reviewed by Alexey Proskuryakov.

        An attempt to fix Chromium's clang build.

        Implement (non-EventListener) marquee IDL attributes from HTML5.
        https://bugs.webkit.org/show_bug.cgi?id=49786

        * rendering/style/RenderStyle.h:
        (WebCore::InheritedFlags::initialMarqueeSpeed):

2010-12-02  Mikhail Naganov  <mnaganov@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: Fix heap snapshots loading. Loading is now
        conducted by the Profiles panel which prevents accidental
        simultaneous attempts to load the same profile several times in
        parallel.

        https://bugs.webkit.org/show_bug.cgi?id=50427

        * inspector/front-end/HeapSnapshotView.js:
        (WebInspector.HeapSnapshotView.prototype._loadProfile):
        (WebInspector.HeapSnapshotView.prototype.processLoadedSnapshot):
        * inspector/front-end/ProfilesPanel.js:
        (WebInspector.ProfilesPanel.prototype.loadHeapSnapshot):
        (WebInspector.ProfilesPanel.prototype.addHeapSnapshotChunk):
        (WebInspector.ProfilesPanel.prototype.finishHeapSnapshot):

2010-12-02  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Simon Fraser.

        Fix Leopard build broken by http://trac.webkit.org/changeset/73217

        * platform/graphics/ca/GraphicsLayerCA.cpp:
        (WebCore::getTransformFunctionValue):
        (WebCore::GraphicsLayerCA::updateContentsTransform):
        * platform/graphics/ca/PlatformCALayer.h:
        * platform/graphics/ca/mac/PlatformCAAnimationMac.mm:
        (PlatformCAAnimation::valueFunction):
        (PlatformCAAnimation::setValueFunction):
        * platform/graphics/ca/mac/PlatformCALayerMac.mm:
        (PlatformCALayer::PlatformCALayer):
        (PlatformCALayer::anchorPoint):
        (PlatformCALayer::setAnchorPoint):
        (PlatformCALayer::contentsTransform):
        (PlatformCALayer::setContentsTransform):
        (PlatformCALayer::isGeometryFlipped):
        (PlatformCALayer::setGeometryFlipped):
        (PlatformCALayer::setMinificationFilter):
        (PlatformCALayer::setMagnificationFilter):

2010-12-02  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        CSS support for the text-emphasis properties
        Part of <rdar://problem/7720300> Support the CSS3 text-emphasis property
        https://bugs.webkit.org/show_bug.cgi?id=48539

        Test: fast/css/parsing-text-emphasis.html

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue): Added text-emphasis-color,
        text-emphasis-position and text-emphasis-style. Left the text-emphasis shorthand unsupported.
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue): Parse the properties.
        (WebCore::CSSParser::parseTextEmphasisStyle): Added.
        * css/CSSParser.h:
        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue): Added TextEmphasisPosition, TextEmphasisFill
        and TextEmphasisMark mappings.
        (WebCore::CSSPrimitiveValue::operator TextEmphasisPosition): Added.
        (WebCore::CSSPrimitiveValue::operator TextEmphasisFill): Added.
        (WebCore::CSSPrimitiveValue::operator TextEmphasisMark): Added.
        * css/CSSPropertyLonghand.cpp:
        (WebCore::initShorthandMap): Added the text-emphasis shorthand.
        * css/CSSPropertyNames.in: Added -webkit-text-emphasis, -webkit-text-emphasis-color,
        -webkit-text-emphasis-position, and -webkit-text-emphasis-style.
        * css/CSSStyleSelector.cpp:
        (WebCore::isValidVisitedLinkProperty): Added text-emphasis-color.
        (WebCore::CSSStyleSelector::applyProperty): Handle the properties.
        * css/CSSValueKeywords.in: Added 'over' and 'under' for text-emphasis-position. Added 'dot',
        'double-circle', 'triangle', 'sesame', 'filled' and 'open' for text-emphasis-style.
        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::colorIncludingFallback): Handle text-emphasis-color.
        (WebCore::RenderStyle::textEmphasisMark): Added. Maps the fake 'auto' value to 'dot' or
        'sesame' based on writing direction.
        * rendering/style/RenderStyle.h: Added accessors.
        (WebCore::InheritedFlags::textEmphasisFill):
        (WebCore::InheritedFlags::textEmphasisCustomMark):
        (WebCore::InheritedFlags::textEmphasisPosition):
        (WebCore::InheritedFlags::setTextEmphasisColor):
        (WebCore::InheritedFlags::setTextEmphasisFill):
        (WebCore::InheritedFlags::setTextEmphasisMark):
        (WebCore::InheritedFlags::setTextEmphasisCustomMark):
        (WebCore::InheritedFlags::setTextEmphasisPosition):
        (WebCore::InheritedFlags::initialTextEmphasisColor):
        (WebCore::InheritedFlags::initialTextEmphasisFill):
        (WebCore::InheritedFlags::initialTextEmphasisMark):
        (WebCore::InheritedFlags::initialTextEmphasisCustomMark):
        (WebCore::InheritedFlags::initialTextEmphasisPosition):
        (WebCore::InheritedFlags::textEmphasisColor):
        * rendering/style/RenderStyleConstants.h:
        * rendering/style/StyleRareInheritedData.cpp:
        (WebCore::StyleRareInheritedData::StyleRareInheritedData):
        (WebCore::StyleRareInheritedData::operator==):
        * rendering/style/StyleRareInheritedData.h:

2010-12-02  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Simon Fraser.

        Share code between Mac (CA) and Windows (CACF) GraphicsLayer implementations
        https://bugs.webkit.org/show_bug.cgi?id=49388

        Replaced GraphicsLayerMac with GraphicsLayerCA. GraphicsLayerCA is essentially 
        identical to GraphicsLayerMac, but replaces all the CoreAnimation specific calls 
        with calls to PlatformCALayer and PlatformCAAnimation. This makes GraphicsLayerCA 
        platform neutral as long as implementations of those two classes are available. 
        Added implementations in PlatformCALayerMac and PlatformCAAnimationMac. Also got 
        rid of GraphicsLayer::nativeLayer() and replaced it with GraphicsLayer::platformLayer() 
        to avoid confusion since both names were used to refer to the same thing. 

        This patch is only for Mac. Windows implementation has not changed.

        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/GraphicsLayer.h:
        * platform/graphics/ca: Added.
        * platform/graphics/ca/GraphicsLayerCA.cpp: Added.
        * platform/graphics/ca/GraphicsLayerCA.h: Added.
        * platform/graphics/ca/PlatformCAAnimation.h: Added.
        * platform/graphics/ca/PlatformCALayer.h: Added.
        * platform/graphics/ca/mac: Added.
        * platform/graphics/ca/mac/PlatformCAAnimationMac.mm: Added.
        * platform/graphics/ca/mac/PlatformCALayerMac.mm: Added.
        * platform/graphics/chromium/GraphicsLayerChromium.cpp:
        * platform/graphics/chromium/GraphicsLayerChromium.h:
        * platform/graphics/mac/GraphicsLayerMac.h: Removed.
        * platform/graphics/mac/GraphicsLayerMac.mm: Removed.
        * platform/graphics/mac/WebLayer.h:
        * platform/graphics/mac/WebLayer.mm:
        * platform/graphics/mac/WebTiledLayer.h:
        * platform/graphics/mac/WebTiledLayer.mm:
        * platform/graphics/qt/GraphicsLayerQt.cpp:
        * platform/graphics/qt/GraphicsLayerQt.h:
        * platform/graphics/win/GraphicsLayerCACF.cpp:
        * platform/graphics/win/GraphicsLayerCACF.h:

2010-12-02  Joseph Pecoraro  <joepeck@webkit.org>

        Reviewed by Darin Adler.

        Update ResourceLoaderSet Enumeration
        https://bugs.webkit.org/show_bug.cgi?id=50405

        Use size_t when working with Vectors and when comparing between size_t types.

        * loader/DocumentLoader.cpp:
        (WebCore::cancelAll):
        (WebCore::setAllDefersLoading):

2010-12-02  Jian Li  <jianli@chromium.org>

        Reviewed by Kenneth Russell.

        Integer calculation issues in DataView constructor
        https://bugs.webkit.org/show_bug.cgi?id=50354

        Test: fast/canvas/webgl/data-view-crash.html

        * html/canvas/DataView.cpp:
        (WebCore::DataView::create):

2010-12-02  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Darin Adler.

        Add AtomicString::fromUTF8
        https://bugs.webkit.org/show_bug.cgi?id=45594

        Use AtomicString::fromUTF8 directly in the libxml2 parser.

        * dom/XMLDocumentParserLibxml2.cpp:
        (WebCore::toAtomicString):

2010-12-02  Andy Estes  <aestes@apple.com>

        Fix the Qt Linux Release minimal build.

        * html/HTMLMarqueeElement.cpp: Include ExceptionCode.h

2010-12-02  Joseph Pecoraro  <joepeck@webkit.org>

        Reviewed by Darin Adler.

        Update ResourceLoaderSet Enumeration
        https://bugs.webkit.org/show_bug.cgi?id=50405

        * loader/DocumentLoader.cpp:
        (WebCore::cancelAll): instead of copying the HashSet, use copyToVector.
        (WebCore::setAllDefersLoading): instead of copying the HashSet, use copyToVector.

2010-12-02  Andy Estes  <aestes@apple.com>

        Reviewed by Darin Adler.

        Implement (non-EventListener) marquee IDL attributes from HTML5.
        https://bugs.webkit.org/show_bug.cgi?id=49786

        Test: fast/html/marquee-element.html

        * html/HTMLMarqueeElement.cpp:
        (WebCore::HTMLMarqueeElement::scrollAmount): If the content attribute
        can be converted to a signed integer and is >= 0, return it.
        Otherwise, return the default scrollAmount value.
        (WebCore::HTMLMarqueeElement::setScrollAmount): Update the content
        attribute if it is >= 0. Otherwise, raise INDEX_SIZE_ERR.
        (WebCore::HTMLMarqueeElement::scrollDelay): Same as scrollAmount.
        (WebCore::HTMLMarqueeElement::setScrollDelay): Same as setScrollAmount.
        (WebCore::HTMLMarqueeElement::loop): If the content attribute can be
        converted to a signed integer and is greater than 0 or equal to -1,
        return it. Otherwise, return the default loop value.
        (WebCore::HTMLMarqueeElement::setLoop): Update the content attribute if
        it is greater than 0 or equal to -1. Otherwise, raise INDEX_SIZE_ERR.
        * html/HTMLMarqueeElement.h:
        * html/HTMLMarqueeElement.idl: Update the IDL to match what is in HTML5.
        * rendering/style/RenderStyle.h:
        (WebCore::InheritedFlags::initialMarqueeSpeed):

2010-12-02  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        [OpenVG] Remove "current path" of GraphicsContext
        https://bugs.webkit.org/show_bug.cgi?id=50294

        * platform/graphics/GraphicsContext.h:
        * platform/graphics/openvg/GraphicsContextOpenVG.cpp:
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::clipPath):
        * platform/graphics/openvg/PainterOpenVG.cpp:
        (WebCore::PainterOpenVG::PainterOpenVG):
        (WebCore::PainterOpenVG::~PainterOpenVG):
        (WebCore::PainterOpenVG::drawPath):
        * platform/graphics/openvg/PainterOpenVG.h:

2010-12-02  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        [WINCE] Remove "current path" of GraphicsContext
        https://bugs.webkit.org/show_bug.cgi?id=50284

        * platform/graphics/GraphicsContext.h:
        * platform/graphics/wince/GraphicsContextWinCE.cpp:
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):

2010-12-02  Johnny Ding  <jnd@chromium.org>

        Reviewed by Adam Barth.

        Set the right gesture status for URL redirections.
        https://bugs.webkit.org/show_bug.cgi?id=47817

        Tests: fast/frames/location-redirect-user-gesture.html
               fast/frames/meta-refresh-user-gesture.html

        * loader/NavigationScheduler.cpp:
        (WebCore::ScheduledNavigation::clearUserGesture):
        (WebCore::ScheduledRedirect::ScheduledRedirect):

2010-12-02  Chris Rogers  <crogers@google.com>

        Reviewed by Kenneth Russell.

        AudioContext needs createBuffer() method from ArrayBuffer
        https://bugs.webkit.org/show_bug.cgi?id=50343

        No new tests since audio API is not yet implemented.

        * webaudio/AudioContext.cpp:
        (WebCore::AudioContext::createBuffer):
        * webaudio/AudioContext.h:
        * webaudio/AudioContext.idl:

2010-12-02  Noel Gordon  <noel.gordon@gmail.com>

        Reviewed by David Levin.

        [chromium] Add canvas.toDataURL("image/jpeg", quality) support
        https://bugs.webkit.org/show_bug.cgi?id=49365

        Adds a libjpeg-based image encoder for Skia bitmaps.  Default encoding quality
        is 92 to match Mozilla, also Safari, though the actual value used by Safari is
        undocumented, and it appears to pre-blur images prior to compression.

        The preMultipliedBGRAtoRGB() routine restores the un-premultiplied RGB colors
        where there is non-zero alpha.  Again, this matches Firefox and Safari, but no
        browser conforms to the HTML5 canvas standard here, I believe, considering the
        result of canvas/philip/tests/toDataURL.jpeg.alpha.html; that test ignores the
        alpha channel when extracting an "image/jpeg".toDataURL().  The correct answer
        needs more investigation, bug http://webkit.org/b/40147.

        Canvas toDataURL is covered by existing tests canvas/philip/tests/toDataURL.*,
        and fast/canvas/*toDataURL* tests.

        * WebCore.gypi:
        * bindings/v8/custom/V8HTMLCanvasElementCustom.cpp:
        (WebCore::V8HTMLCanvasElement::toDataURLCallback): don't set encoding quality
        here, just pass the toDataURL parameters through to the canvas layer.
        * platform/chromium/MIMETypeRegistryChromium.cpp:
        (WebCore::MIMETypeRegistry::isSupportedImageMIMETypeForEncoding): implement
        the supported mimeTypes for encoding in-place.
        * platform/graphics/skia/ImageBufferSkia.cpp:
        (WebCore::ImageBuffer::toDataURL): add jpeg encoding and quality support.
        * platform/image-encoders/skia/JPEGImageEncoder.cpp: Added.
        (WebCore::prepareOutput):
        (WebCore::writeOutput):
        (WebCore::finishOutput):
        (WebCore::handleError):
        (WebCore::preMultipliedBGRAtoRGB): FIXME: bug 40147.
        (WebCore::JPEGImageEncoder::encode):
        * platform/image-encoders/skia/JPEGImageEncoder.h: Added.

2010-12-02  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r73152.
        http://trac.webkit.org/changeset/73152
        https://bugs.webkit.org/show_bug.cgi?id=50401

        the patch has broken chromium win layout tests (Requested by
        loislo on #webkit).

        * inspector/CodeGeneratorInspector.pm:
        * inspector/Inspector.idl:
        * inspector/front-end/Callback.js:
        * inspector/front-end/DOMAgent.js:
        (WebInspector.DOMNode):
        * inspector/front-end/inspector.js:
        (WebInspector.loaded.WebInspector.socket.onmessage):
        (WebInspector.dispatch):
        (WebInspector_syncDispatch):
        (WebInspector.reportProtocolError):

2010-12-02  W. James MacLean  <wjmaclean@chromium.org>

        Reviewed by James Robinson.

        Scaled Resized images are blurred when sent to Skia
        https://bugs.webkit.org/show_bug.cgi?id=42370

        This patch modifies ImageSkia.cpp to fix the calculation of resampled
        bitmap sizes so as to include the transform matrix of the canvas.
        Includes new tests to catch a scrolling regression and a clipping regression.

        Tests: svg/custom/image-rescale-clip.html
               svg/custom/image-rescale-scroll.html
               svg/custom/image-rescale.svg

        * platform/graphics/skia/ImageSkia.cpp:
        (WebCore::computeResamplingMode):
        (WebCore::drawResampledBitmap):

2010-12-02  Erik Arvidsson  <arv@chromium.org>

        Reviewed by Darin Adler.

        Missing DOM property for incremental input attribute
        https://bugs.webkit.org/show_bug.cgi?id=50335

        Test: fast/forms/incremental-dom-property.html

        * html/HTMLInputElement.idl: Added attribute

2010-12-02  John Knottenbelt  <jknotten@chromium.org>

        Reviewed by Steve Block.

        Move requestGeolocationPermissionForFrame to GeolocationClient
        https://bugs.webkit.org/show_bug.cgi?id=50061

        This change facilitates client-based geolocation implementation by
        bringing together permission control into the geolocation client
        interface.

        * page/Chrome.h:
        * page/ChromeClient.h:
        * page/Geolocation.cpp:
        (WebCore::Geolocation::disconnectFrame):
        (WebCore::Geolocation::requestPermission):
        * page/GeolocationClient.h:
        * page/GeolocationController.cpp:
        (WebCore::GeolocationController::requestPermission):
        (WebCore::GeolocationController::cancelPermissionRequest):
        * page/GeolocationController.h:
        * platform/mock/GeolocationClientMock.cpp:
        (WebCore::GeolocationClientMock::GeolocationClientMock):
        (WebCore::GeolocationClientMock::setPermission):
        (WebCore::GeolocationClientMock::requestPermission):
        (WebCore::GeolocationClientMock::cancelPermissionRequest):
        (WebCore::GeolocationClientMock::asyncUpdatePermission):
        (WebCore::GeolocationClientMock::permissionTimerFired):
        (WebCore::GeolocationClientMock::reset):
        (WebCore::GeolocationClientMock::stopUpdating):
        (WebCore::GeolocationClientMock::asyncUpdateController):
        (WebCore::GeolocationClientMock::controllerTimerFired):
        * platform/mock/GeolocationClientMock.h:

2010-12-01  Ilya Tikhonovsky  <loislo@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: Inspector protocol cleanup task.

        The patch has just small renames and adjustments for the protocol things.
        'handler' keyword in idl file was replaced with 'domain'.
        'domain' property was assigned for the each backend to frontend messages.
        At the next step WebInspector wrapper functions will be removed and 'agents' will be called directly.

        https://bugs.webkit.org/show_bug.cgi?id=50337

        * inspector/CodeGeneratorInspector.pm:
        * inspector/Inspector.idl:
        * inspector/front-end/inspector.js:
        (WebInspector_syncDispatch):

2010-12-01  Andrey Kosyakov  <caseq@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: [Resources panel] [HAR] Need a way to save timing data.
        Re-implementing HAR export functionality that used to be in Resources
        tab in Network tab.
        https://bugs.webkit.org/show_bug.cgi?id=45663

        * inspector/front-end/NetworkPanel.js:
        (WebInspector.NetworkPanel.prototype._createTable):
        (WebInspector.NetworkPanel.prototype._toggleViewingResourceMode):
        (WebInspector.NetworkPanel.prototype._contextMenu):
        (WebInspector.NetworkPanel.prototype._exportAll):
        (WebInspector.NetworkPanel.prototype._exportResource):
        (WebInspector.NetworkDataGridNode.prototype.refreshResource):
        * inspector/front-end/networkPanel.css:
        (.data-grid table.data tr.revealed.network-item):
        (.data-grid.filter-other table.data tr.revealed.network-category-other):

2010-12-02  Dai Mikurube  <dmikurube@google.com>

        Reviewed by Kent Tamura.

        Reject named colors, accept only #rrggbb in <input type=color />
        https://bugs.webkit.org/show_bug.cgi?id=50308

        * html/ColorInputType.cpp: Modified to accept only simple colors like #xxxxxx.
        (WebCore::isValidColorString):

2010-12-02  Vincent Scheib  <scheib@chromium.org>

        Reviewed by Darin Fisher.

        [chromium] histograms api updated in WebKitClient and added to ChromiumBridge
        https://bugs.webkit.org/show_bug.cgi?id=50285

        Test by loading "about:histograms" after navigating to accelerated pages.

        * platform/chromium/ChromiumBridge.h: api update.

2010-12-02  Andras Becsi  <abecsi@webkit.org>

        Unreviewed build fix.

        [Qt][V8] Fix linking of generated sources.

        No new tests needed.

        * WebCore.pro: add missing V8ImageDataCustom.cpp.

2010-12-02  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Adam Roben.

        Split DECLARE_ANIMATED_PROPERTY* in DECLARE/DEFINE parts for SVGAnimatedString/SVGAnimatedEnumeration
        https://bugs.webkit.org/show_bug.cgi?id=50383

        Continuing the work on bug 42025: Introduce DECLARE_ANIMATED_(STRING|ENUMERATION) / DEFINE_ANIMATED_(STRING|ENUMERATION).
        The animated property declaration lives in the header, the definition in the cpp file, to avoid the dependency on SVGNames.h in all headers.

        No functional changes, thus no new tests.

        * svg/SVGAElement.cpp:
        * svg/SVGAElement.h:
        (WebCore::SVGAElement::isValid):
        (WebCore::SVGAElement::target):
        * svg/SVGAltGlyphElement.cpp:
        * svg/SVGAltGlyphElement.h:
        * svg/SVGAnimatedEnumeration.h:
        * svg/SVGAnimatedString.h:
        * svg/SVGClipPathElement.cpp:
        * svg/SVGClipPathElement.h:
        * svg/SVGComponentTransferFunctionElement.cpp:
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGCursorElement.cpp:
        * svg/SVGCursorElement.h:
        * svg/SVGFEBlendElement.cpp:
        * svg/SVGFEBlendElement.h:
        * svg/SVGFEColorMatrixElement.cpp:
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEComponentTransferElement.cpp:
        * svg/SVGFEComponentTransferElement.h:
        * svg/SVGFECompositeElement.cpp:
        * svg/SVGFECompositeElement.h:
        * svg/SVGFEConvolveMatrixElement.cpp:
        * svg/SVGFEConvolveMatrixElement.h:
        * svg/SVGFEDiffuseLightingElement.cpp:
        * svg/SVGFEDiffuseLightingElement.h:
        * svg/SVGFEDisplacementMapElement.cpp:
        * svg/SVGFEDisplacementMapElement.h:
        * svg/SVGFEGaussianBlurElement.cpp:
        * svg/SVGFEGaussianBlurElement.h:
        * svg/SVGFEImageElement.cpp:
        * svg/SVGFEImageElement.h:
        * svg/SVGFELightElement.cpp:
        * svg/SVGFEMergeNodeElement.cpp:
        * svg/SVGFEMergeNodeElement.h:
        * svg/SVGFEMorphologyElement.cpp:
        * svg/SVGFEMorphologyElement.h:
        * svg/SVGFEOffsetElement.cpp:
        * svg/SVGFEOffsetElement.h:
        * svg/SVGFESpecularLightingElement.cpp:
        * svg/SVGFESpecularLightingElement.h:
        * svg/SVGFETileElement.cpp:
        * svg/SVGFETileElement.h:
        * svg/SVGFETurbulenceElement.cpp:
        * svg/SVGFETurbulenceElement.h:
        * svg/SVGFilterElement.cpp:
        * svg/SVGFilterElement.h:
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/SVGForeignObjectElement.cpp:
        * svg/SVGForeignObjectElement.h:
        * svg/SVGGradientElement.cpp:
        * svg/SVGGradientElement.h:
        * svg/SVGImageElement.cpp:
        * svg/SVGImageElement.h:
        * svg/SVGMPathElement.cpp:
        * svg/SVGMPathElement.h:
        * svg/SVGMarkerElement.cpp:
        * svg/SVGMarkerElement.h:
        * svg/SVGMaskElement.cpp:
        * svg/SVGMaskElement.h:
        * svg/SVGPatternElement.cpp:
        * svg/SVGPatternElement.h:
        * svg/SVGScriptElement.cpp:
        * svg/SVGScriptElement.h:
        * svg/SVGStyledElement.cpp:
        * svg/SVGStyledElement.h:
        (WebCore::SVGStyledElement::hasRelativeLengths):
        (WebCore::SVGStyledElement::supportsMarkers):
        (WebCore::SVGStyledElement::style):
        (WebCore::SVGStyledElement::updateRelativeLengthsInformation):
        (WebCore::SVGStyledElement::selfHasRelativeLengths):
        (WebCore::SVGStyledElement::isStyled):
        * svg/SVGTRefElement.cpp:
        * svg/SVGTRefElement.h:
        * svg/SVGTextContentElement.cpp:
        * svg/SVGTextContentElement.h:
        * svg/SVGTextPathElement.cpp:
        * svg/SVGTextPathElement.h:
        * svg/SVGUseElement.cpp:
        * svg/SVGUseElement.h:

2010-12-02  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        [WX] Remove "current path" of GraphicsContext
        https://bugs.webkit.org/show_bug.cgi?id=50286

        * platform/graphics/GraphicsContext.h:
        * platform/graphics/wx/GraphicsContextWx.cpp:
        (WebCore::GraphicsContext::GraphicsContext):
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):

2010-10-26  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] Text input controls do not react properly to CSS styling
        https://bugs.webkit.org/show_bug.cgi?id=40855

        Improve text input control rendering. Instead of using the GTK+ border
        attributes of the control modify the padding, they modify the border.
        Make this same choice for search inputs and text area inputs.

        * platform/gtk/RenderThemeGtk.cpp:
        (WebCore::setTextInputBorders): Added this helper which sets text input control
        borders based on GTK+ theme settings.
        (WebCore::RenderThemeGtk::adjustTextFieldStyle): Use the setTextInputBorders helper.
        (WebCore::RenderThemeGtk::adjustTextAreaStyle): Ditto.
        (WebCore::RenderThemeGtk::adjustSearchFieldStyle): Ditto.
        * platform/gtk/RenderThemeGtk.h:

2010-12-02  Andreas Kling  <kling@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] GraphicsContext::strokeRect() taints the context's lineWidth
        https://bugs.webkit.org/show_bug.cgi?id=50269

        Test: fast/canvas/canvas-lineWidth-intact-after-strokeRect.html

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::strokeRect): Restore the context's
        original stroke thickness after painting.

2010-12-02  Renata Hodovan  <reni@webkit.org>

        Reviewed by Andreas Kling.

        [Qt] GraphicsContext::clip(path) should clip using winding fill 
        https://bugs.webkit.org/show_bug.cgi?id=49912

        GraphicsContext::clip(path) now uses winding fill and this function is called by
        GraphicsContext::canvasClip(path).

        No new test is needed.

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::clip):
        (WebCore::GraphicsContext::canvasClip):

2010-12-01  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: Remove obsolete CSS backend API from InspectorDOMAgent
        https://bugs.webkit.org/show_bug.cgi?id=50318

        * CMakeLists.txt:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.order:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * inspector/Inspector.idl:
        * inspector/InspectorCSSAgent.h:
        * inspector/InspectorCSSStore.cpp: Removed.
        * inspector/InspectorCSSStore.h: Removed.
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        (WebCore::InspectorController::connectFrontend):
        (WebCore::InspectorController::didCommitLoad):
        * inspector/InspectorController.h:
        * inspector/InspectorDOMAgent.cpp:
        (WebCore::InspectorDOMAgent::InspectorDOMAgent):
        (WebCore::InspectorDOMAgent::unbind):
        * inspector/InspectorDOMAgent.h:
        (WebCore::InspectorDOMAgent::create):

2010-12-02  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed trivial buildfix after r73117.

        * page/FrameView.cpp:
        (WebCore::FrameView::calculateScrollbarModesForLayout):

2010-12-02  Yuqiang Xian  <yuqiang.xian@intel.com>

        Reviewed by Pavel Feldman.

        [V8] Speed up data property access for ImageData.
        https://bugs.webkit.org/show_bug.cgi?id=49999

        We create a normal V8 object which has a PixelArray as the backing storage,
        and set the "data" property of the ImageData object to it. 
        This way "data" becomes a pure JS property and we don't need to call through
        the C++ bindings for ImageData "data" access. 
        This eliminates big overhead in switching between JavaScript and native
        contexts and performing object bindings.

        No new tests. Relying on existing Canvas tests.

        * WebCore.gypi:
        * bindings/scripts/CodeGeneratorV8.pm:
        * bindings/v8/custom/V8CanvasPixelArrayCustom.cpp:
        (WebCore::toV8):
        * bindings/v8/custom/V8ImageDataCustom.cpp: Added.
        (WebCore::toV8):
        * html/ImageData.idl:
        * html/canvas/CanvasPixelArray.idl:

2010-12-02  Kent Tamura  <tkent@chromium.org>

        Unreviewed. Run sort-Xcode-project-file.

        * WebCore.xcodeproj/project.pbxproj:

2010-12-02  Mike Lawther  <mikelawther@chromium.org>

        Reviewed by David Hyatt.

        Clean up of iframe scrollbar mode code
        https://bugs.webkit.org/show_bug.cgi?id=47797

        Pull setChildNeedsLayout/setNeedsLayout calls out of scrollbar mode
        calculation method and put back into main layout function. 
        Early exit from the scrollbar calc when scrollbars are turned off. 

        * page/FrameView.cpp:
        (WebCore::FrameView::calculateScrollbarModesForLayout):
        (WebCore::FrameView::layout):

2010-12-02  Hironori Bono  <hbono@chromium.org>

        Reviewed by Darin Fisher.

        [Chromium] Fix possible crashes in FontFallbackFont::determinePitch().
        https://bugs.webkit.org/show_bug.cgi?id=25770

        When all of "Arial", "Courier New", and "Times New Roman" fonts are corrupted,
        FontCache::getLastResortFallbackFont() returns 0 and it causes this crash. To
        avoid this crash, this change falls back to system fonts (Windows ensures they
        are sane) as Win Safari does. Unfortunately, I don't have any ideas how I can
        write a layout test for this issue because this crash happens on a PC some of
        its system fonts are corrupted.

        * platform/graphics/chromium/FontCacheChromiumWin.cpp:
        (WebCore::fontDataFromDescriptionAndLogFont):
        (WebCore::FontCache::getLastResortFallbackFont):

2010-12-02  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Kent Tamura.

        Provide means to store shadow DOM nodes on Element
        https://bugs.webkit.org/show_bug.cgi?id=48697

        Adds shadow DOM awareness to the standard Node attach/detach,
        document and tree insertion and removal cycle.

        No new tests, because the code is not yet used.

        * dom/Element.cpp:
        (WebCore::Element::insertedIntoDocument): Added logic to cascade down to shadow DOM, if present.
        (WebCore::Element::removedFromDocument): Ditto.
        (WebCore::Element::insertedIntoTree): Ditto.
        (WebCore::Element::removedFromTree): Ditto.
        (WebCore::Element::attach): Ditto.
        (WebCore::Element::detach): Ditto.
        (WebCore::Element::recalcStyle):
        (WebCore::Element::shadowRoot): Added.
        (WebCore::Element::setShadowRoot): Added.
        (WebCore::Element::clearShadowRoot): Added.
        * dom/Element.h: Added decls.
        * dom/ElementRareData.h: Added a member to hold a RefPtr to the shadow DOM root for the element.

2010-12-02  Adam Barth  <abarth@webkit.org>

        Reviewed by Eric Seidel.

        Gray-scale JPEG images with a color profile are stretched horizonally
        https://bugs.webkit.org/show_bug.cgi?id=49950

        Turns out gray-scale JPEGs with color profiles have the same issue as
        PNGs.  As with PNGs, we suppress now suppress the color profile for
        gray-scale JPEGs.  Most importantly, this patch adds a test.

        Test: fast/images/gray-scale-jpeg-with-color-profile.html

        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp:
        (WebCore::JPEGImageReader::decode):

2010-12-01  Geoffrey Garen  <ggaren@apple.com>

        Build fix: Added a forwarding header.

        * ForwardingHeaders/wtf/OSAllocator.h: Added.

2010-12-01  Jia Pu  <jpu@apple.com>

        Reviewed by Darin Adler.

        Support multiple correction candidates panel for misspelled word on Mac OS X.
        https://bugs.webkit.org/show_bug.cgi?id=50137
        <rdar://problem/8568059>

        Test: platform/mac/editing/spelling/delete-autocorrected-word-1.html
        Manual test: WebCore/manual-tests/autocorrection/dismiss-multiple-guesses.html
                     WebCore/manual-tests/autocorrection/select-from-multiple-guesses.html

        This patch is for supporting multiple correction suggestion panel on Mac OS X.
        The behavior and implementation is similar to that of reversion candiate panel.

        * WebCore.exp.in: Added and removed symbols.

        * editing/CorrectionPanelInfo.h: Added new correction panel type, PanelTypeSpellingSuggestions.

        * editing/Editor.cpp:
        (WebCore::markerTypesForAutocorrection): Convenient function for getting marker types to
          be added to autocorrected word.
        (WebCore::boundingBoxForRange): Convenient function for calculating the bounding box of a range.
        (WebCore::markerTypesForReplacement): Convenient function for getting marker types to
          be added to word that has been replaced by various correction panel.
        (WebCore::Editor::respondToChangedSelection): Added code to trigger timer for multiple
          suggestion panel.
        (WebCore::Editor::guessesForMisspelledSelection): Adopted new signature of EditorClient::getGuessesForWord().
        (WebCore::Editor::markMisspellingsAfterTypingToWord): Adopted new signature of applyCorrectionPanelInfo().
        (WebCore::Editor::markAllMisspellingsAndBadGrammarInRanges): Ditto.
        (WebCore::Editor::correctionPanelTimerFired): Added code to handle new multiple suggestion panel.
        (WebCore::Editor::handleCorrectionPanelResult): Replaced handleRejectedCorrection(), since
          with new AppKit correction panel API, not only rejection, but also confirmation can be
          handled in callback.
        (WebCore::Editor::stopCorrectionPanelTimer): Moved the code that clears correction panel info
          from dismissCorrectionPanel() to this function to fix a bug that would occur when deleting
          autocorrected word.
        (WebCore::Editor::dismissCorrectionPanel): Ditto.
        (WebCore::Editor::applyCorrectionPanelInfo): Added code to handle new multiple suggestion panel.

        * editing/Editor.h: Replaced handleRejectedCorrection() with handleCorrectionPanelResult().
          Changed the signature of applyCorrectionPanelInfo() to hanlde new correction panel type.

        * editing/TextCheckingHelper.cpp:
        (WebCore::TextCheckingHelper::guessesForMisspelledOrUngrammaticalRange): Adopted new EditorClient::getGuessesForWord().

        * editing/TextCheckingHelper.h: Made paragraphRange() public.

        * loader/EmptyClients.h:
        (WebCore::EmptyEditorClient::showCorrectionPanel): Adopted new signature defined in base class.
        (WebCore::EmptyEditorClient::getGuessesForWord): Ditto.

        * manual-tests/autocorrection/dismiss-multiple-guesses.html: Added.

        * manual-tests/autocorrection/select-from-multiple-guesses.html: Added.

        * page/EditorClient.h:  Changed showCorrectionPanel() to allow passing multiple correction
          candidates. Changed getGuessesForWord() to allow passing in contextual text for better
          correction suggestions (for those spellcheckers that utilizes such contextual information).

2010-12-01  David Hyatt  <hyatt@apple.com>

        Reviewed by James Robinson.

        https://bugs.webkit.org/show_bug.cgi?id=50360
        
        Make sure to include the origin adjustment code that I added on Mac to keep truncation-rtl.html passing.

        * platform/ScrollView.cpp:
        (WebCore::ScrollView::updateScrollbars):

2010-12-01  David Hyatt  <hyatt@apple.com>

        Reviewed by Dan Bernstein.

        https://bugs.webkit.org/show_bug.cgi?id=46645

        Generalize overflow section scrollOriginX code to be a point and to work in both horizontal
        and vertical modes.

        Not testable yet, since the rightmost/leftmost/topmost/lowestPosition functions are returning
        horrendously wrong values in the vertical text case for overflow:auto objects.

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::RenderLayer):
        (WebCore::RenderLayer::scrollToOffset):
        (WebCore::RenderLayer::computeScrollDimensions):
        (WebCore::RenderLayer::updateOverflowStatus):
        * rendering/RenderLayer.h:
        (WebCore::RenderLayer::scrolledContentOffset):
        (WebCore::RenderLayer::scrollXOffset):
        (WebCore::RenderLayer::scrollYOffset):
        (WebCore::RenderLayer::scrollToXOffset):
        (WebCore::RenderLayer::scrollToYOffset):

2010-12-01  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Adam Roben.

        WinCairo build should not use link-time code generation (LTCG)
        https://bugs.webkit.org/show_bug.cgi?id=50353

        * WebCore.vcproj/QTMovieWin.vcproj:
        * WebCore.vcproj/WebCore.vcproj:

2010-12-01  David Hyatt  <hyatt@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=46645
        
        Part 1 of making scrolling work with vertical text. This patch generalizes the scrollOriginX concept
        recently added for horizontal RTL documents and applies it to writing modes as well.  Now the
        scrollOrigin is a point, since you can start off locked to the bottom or locked to the right.
        
        This patch also fixes numerous bugs with the scrollOrigin code using native Mac NSScrollViews and
        makes them behave the same as the cross-platform code (allowing for cross-platform results to be
        landed).

        * page/FrameView.cpp:
        (WebCore::FrameView::adjustViewSize):
        * page/mac/WebCoreFrameView.h:
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::ScrollView):
        (WebCore::ScrollView::maximumScrollPosition):
        (WebCore::ScrollView::minimumScrollPosition):
        (WebCore::ScrollView::valueChanged):
        (WebCore::ScrollView::updateScrollbars):
        (WebCore::ScrollView::wheelEvent):
        * platform/ScrollView.h:
        (WebCore::ScrollView::scrollOrigin):
        * platform/mac/ScrollViewMac.mm:
        (WebCore::ScrollView::platformSetScrollPosition):
        (WebCore::ScrollView::platformSetScrollOrigin):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::paintRootBoxDecorations):
        * rendering/RenderView.cpp:
        (WebCore::RenderView::layout):
        (WebCore::RenderView::docTop):
        (WebCore::RenderView::docHeight):
        (WebCore::RenderView::docLeft):
        (WebCore::RenderView::docWidth):
        * rendering/RenderView.h:

2010-11-30  Steve Block  <steveblock@google.com>

        Reviewed by Jeremy Orlow.

        Upstream recent changes to WebCore/platform/network/android
        https://bugs.webkit.org/show_bug.cgi?id=50224

        Android implementation changes only, no new tests.

        * platform/network/NetworkingContext.h:
        * platform/network/android/CookieJarAndroid.cpp:
        (WebCore::setCookies):
        (WebCore::cookies):
        (WebCore::cookieRequestHeaderFieldValue):
        (WebCore::cookiesEnabled):
        * platform/network/android/ProxyServerAndroid.cpp: Added.
        (WebCore::proxyServersForURL):
        * platform/network/android/ResourceHandleAndroid.cpp:
        (WebCore::ResourceHandle::start):
        (WebCore::ResourceHandle::loadResourceSynchronously):
        * platform/network/android/ResourceRequestAndroid.cpp:
        (WebCore::initializeMaximumHTTPConnectionCountPerHost):

2010-12-01  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Adam Roben.

        vcproj changes can't be applied cleanly by the Windows EWS bot
        https://bugs.webkit.org/show_bug.cgi?id=50328

        * WebCore.vcproj/QTMovieWin.vcproj: Modified property svn:eol-style.
        * WebCore.vcproj/QTMovieWinCommon.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCore.sln: Modified property svn:eol-style.
        * WebCore.vcproj/WebCore.submit.sln: Modified property svn:eol-style.
        * WebCore.vcproj/WebCore.vcproj: Modified property svn:eol-style.
        * WebCore.vcproj/WebCoreCFNetwork.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCoreCG.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCoreCURL.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCoreCairo.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCoreCommon.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCoreGenerated.vcproj: Modified property svn:eol-style.
        * WebCore.vcproj/WebCoreGeneratedCairo.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCoreGeneratedCommon.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCoreMediaQT.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCorePthreads.vsprops: Added property svn:eol-style.
        * WebCore.vcproj/WebCoreQuartzCore.vsprops: Added property svn:eol-style.

2010-11-30  Vangelis Kokkevis  <vangelis@chromium.org>

        Reviewed by Darin Fisher.

        Adds accelerated compositing trigger flags to Settings to allow
        ports to set them via command line flags, etc.
        https://bugs.webkit.org/show_bug.cgi?id=50301

        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        (WebCore::Settings::setAcceleratedCompositingFor3DTransformsEnabled):
        (WebCore::Settings::setAcceleratedCompositingForVideoEnabled):
        (WebCore::Settings::setAcceleratedCompositingForPluginsEnabled):
        (WebCore::Settings::setAcceleratedCompositingForCanvasEnabled):
        (WebCore::Settings::setAcceleratedCompositingForAnimationEnabled):
        * page/Settings.h:
        (WebCore::Settings::acceleratedCompositingFor3DTransformsEnabled):
        (WebCore::Settings::acceleratedCompositingForVideoEnabled):
        (WebCore::Settings::acceleratedCompositingForPluginsEnabled):
        (WebCore::Settings::acceleratedCompositingForCanvasEnabled):
        (WebCore::Settings::acceleratedCompositingForAnimationEnabled):

2010-12-01  Darin Adler  <darin@apple.com>

        Fixed warning seen on buildbot.

        * platform/graphics/chromium/ContentLayerChromium.cpp:
        (WebCore::ContentLayerChromium::SharedValues::SharedValues): Added #if.

2010-12-01  Ryosuke Niwa  <rniwa@webkit.org>

        Reviewed by Darin Adler, Tony Chang, and unofficially by Enrica Casucci.

        chrome.dll!WebCore::RangeBoundaryPoint::toPosition ReadAV@NULL (cf0d0f28bc56f2591cc74f71b46036ea)
        https://bugs.webkit.org/show_bug.cgi?id=47808

        The crash was caused by moveParagraphWithClones' not copying the entire paragraph
        when called by doApplyForSingleParagraph, which was induced by a bug in
        cloneParagraphUnderNewElement which ended the cloning process early when the start node
        and the end node didn't share the same parent node. Fixed the bug in cloneParagraphUnderNewElement
        by calling traverseNextSibling(outerNode) instead of nextSibling().

        Also added an early exit to InsertListCommand::doApply when lastSelectionRange is null.

        Tests: editing/execCommand/switch-multiple-list-items-crash.html
               editing/execCommand/switch-multiple-list-items.html

        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::cloneParagraphUnderNewElement):
        * editing/InsertListCommand.cpp:
        (WebCore::InsertListCommand::doApply):

2010-12-01  Kevin Ollivier  <kevino@theolliviers.com>

        [wx] Build fixes after recent trunk changes.

        * platform/graphics/wx/ImageBufferWx.cpp:
        (WebCore::ImageBuffer::ImageBuffer):
        * platform/wx/LocalizedStringsWx.cpp:
        (WebCore::platformDefaultLanguage):

2010-12-01  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r73047.
        http://trac.webkit.org/changeset/73047
        https://bugs.webkit.org/show_bug.cgi?id=50339

        missing bug number (Requested by rniwa on #webkit).

        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::cloneParagraphUnderNewElement):
        * editing/InsertListCommand.cpp:
        (WebCore::InsertListCommand::doApply):

2010-12-01  Ryosuke Niwa  <rniwa@webkit.org>

        Reviewed by Darin Adler, Tony Chang, and unofficially by Enrica Casucci.

        The crash was caused by moveParagraphWithClones' not copying the entire paragraph
        when called by doApplyForSingleParagraph, which was induced by a bug in
        cloneParagraphUnderNewElement which ended the cloning process early when the start node
        and the end node didn't share the same parent node. Fixed the bug in cloneParagraphUnderNewElement
        by calling traverseNextSibling(outerNode) instead of nextSibling().

        Also added an early exit to InsertListCommand::doApply when lastSelectionRange is null.

        Tests: editing/execCommand/switch-multiple-list-items-crash.html
               editing/execCommand/switch-multiple-list-items.html

        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::cloneParagraphUnderNewElement):
        * editing/InsertListCommand.cpp:
        (WebCore::InsertListCommand::doApply):

2010-12-01  Grace Kloba  <klobag@chromium.org>

        Reviewed by Kenneth Russell.

        [chromium] ContentLayerChromium shader should honor the platform Sk_x_SHIFT value instead of assuming BGRA color
        https://bugs.webkit.org/show_bug.cgi?id=50189

        * platform/graphics/chromium/ContentLayerChromium.cpp:
        (WebCore::ContentLayerChromium::SharedValues::SharedValues):Use SK_B32_SHIFT to decide whether to use RGBA or BGRA shader for Skia port.

2010-12-01  Nico Weber  <thakis@chromium.org>

        Reviewed by Dimitri Glazkov.

        Fix clang warnings caused by -Wlogical-op-parentheses
        https://bugs.webkit.org/show_bug.cgi?id=50324

        * platform/graphics/mac/ComplexTextController.cpp:
        (WebCore::ComplexTextController::adjustGlyphsAndAdvances):

2010-12-01  Martin Robinson  <mrobinson@igalia.com>

        Build fix for GTK+.

        * platform/gtk/PopupMenuGtk.cpp:
        (WebCore::PopupMenuGtk::typeAheadFind): Uncomment mistakenly commented line.

2010-12-01  Apelete Seketeli  <apelete@seketeli.org> and Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        [Gtk] Open menulists should support typeahead find
        https://bugs.webkit.org/show_bug.cgi?id=27443

        Added typeahead find support for open GTK+ menulists.

        Test: platform/gtk/fast/forms/menulist-typeahead-find.html

        * platform/gtk/PopupMenuGtk.cpp:
        (WebCore::PopupMenuGtk::PopupMenuGtk): Initialize new members.
        (WebCore::PopupMenuGtk::show): Track currently selected menu item
        via a signal handler.
        (WebCore::PopupMenuGtk::typeAheadFind): Added.
        (WebCore::PopupMenuGtk::menuUnmapped): Reset typeahead find state
        when menu is unmapped.
        (WebCore::PopupMenuGtk::resetTypeAheadFindState): Added.
        (WebCore::PopupMenuGtk::selectItemCallback): Added.
        (WebCore::PopupMenuGtk::keyPressEventCallback): Added.
        * platform/gtk/PopupMenuGtk.h: Added new members to track typeahead
        find state.

2010-12-01  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Xan Lopez.

        Split DECLARE_ANIMATED_PROPERTY* in DECLARE/DEFINE parts for SVGAnimatedNumber
        https://bugs.webkit.org/show_bug.cgi?id=50323

        Continuing the work on bug 42025: Introduce DECLARE_ANIMATED_NUMBER / DEFINE_ANIMATED_NUMBER.
        The animated property declaration lives in the header, the definition in the cpp file, to avoid the dependency on SVGNames.h in all headers.

        No functional changes, thus no new tests.

        * svg/SVGAnimatedNumber.h:
        * svg/SVGComponentTransferFunctionElement.cpp:
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGFECompositeElement.cpp:
        * svg/SVGFECompositeElement.h:
        * svg/SVGFEConvolveMatrixElement.cpp:
        * svg/SVGFEConvolveMatrixElement.h:
        * svg/SVGFEDiffuseLightingElement.cpp:
        * svg/SVGFEDiffuseLightingElement.h:
        * svg/SVGFEDisplacementMapElement.cpp:
        * svg/SVGFEDisplacementMapElement.h:
        * svg/SVGFEGaussianBlurElement.cpp:
        * svg/SVGFEGaussianBlurElement.h:
        * svg/SVGFELightElement.cpp:
        * svg/SVGFELightElement.h:
        * svg/SVGFEMorphologyElement.cpp:
        * svg/SVGFEMorphologyElement.h:
        * svg/SVGFEOffsetElement.cpp:
        * svg/SVGFEOffsetElement.h:
        * svg/SVGFESpecularLightingElement.cpp:
        * svg/SVGFESpecularLightingElement.h:
        * svg/SVGFETurbulenceElement.cpp:
        * svg/SVGFETurbulenceElement.h:
        * svg/SVGPathElement.cpp:
        * svg/SVGPathElement.h:
        * svg/SVGStopElement.cpp:
        * svg/SVGStopElement.h:
        (WebCore::SVGStopElement::isGradientStop):

2010-12-01  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        Sliders are not transformed after r50188
        https://bugs.webkit.org/show_bug.cgi?id=50317

        Need to call updateLayerTransform during slider layout, as sliders
        may be transformed.

        No new tests. This patch should make fast/forms/slider-transformed.html
        pass on the GTK+ bots.

        * rendering/RenderSlider.cpp:
        (WebCore::RenderSlider::layout): Call updateLayerTransform here.

2010-11-30  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: do not make helpScreen.css lazily loaded.
        https://bugs.webkit.org/show_bug.cgi?id=50304

        * inspector/front-end/HelpScreen.js:
        (WebInspector.HelpScreen):
        (WebInspector.HelpScreen.prototype._onBlur):
        * inspector/front-end/inspector.html:

2010-12-01  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Xan Lopez.

        Split DECLARE_ANIMATED_PROPERTY* in DECLARE/DEFINE parts for SVGLengthList/SVGNumberList/SVGTransformList
        https://bugs.webkit.org/show_bug.cgi?id=50322

        Continuing the work on bug 42025: Introduce DECLARE_ANIMATED_(LENGTH|NUMBER|TRANSFORM)_LIST / DEFINE_ANIMATED_(LENGTH|NUMBER|TRANSFORM).
        The animated property declaration lives in the header, the definition in the cpp file, to avoid the dependency on SVGNames.h in all headers.

        No functional changes, thus no new tests.

        * svg/SVGAnimatedLengthList.h:
        * svg/SVGAnimatedNumberList.h:
        * svg/SVGAnimatedTransformList.h:
        * svg/SVGComponentTransferFunctionElement.cpp:
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGFEColorMatrixElement.cpp:
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEConvolveMatrixElement.cpp:
        * svg/SVGFEConvolveMatrixElement.h:
        * svg/SVGGradientElement.cpp:
        * svg/SVGGradientElement.h:
        (WebCore::SVGGradientElement::needsPendingResourceHandling):
        * svg/SVGPatternElement.cpp:
        * svg/SVGPatternElement.h:
        * svg/SVGPolygonElement.cpp:
        * svg/SVGPolylineElement.cpp:
        * svg/SVGStyledTransformableElement.cpp:
        * svg/SVGStyledTransformableElement.h:
        * svg/SVGTextElement.cpp:
        (WebCore::SVGTextElement::SVGTextElement):
        * svg/SVGTextElement.h:
        (WebCore::SVGTextElement::localCoordinateSpaceTransform):
        * svg/SVGTextPositioningElement.cpp:
        * svg/SVGTextPositioningElement.h:
        * svg/properties/SVGAnimatedPropertyMacros.h:

2010-12-01  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: name-only property appears in style declaration but not in the Styles pane
        https://bugs.webkit.org/show_bug.cgi?id=49663

        Check that at least one property has been parsed from the user input.

        * inspector/InspectorStyleSheet.cpp:
        (WebCore::InspectorStyle::setPropertyText):

2010-12-01  Andrey Kosyakov  <caseq@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: disable cookies tab in network resource view by default, enable for chromium
        https://bugs.webkit.org/show_bug.cgi?id=50249

        * inspector/front-end/NetworkItemView.js:
        (WebInspector.NetworkItemView):
        (WebInspector.NetworkItemView.prototype.resize):
        * inspector/front-end/Settings.js:

2010-12-01  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Xan Lopez.

        Split DECLARE_ANIMATED_PROPERTY* in DECLARE/DEFINE parts for SVGLength
        https://bugs.webkit.org/show_bug.cgi?id=50316

        Introduce DECLARE_ANIMATED_LENGTH / DEFINE_ANIMATED_LENGTH, splitting up the original DECLARE_ANIMATED_PROPERTY_NEW macro
        in a part that goes in the .cpp file and another that remains in the header. This avoids having to include SVGNames.h
        in all SVG*Element files.

        No functional changes, thus no new tests.

        * svg/SVGAnimatedLength.h:
        * svg/SVGCircleElement.cpp:
        * svg/SVGCircleElement.h:
        (WebCore::SVGCircleElement::isValid):
        * svg/SVGCursorElement.cpp:
        * svg/SVGCursorElement.h:
        (WebCore::SVGCursorElement::isValid):
        * svg/SVGEllipseElement.cpp:
        * svg/SVGEllipseElement.h:
        (WebCore::SVGEllipseElement::isValid):
        * svg/SVGFilterElement.cpp:
        * svg/SVGFilterElement.h:
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/SVGForeignObjectElement.cpp:
        (WebCore::SVGForeignObjectElement::SVGForeignObjectElement):
        * svg/SVGForeignObjectElement.h:
        (WebCore::SVGForeignObjectElement::isValid):
        * svg/SVGImageElement.cpp:
        * svg/SVGImageElement.h:
        (WebCore::SVGImageElement::isValid):
        * svg/SVGLineElement.cpp:
        * svg/SVGLineElement.h:
        (WebCore::SVGLineElement::isValid):
        (WebCore::SVGLineElement::supportsMarkers):
        * svg/SVGLinearGradientElement.cpp:
        * svg/SVGLinearGradientElement.h:
        * svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::SVGMarkerElement):
        * svg/SVGMarkerElement.h:
        * svg/SVGMaskElement.cpp:
        * svg/SVGMaskElement.h:
        (WebCore::SVGMaskElement::isValid):
        (WebCore::SVGMaskElement::needsPendingResourceHandling):
        * svg/SVGPatternElement.cpp:
        * svg/SVGPatternElement.h:
        (WebCore::SVGPatternElement::isValid):
        (WebCore::SVGPatternElement::needsPendingResourceHandling):
        * svg/SVGRadialGradientElement.cpp:
        * svg/SVGRadialGradientElement.h:
        * svg/SVGRectElement.cpp:
        * svg/SVGRectElement.h:
        (WebCore::SVGRectElement::isValid):
        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::SVGSVGElement):
        * svg/SVGSVGElement.h:
        (WebCore::SVGSVGElement::isValid):
        (WebCore::SVGSVGElement::setContainerSize):
        (WebCore::SVGSVGElement::containerSize):
        (WebCore::SVGSVGElement::hasSetContainerSize):
        (WebCore::SVGSVGElement::currentTranslate):
        (WebCore::SVGSVGElement::timeContainer):
        (WebCore::SVGSVGElement::isSVG):
        (WebCore::SVGSVGElement::rendererIsNeeded):
        * svg/SVGTextContentElement.cpp:
        * svg/SVGTextContentElement.h:
        (WebCore::SVGTextContentElement::isValid):
        (WebCore::SVGTextContentElement::isTextContent):
        * svg/SVGTextPathElement.cpp:
        * svg/SVGTextPathElement.h:
        * svg/SVGTextPositioningElement.h:
        * svg/SVGUseElement.cpp:
        * svg/SVGUseElement.h:
        (WebCore::SVGUseElement::isValid):
        (WebCore::SVGUseElement::setUpdatesBlocked):
        (WebCore::SVGUseElement::isPendingResource):
        * svg/properties/SVGAnimatedPropertyMacros.h:

2010-12-01  Anton D'Auria  <adauria@apple.com>

        Reviewed by Kevin Decker.

        Deny access to local and session storage in private browsing mode.
        https://bugs.webkit.org/show_bug.cgi?id=49329

        * storage/Storage.cpp:
        (WebCore::Storage::length):
        (WebCore::Storage::key):
        (WebCore::Storage::getItem):
        (WebCore::Storage::contains):

2010-12-01  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Martin Robinson.

        Volume control not correctly initialized
        https://bugs.webkit.org/show_bug.cgi?id=36299

        Replaced the mute/volume Timers with g_timeouts which are (for
        now, at least) more reliable than Timers for one-shot-fire-now
        actions.

        Test: media/video-volume.html

        * platform/graphics/MediaPlayer.cpp:
        (WebCore::MediaPlayer::~MediaPlayer): Reset the raw pointers to 0
        when destructing the player.
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::mediaPlayerPrivateVolumeChangeTimeoutCallback):
        (WebCore::mediaPlayerPrivateMuteChangeTimeoutCallback):
        (WebCore::MediaPlayerPrivateGStreamer::~MediaPlayerPrivateGStreamer):
        (WebCore::MediaPlayerPrivateGStreamer::notifyPlayerOfVolumeChange):
        (WebCore::MediaPlayerPrivateGStreamer::volumeChanged):
        (WebCore::MediaPlayerPrivateGStreamer::notifyPlayerOfMute):
        (WebCore::MediaPlayerPrivateGStreamer::muteChanged):
        (WebCore::MediaPlayerPrivateGStreamer::createGSTPlayBin): Set
        playbin2 volume/mute base on MediaPlayer related values.
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.h:

2010-12-01  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        Cleanup main CMakeLists.txt after r72664, r72672 and r72667
        https://bugs.webkit.org/show_bug.cgi?id=50232

        * CMakeLists.txt: Removed obsolete dependencies.

2010-12-01  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Dirk Schulze.

        Cleanup SVGPropertyTraits
        https://bugs.webkit.org/show_bug.cgi?id=50229

        Move all template specializations for non-POD types (eg. SVGLength, SVGLengthList, etc.) from SVGPropertyTraits
        into the right SVG* classes, to avoid having to include a dozen SVG*.h files in SVGPropertyTraits.h, which is
        included by all DOM/JS/V8 binding files and SVGElement.h.

        No new functionality, thus no new tests.

        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/scripts/CodeGenerator.pm:
        * bindings/scripts/CodeGeneratorObjC.pm:
        * bindings/scripts/CodeGeneratorV8.pm:
        * svg/SVGAngle.h:
        * svg/SVGLength.h:
        * svg/SVGLengthList.h:
        * svg/SVGMarkerElement.h:
        * svg/SVGNumberList.h:
        * svg/SVGPatternElement.h:
        * svg/SVGPointList.h:
        * svg/SVGPreserveAspectRatio.h:
        * svg/SVGRect.h: Added.
        * svg/SVGSVGElement.h:
        * svg/SVGStringList.h:
        * svg/SVGSymbolElement.h:
        * svg/SVGTransformList.h:
        * svg/SVGViewElement.h:
        * svg/SVGViewSpec.h:
        * svg/properties/SVGListProperty.h:
        * svg/properties/SVGPropertyTraits.h:
        * svg/properties/SVGTransformListPropertyTearOff.h:

2010-11-30  Kent Tamura  <tkent@chromium.org>

        Reviewed by Darin Adler.

        Refactor HTMLInputElement: Move a part of HTMLInputElement::
        defaultEventHandler() to InputTypes
        https://bugs.webkit.org/show_bug.cgi?id=50097

        Move all of keyboard-related event handling to InputType.

        No new tests because this should not change any behavior.

        * html/BaseButtonInputType.cpp:
        (WebCore::BaseButtonInputType::handleKeydownEvent):
        (WebCore::BaseButtonInputType::handleKeypressEvent):
        (WebCore::BaseButtonInputType::handleKeyupEvent):
        * html/BaseButtonInputType.h:
        * html/BaseCheckableInputType.cpp:
        (WebCore::BaseCheckableInputType::handleKeydownEvent):
        (WebCore::BaseCheckableInputType::handleKeypressEvent):
        * html/BaseCheckableInputType.h:
        * html/CheckboxInputType.cpp:
        (WebCore::CheckboxInputType::handleKeyupEvent):
        * html/CheckboxInputType.h:
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::defaultEventHandler):
         We remove !implicitSubmission check for callBaseClassEarly because
         implicitSubmission can not be true for keydown event and keypress
         event at this point.
        * html/InputType.cpp:
        (WebCore::InputType::shouldSubmitImplicitly):
         Returns true for a keypress event with "\r". Note that we don't overload
         this function for BUTTON, FILE, IMAGE, RESET, and SUBMIT because a
         keypress event with "\r" for these types returns from HTMLInputElement::defaultEventHandler()
         before implicit submission checking.
        (WebCore::InputType::handleKeypressEvent):
        (WebCore::InputType::handleKeyupEvent):
        * html/InputType.h:
        * html/RadioInputType.cpp:
        (WebCore::RadioInputType::handleKeydownEvent):
        (WebCore::RadioInputType::handleKeyupEvent):
        * html/RadioInputType.h:
        * html/TextFieldInputType.cpp:
        (WebCore::TextFieldInputType::shouldSubmitImplicitly):
        * html/TextFieldInputType.h:

2010-11-30  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        Move CSS generator logic into main CMakeLists.txt file
        https://bugs.webkit.org/show_bug.cgi?id=50230

        * CMakeLists.txt:

2010-11-30  Ojan Vafai  <ojan@chromium.org>

        Revert r72876. It caused a ~30% perf regression in chromium's bloat-http test
        https://bugs.webkit.org/show_bug.cgi?id=50288

        2010-11-29 Adam Barth <abarth@webkit.org (:abarth) (r)>
        Reviewed by Darin Adler.
        Introduce the notion of a "display-isolated" URL scheme for use by Chrome-internal URLs
        https://bugs.webkit.org/show_bug.cgi?id=50182
        A display-isolated URL can only be displayed (e.g., put in an iframe,
        hyperlinked to) by documents from that scheme. In a sense, this is a
        generalization of some of the protections we give file URLs, but
        instead of lumping them all together into one "local" bucket, this
        patch creates a separate bucket for each scheme.
        For a while, I tried using a separate bucket for each origin. That
        would have played nicely with what Blob URLs are trying to do, but some
        "chrome" URL pages rely on being able to display other chrome URL
        pages, even in different origins. For example, the New Tab Page shows
        thumbnails from the "thumbnail" host.
        This patch also removes a bunch of unused code. I've also propagated
        the "deprecated" status of deprecatedCanDisplay to
        deprecatedShouldTreatURLAsLocal because that method has no other
        callers and is really asking for uppercase/lowercase bugs. I dream of
        someday removing these functions.
        page/SecurityOrigin.cpp:
        (WebCore::SecurityOrigin::canDisplay):
        (WebCore::SecurityOrigin::deprecatedCanDisplay):
        platform/SchemeRegistry.cpp:
        (WebCore::displayIsolatedURLSchemes):
        (WebCore::SchemeRegistry::registerURLSchemeAsLocal):
        (WebCore::SchemeRegistry::deprecatedShouldTreatURLAsLocal):
        (WebCore::SchemeRegistry::shouldTreatURLSchemeAsLocal):
        (WebCore::SchemeRegistry::registerURLSchemeAsDisplayIsolated):
        (WebCore::SchemeRegistry::shouldTreatURLSchemeAsDisplayIsolated):
        platform/SchemeRegistry.h:
        2010-11-29 Adam Barth <abarth@webkit.org (:abarth) (r)>
        Reviewed by Darin Adler.
        Introduce the notion of a "display-isolated" URL scheme for use by Chrome-internal URLs
         https://bugs.webkit.org/show_bug.cgi?id=50182
        This patch adds a Chromium API for registering schemes as
        display-isolated. In a subsequent patch, I'll change the "chrome"
        scheme in Chrome to be display isolated instead of local. That will
        prevent file URLs from linking to chrome URLs.
        public/WebSecurityPolicy.h:
        src/WebSecurityPolicy.cpp:
        (WebKit::WebSecurityPolicy::registerURLSchemeAsDisplayIsolated):

        * page/SecurityOrigin.cpp:
        (WebCore::SecurityOrigin::canDisplay):
        (WebCore::SecurityOrigin::deprecatedCanDisplay):
        * platform/SchemeRegistry.cpp:
        (WebCore::SchemeRegistry::registerURLSchemeAsLocal):
        (WebCore::SchemeRegistry::removeURLSchemeRegisteredAsLocal):
        (WebCore::SchemeRegistry::localURLSchemes):
        (WebCore::SchemeRegistry::shouldTreatURLAsLocal):
        (WebCore::SchemeRegistry::shouldTreatURLSchemeAsLocal):
        * platform/SchemeRegistry.h:

2010-11-30  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Beth Dakin.

        WebKit duplicates AXValue and AXDescription on abbr
        https://bugs.webkit.org/show_bug.cgi?id=50260

        stringValue() and accessibilityDescription() were returning the same value for static text with
        an aria-label. Static text elements should not have an accessibility description, they
        should only have a stringValue.

        Test: platform/mac/accessibility/static-text-with-aria-label.html

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::ariaAccessibilityDescription):
        (WebCore::AccessibilityRenderObject::accessibilityDescription):
        (WebCore::AccessibilityRenderObject::text):
        * accessibility/AccessibilityRenderObject.h:

2010-11-30  Ryosuke Niwa  <rniwa@webkit.org>

        Reviewed by Darin Adler.

        [HTML5] Rename member variables of HTMLScriptElement
        https://bugs.webkit.org/show_bug.cgi?id=49705

        Renamed m_wasCreatedByParser to m_wasInsertedByParser, m_requested to m_isExternalScript,
        m_isEvaluated to m_wasAlreadyStarted, and m_firedLoad to m_haveFiredLoad.

        Also made ScriptElement's haveFiredLoadEvent and removed HTMLScriptElement's haveFiredLoadEvent.
        This effectively adds the same function to SVGScriptElement, which isn't currently used anywhere.

        No new tests are added since this is a refactoring.

        * dom/ScriptElement.cpp:
        (WebCore::ScriptElement::ScriptElement):
        (WebCore::ScriptElement::insertedIntoDocument):
        (WebCore::ScriptElement::childrenChanged):
        (WebCore::ScriptElement::finishParsingChildren):
        (WebCore::ScriptElement::requestScript):
        (WebCore::ScriptElement::evaluateScript):
        (WebCore::ScriptElement::executeScript):
        (WebCore::ScriptElement::ignoresLoadRequest):
        * dom/ScriptElement.h:
        (WebCore::ScriptElement::haveFiredLoadEvent):
        (WebCore::ScriptElement::setHaveFiredLoadEvent):
        (WebCore::ScriptElement::wasInsertedByParser):
        (WebCore::ScriptElement::wasAlreadyStarted):
        * html/HTMLScriptElement.cpp:
        (WebCore::HTMLScriptElement::HTMLScriptElement):
        (WebCore::HTMLScriptElement::create):
        (WebCore::HTMLScriptElement::cloneElementWithoutAttributesAndChildren):
        * html/HTMLScriptElement.h:
        * svg/SVGScriptElement.cpp:
        (WebCore::SVGScriptElement::SVGScriptElement):
        (WebCore::SVGScriptElement::create):
        (WebCore::SVGScriptElement::svgAttributeChanged):
        (WebCore::SVGScriptElement::insertedIntoDocument):
        (WebCore::SVGScriptElement::dispatchLoadEvent):
        (WebCore::SVGScriptElement::cloneElementWithoutAttributesAndChildren):
        * svg/SVGScriptElement.h:

2010-11-30  Darin Adler  <darin@apple.com>

        Rolled back most of the FileReaderLoader changes to fix 32-bit builds.

        * fileapi/FileReaderLoader.cpp: Changed types back to unsigned from unsigned long long
        * fileapi/FileReaderLoader.h: Ditto.

2010-11-30  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        Text search should treat all matches as word-start matches when the target begins with a separator character
        https://bugs.webkit.org/show_bug.cgi?id=50302

        * editing/TextIterator.cpp:
        (WebCore::SearchBuffer::SearchBuffer): Disable the AtWordStarts option if it was specified and
        the target string begins with one of the "separator" characters.

2010-11-30  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Dave Hyatt.

        Web Inspector: [CRASH] on "Revert to this revision" of style with import.
        https://bugs.webkit.org/show_bug.cgi?id=50256

        Rolled back one line from http://trac.webkit.org/changeset/36904 as agreed with
        David.

        * css/CSSImportRule.cpp:
        (WebCore::CSSImportRule::insertedIntoParent):

2010-11-30  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] fillRect shadow has incorrect behavior when using ctx.scale(x,y)
        https://bugs.webkit.org/show_bug.cgi?id=50283

        Adjust the mask rectangle for Cairo shadows, so that the origin
        is not affected by the scale of the transformation matrix.

        * platform/graphics/ContextShadow.h: Make this Qt-only member global.
        * platform/graphics/cairo/ContextShadowCairo.cpp:
        (WebCore::ContextShadow::beginShadowLayer): Save the original layer area.
        (WebCore::ContextShadow::endShadowLayer): If the target context has a scale
        transform, make sure not to scale the blur distance when blitting the shadow.

2010-11-30  Darin Adler  <darin@apple.com>

        Reviewed by Alexey Proskuryakov.

        Make ProgressEvent 64-bit instead of 32-bit
        https://bugs.webkit.org/show_bug.cgi?id=50289

        * dom/ProgressEvent.cpp:
        (WebCore::ProgressEvent::ProgressEvent): Changed arguments to unsigned long long.
        (WebCore::ProgressEvent::initProgressEvent): Ditto.

        * dom/ProgressEvent.h: Fixed formatting. Changed types to unsigned long long.
        Made isProgressEvent override private.

        * dom/ProgressEvent.idl: Tweaked formatting and changed types to unsigned long long.

        * fileapi/FileReader.cpp: Removed unneeded includes.
        Used static on const so we'd get an error if the same constant was in a header.
        (WebCore::FileReader::didReceiveData): Removed unneeded WTF prefix.
        (WebCore::FileReader::fireEvent): Got rid of local variables that would narrow
        bytes loaded and total bytes to 32-bit.

        * fileapi/FileReaderLoader.cpp:
        (WebCore::FileReaderLoader::didReceiveResponse): Restructured code a bit and
        added comments. Also added handling for when ArrayBuffer::create returns 0.
        (WebCore::FileReaderLoader::didReceiveData): Fixed handling of case where more
        data arrives than is expected so it won't overrun the buffer. Also broke an
        assertion into two and improved a comment.

        * fileapi/FileReaderLoader.h: Changed bytesLoaded and totalBytes to unsigned long long.

        * fileapi/FileWriter.cpp:
        (WebCore::FileWriter::fireEvent): Removed narrowing casts in call to
        ProgressEvent::create.

        * html/canvas/ArrayBuffer.cpp:
        (WebCore::ArrayBuffer::tryAllocate): Added a comment because the code here seems wrong.

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::didSendData): Removed narrowing casts in call to
        XMLHttpRequestProgressEvent::create.
        (WebCore::XMLHttpRequest::didReceiveData): Removed narrowing casts in call to
        dispatchProgressEvent.

        * xml/XMLHttpRequestProgressEvent.h: Fixed formatting. Changed types to unsigned long long.
        Made isXMLHttpRequestProgressEvent override private.

        * xml/XMLHttpRequestProgressEvent.idl: Tweaked formatting and changed types to unsigned long long.

        * xml/XMLHttpRequestProgressEventThrottle.cpp:
        (WebCore::XMLHttpRequestProgressEventThrottle::dispatchProgressEvent): Changed types to
        unsigned long long.

        * xml/XMLHttpRequestProgressEventThrottle.h: Changed types to unsigned long long.

2010-11-30  Yael Aharon  <yael.aharon@nokia.com>

        Reviewed by Darin Adler.

        Progress and meter elements should take a form in their constructor like any other form control.
        https://bugs.webkit.org/show_bug.cgi?id=50195

        Tests: fast/dom/HTMLMeterElement/meter-element-form.html
               fast/dom/HTMLProgressElement/progress-element-form.html

        * html/HTMLMeterElement.cpp:
        (WebCore::HTMLMeterElement::HTMLMeterElement):
        (WebCore::HTMLMeterElement::create):
        * html/HTMLMeterElement.h:
        * html/HTMLProgressElement.h:
        * html/HTMLTagNames.in:

2010-11-30  Tony Chang  <tony@chromium.org>

        Reviewed by Adam Barth.

        [chromium] fix get-int-identifier-special-values.html using TestNetscapePlugIn
        https://bugs.webkit.org/show_bug.cgi?id=49036

        No new tests: Covered by plugins/npruntime/get-int-identifier-special-values.html

        In http://codereview.chromium.org/11574, the forked chromium test
        plugin changed how it testGetIntIdentifier to work around a change
        caused by a silverlight specific plugin fix:
        http://codereview.chromium.org/11569/diff/1/2

        It's not clear to me that this change is needed anymore since
        silverlight has had multiple releases, testing without this patch
        works on a test windows build, and safari win seems to run silverlight
        without this either.  Since there's no test for this behavior, I'm
        rolling it out so we can match the upstream test.

        * bindings/v8/V8NPUtils.cpp:
        (WebCore::convertV8ObjectToNPVariant):

2010-11-30  Chris Guillory  <chris.guillory@google.com>

        Reviewed by Chris Fleizach.

        Computing style on a stale node while sending pending accessibility notification.
        https://bugs.webkit.org/show_bug.cgi?id=50162

        Retain node pointer members of AccessibilityImageMapLink.

        Test: accessibility/image-map-title-causes-crash.html

        * accessibility/AccessibilityImageMapLink.cpp:
        (WebCore::AccessibilityImageMapLink::parentObject):
        (WebCore::AccessibilityImageMapLink::anchorElement):
        (WebCore::AccessibilityImageMapLink::url):
        (WebCore::AccessibilityImageMapLink::elementRect):
        * accessibility/AccessibilityImageMapLink.h:
        (WebCore::AccessibilityImageMapLink::areaElement):
        (WebCore::AccessibilityImageMapLink::mapElement):
        (WebCore::AccessibilityImageMapLink::node):
        * dom/Document.cpp:
        (WebCore::Document::clearAXObjectCache):

2010-11-30  James Robinson  <jamesr@chromium.org>

        Reviewed by Tony Chang.

        Build fix - add parens in foo || bar && baz to make gcc happy
        https://bugs.webkit.org/show_bug.cgi?id=50276

        gcc 4.4 warns that statements of the form "foo || bar && baz".  It wants
        parens around the "bar && baz" part to make it clear which way the logical
        operators bind.

        * editing/TextIterator.cpp:
        (WebCore::SearchBuffer::search):

2010-11-30  Daniel Bates  <dbates@rim.com>

        Reviewed by David Hyatt.

        Focused <area> should use CSS properties of <area> instead of associated <img>
        https://bugs.webkit.org/show_bug.cgi?id=49888

        Fixes an issue where the CSS properties of an <area> were not used when
        the <area> was focused.

        Currently, when focusing an <area> (say by pressing option + tab in Mac
        Safari) we use the CSS style information for the <img> associated with
        the <area>. Instead, we should use the CSS style information for the
        focused <area>. In particular, this will make the us honor the outline-
        color property of a focused <area> when drawing its focus ring.

        Tests: fast/images/imagemap-focus-ring-outline-color-explicitly-inherited-from-map.html
               fast/images/imagemap-focus-ring-outline-color-not-inherited-from-map.html
               fast/images/imagemap-focus-ring-outline-color.html

        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::paintFocusRing): Use the style information of
        the focused <area> when drawing the focus ring for it.

2010-11-30  Tony Chang  <tony@chromium.org>

        Reviewed by James Robinson.

        [chromium] enable WebCore compiler warnings on Linux take 3
        https://bugs.webkit.org/show_bug.cgi?id=50258

        * WebCore.gyp/WebCore.gyp:

2010-11-30  Mario Sanchez Prada  <msanchez@igalia.com>

        Reviewed by Chris Fleizach.

        [GTK] Implement ROLE_COMBO_BOX
        https://bugs.webkit.org/show_bug.cgi?id=25678

        Implement the remaining bits for combo boxes.

        This patch finishes the implementation, from the point of view of
        the Atk library, of those objects exposed to ATK as combo boxes,
        and their related elements (menus and menu items). It therefore
        implements the proper interfaces for each type of object related
        to combo boxes (AtkSelection for the combo box, AtkText for every
        menu item and AtkAction for the combo box, the menu and the menu
        items), takes care of emitting the proper signals when focus or a
        given a selection changes and adds a new unit test to check all
        this new stuff.

        Make possible to ask an AccessibleMenuListOption for a sensible
        string representation, so far only available through the private
        and MSAA related method nameForMSAA. Just moved the implementation
        of that method to an overriden version of stringValue(), which is
        platform independent, and called that from nameForMSAA().

        * accessibility/AccessibilityMenuListOption.h:
        * accessibility/AccessibilityMenuListOption.cpp:
        (WebCore::AccessibilityMenuListOption::nameForMSAA): Just call to
        stringValue(), which holds from now on that used to be here.
        (WebCore::AccessibilityMenuListOption::stringValue): New, override
        of AccessibilityObject::stringValue() to return a proper string.

        Emit the missing signals when a selection is made.

        * accessibility/gtk/AXObjectCacheAtk.cpp:
        (WebCore::AXObjectCache::postPlatformNotification): Emit the usual
        'focus' signals when a selection is made over the combo box.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (setAtkStateSetFromCoreObject): Ensure the EXPANDABLE and EXPANDED
        Atk states are added to the state set when needed.
        (listObjectForSelection): New, returns the proper list object (the
        one holding the list of available options as its children) for an
        specific AtkObject implementing AtkSelection. This is needed
        because sometimes the selectable options are not directly children
        of the AtkSelection object (i.e. a combo box has a 'menu' object
        as its only child of it, holding the list of options as children).
        (optionFromList): Use listObjectForSelection() to get the actual
        object holding the list of children as the available options.
        (optionFromSelection): Add support for combo boxes.
        (webkit_accessible_selection_add_selection): Ditto.
        (webkit_accessible_selection_clear_selection): Ditto.
        (webkit_accessible_selection_get_selection_count): Ditto.
        (webkit_accessible_selection_is_child_selected): Ditto.
        (webkit_accessible_selection_remove_selection): Ditto.
        (webkit_accessible_text_get_text): Makes sure stringValue() is
        considered to get the result substring when it was already
        considered when checking the maximum text length for the object.
        (getInterfaceMaskFromObject): Make sure the AtkSelection interface
        is implemented for the combo boxes, that the AtkText is
        implemented for the menu items and that the AtkAction interface is
        now implemented for every object (WebCore will decide what to do).

        Avoid a segfault crash when using this from unit tests.

        * platform/gtk/PopupMenuGtk.cpp:
        (WebCore::PopupMenuGtk::show): Make sure we got a valid GdkWindow
        before calling gdk_window_get_origin() over it.

2010-11-30  Andreas Kling  <kling@webkit.org>

        Reviewed by Tor Arne Vestbø.

        [Qt] GraphicsContext: Avoid unnecessarily copying the painter's QTransform

        Stash the transform in a const reference (QPainter::transform() returns one)
        instead of making a copy in the shadow drawing parts of fillPath, strokePath and fillRect.

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::fillRect):

2010-11-30  Vangelis Kokkevis  <vangelis@chromium.org>

        Reviewed by Simon Fraser.

        Provide more fine grained control to ports over when to turn on 
        accelerated compositing.
        https://bugs.webkit.org/show_bug.cgi?id=49998

        The RenderLayerCompositor now checks with the chrome client whether
        3d transforms, video, plugins, canvas and animation require
        switching over to the composited path. Layers that overlap composited
        content will still turn into composited layers regardless of the
        setting.

        * css/MediaQueryEvaluator.cpp:
        (WebCore::transform_3dMediaFeatureEval):
        * page/ChromeClient.h:
        (WebCore::ChromeClient::allowedCompositingTriggers):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::canRender3DTransforms):
        (WebCore::RenderLayer::updateTransform):
        (WebCore::RenderLayer::currentTransform):
        * rendering/RenderLayer.h:
        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::updateLayerTransform):
        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::RenderLayerCompositor):
        (WebCore::RenderLayerCompositor::cacheAcceleratedCompositingFlags):
        (WebCore::RenderLayerCompositor::canRender3DTransforms):
        (WebCore::RenderLayerCompositor::requiresCompositingLayer):
        (WebCore::RenderLayerCompositor::requiresCompositingForTransform):
        (WebCore::RenderLayerCompositor::requiresCompositingForVideo):
        (WebCore::RenderLayerCompositor::requiresCompositingForCanvas):
        (WebCore::RenderLayerCompositor::requiresCompositingForPlugin):
        (WebCore::RenderLayerCompositor::requiresCompositingForAnimation):
        * rendering/RenderLayerCompositor.h:

2010-11-30  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Plug leak in SoupCache
        https://bugs.webkit.org/show_bug.cgi?id=50142

        Free the cache file contents when we don't need them anymore.

        * platform/network/soup/cache/webkit/soup-cache.c:
        (webkit_soup_cache_load):

2010-11-30  Andras Becsi  <abecsi@webkit.org>

        Reviewed by Csaba Osztrogonác.

        [Qt][V8] Make QtWebKit with V8 build on Linux.
        https://bugs.webkit.org/show_bug.cgi?id=50244

        No new tests needed.

        * WebCore.pri: add missing idl file
        * WebCore.pro: enable Linux build
        * bindings/scripts/CodeGeneratorV8.pm: add missing headers
        * bindings/v8/ScriptControllerQt.cpp: fix instantiation
        (WebCore::ScriptController::qtScriptEngine):
        * bindings/v8/V8GCController.cpp: fix guard
        (WebCore::V8GCController::checkMemoryUsage):
        * inspector/CodeGeneratorInspector.pm: add missing header
        * loader/ResourceLoadScheduler.cpp: ditto
        * loader/cache/MemoryCache.cpp: ditto
        * loader/loader.cpp: ditto

2010-11-30  David Hyatt  <hyatt@apple.com>

        Reviewed by Simon Fraser.
        
        https://bugs.webkit.org/show_bug.cgi?id=50183
        
        Code got commented out by accident during render tree refactoring last year.  Put the code back in, since
        it hurts performance to have that line commented out.

        In order to put this code back in, I had to fix some bugs with preferred width computations and
        overflow: scroll.  Make the pref widths computation create the scrollbar if it doesn't exist yet.

        Make sure the scrollbar size is included prior to checking for defined width/min-width/max-width values.  Otherwise
        the scrollbar inflates the width beyond the fixed size that was specified.
        
        For table cells, there is an additional wrinkle.  Make sure not to include the scrollbar size as part of the minimum
        intrinsic width so that we don't incorrectly grow.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::layoutPositionedObjects):
        (WebCore::RenderBlock::computePreferredLogicalWidths):
        * rendering/RenderFlexibleBox.cpp:
        (WebCore::RenderFlexibleBox::computePreferredLogicalWidths):

2010-11-30  Vitaly Repeshko  <vitalyr@chromium.org>

        Unreviewed.

        Attempt to fix windows debug chromium build.

        * html/TimeInputType.cpp: Added include providing isfinite.

2010-11-30  Darin Adler  <darin@apple.com>

        Reviewed by Jon Honeycutt.

        DOM binding code generator scripts import unused File::stat Perl module
        https://bugs.webkit.org/show_bug.cgi?id=50250

        * bindings/scripts/CodeGeneratorCPP.pm: Removed "using File::stat".
        * bindings/scripts/CodeGeneratorJS.pm: Ditto.
        * bindings/scripts/CodeGeneratorObjC.pm: Ditto.
        * bindings/scripts/CodeGeneratorV8.pm: Ditto.

2010-11-30  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: implement "Revert to this revision" in resources panel.
        https://bugs.webkit.org/show_bug.cgi?id=50107

        * inspector/Inspector.idl:
        * inspector/InspectorCSSAgent.cpp:
        (WebCore::InspectorCSSAgent::setStyleSheetText2):
        * inspector/InspectorCSSAgent.h:
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::InspectorStyleSheet::reparseStyleSheet):
        * inspector/front-end/CSSStyleModel.js:
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged.callback):
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged):
        (WebInspector.CSSStyleModel.prototype._onRevert):
        * inspector/front-end/Resource.js:
        (WebInspector.Resource.prototype.get contentTimestamp):
        (WebInspector.Resource.prototype.setInitialContent):
        (WebInspector.Resource.prototype.isLocallyModified):
        (WebInspector.Resource.prototype.setContent.else.finished):
        (WebInspector.Resource.prototype.setContent):
        (WebInspector.Resource.prototype.revertToThis.callback):
        (WebInspector.Resource.prototype.revertToThis):
        (WebInspector.Resource.prototype.get baseRevision):
        (WebInspector.Resource.prototype._innerRequestContent):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel.prototype._showResourceView):
        (WebInspector.FrameResourceTreeElement.prototype._contentChanged):
        (WebInspector.ResourceRevisionTreeElement):
        (WebInspector.ResourceRevisionTreeElement.prototype.onattach):
        (WebInspector.ResourceRevisionTreeElement.prototype._ondragstart):
        (WebInspector.ResourceRevisionTreeElement.prototype._handleContextMenuEvent):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.editScriptSource.mycallback):
        (WebInspector.ScriptsPanel.prototype.editScriptSource):
        * inspector/front-end/SourceView.js:
        (WebInspector.SourceView.prototype._editLine):
        (WebInspector.SourceView.prototype._editLineComplete):
        (WebInspector.SourceView.prototype._revertEditLine):

2010-11-30  Adam Roben  <aroben@apple.com>

        Clean up WebCore.vcproj's bindings filter

        I added files that we compile (via an all-in-one file) but weren't in
        the .vcproj, removed files that no longer exist, and added the scripts
        we use.

        Fixes <http://webkit.org/b/50248> WebCore.vcproj's bindings filter is
        out-of-date

        Reviewed by Darin Adler.

        * WebCore.vcproj/WebCore.vcproj:

2010-11-30  Adam Roben  <aroben@apple.com>

        Move JSIDB* files to the DerivedSources filter

        This correctly reflects their location on disk. (They were formerly
        listed under bindings/js.)

        * WebCore.vcproj/WebCore.vcproj:

2010-11-30  Xiaomei Ji  <xji@chromium.org>

        Reviewed by David Hyatt.

        Remove clampNegativeToZero in adjustScrollPositionWithinRange.
        https://bugs.webkit.org/show_bug.cgi?id=50203

        * platform/ScrollView.cpp:
        (WebCore::ScrollView::adjustScrollPositionWithinRange):

2010-11-30  Adam Roben  <aroben@apple.com>

        Remove duplicate files from WebCore.vcproj

        Rubber-stamped by Steve Falkenburg.

        * WebCore.vcproj/WebCore.vcproj:

2010-11-30  Adam Roben  <aroben@apple.com>

        Let VS do its thang with WebCore.vcproj

        I just removed and readded AnimationBase.cpp.

        Rubber-stamped by Steve Falkenburg.

        * WebCore.vcproj/WebCore.vcproj:

2010-11-30  Mario Sanchez Prada  <msanchez@igalia.com>

        Reviewed by Chris Fleizach.

        ASSERT failing for combo boxes when selection changes
        https://bugs.webkit.org/show_bug.cgi?id=50062

        Don't call listBoxOnChange for elements using menu lists.

        Test: fast/forms/select-option-accesskey-crash.html

        * dom/SelectElement.cpp:
        (WebCore::SelectElement::accessKeySetSelectedIndex): Extra check
        to decide whether to call menuListOnChange() or listBoxOnChange()
        instead of always calling listBoxOnChange().

2010-11-30  Andreas Kling  <kling@webkit.org>

        Reviewed by Dirk Schulze.

        GraphicsContext: Remove "current path" and have strokePath, fillPath and clipPath take a Path argument.
        https://bugs.webkit.org/show_bug.cgi?id=48516

        No new tests, this is refactoring only.

        fillPath() -> fillPath(const Path&)
        strokePath() -> strokePath(const Path&)
        clipPath(WindRule) -> clipPath(const Path&, WindRule)

        drawPath() was only used by CG, so made it PLATFORM(CG) specific.

        The Qt, CG and Cairo implementations are best-effort.
        For the rest, I've put beginPath/addPath and FIXMEs in the three affected methods.

        * WebCore.exp.in:
        * html/canvas/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::fill):
        (WebCore::CanvasRenderingContext2D::stroke):
        * inspector/InspectorController.cpp:
        (WebCore::drawOutlinedQuad):
        * mathml/RenderMathMLRoot.cpp:
        (WebCore::RenderMathMLRoot::paint):
        * mathml/RenderMathMLSquareRoot.cpp:
        (WebCore::RenderMathMLSquareRoot::paint):
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/GraphicsContextPrivate.h:
        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::clipPath):
        * platform/graphics/cairo/GraphicsContextPlatformPrivateCairo.h:
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::drawEllipse):
        (WebCore::addConvexPolygonToPath):
        (WebCore::GraphicsContext::drawConvexPolygon):
        (WebCore::GraphicsContext::clipConvexPolygon):
        (WebCore::GraphicsContext::drawPath):
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::fillRoundedRect):
        (WebCore::GraphicsContext::clipPath):
        * platform/graphics/haiku/GraphicsContextHaiku.cpp:
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::fillPath):
        * platform/graphics/openvg/GraphicsContextOpenVG.cpp:
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::clipPath):
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::restorePlatformState):
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::clipPath):
        (WebCore::GraphicsContext::strokeRect):
        (WebCore::GraphicsContext::translate):
        (WebCore::GraphicsContext::rotate):
        (WebCore::GraphicsContext::scale):
        (WebCore::GraphicsContext::concatCTM):
        * platform/graphics/skia/GraphicsContextSkia.cpp:
        (WebCore::GraphicsContext::clipPath):
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        * platform/graphics/wince/GraphicsContextWinCE.cpp:
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::clipPath):
        * platform/graphics/wx/GraphicsContextWx.cpp:
        (WebCore::GraphicsContext::clipPath):
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::paintBorder):
        (WebCore::RenderBoxModelObject::paintBoxShadow):
        * rendering/RenderEmbeddedObject.cpp:
        (WebCore::RenderEmbeddedObject::paintReplaced):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::drawBoxSideFromPath):
        * rendering/RenderSVGResource.h:
        (WebCore::RenderSVGResource::postApplyResource):
        * rendering/RenderSVGResourceClipper.cpp:
        (WebCore::RenderSVGResourceClipper::pathOnlyClipping):
        * rendering/RenderSVGResourceFilter.cpp:
        (WebCore::RenderSVGResourceFilter::postApplyResource):
        * rendering/RenderSVGResourceFilter.h:
        * rendering/RenderSVGResourceGradient.cpp:
        (WebCore::RenderSVGResourceGradient::applyResource):
        * rendering/RenderSVGResourceGradient.h:
        * rendering/RenderSVGResourcePattern.cpp:
        (WebCore::RenderSVGResourcePattern::postApplyResource):
        * rendering/RenderSVGResourcePattern.h:
        * rendering/RenderSVGResourceSolidColor.cpp:
        (WebCore::RenderSVGResourceSolidColor::postApplyResource):
        * rendering/RenderSVGResourceSolidColor.h:
        * rendering/SVGRenderSupport.cpp:
        (WebCore::SVGRenderSupport::finishRenderSVGContent):
        * rendering/svg/RenderSVGPath.cpp:
        (WebCore::RenderSVGPath::fillAndStrokePath):
        * rendering/svg/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::releasePaintingResource):
        (WebCore::SVGInlineTextBox::restoreGraphicsContextAfterTextPainting):
        (WebCore::SVGInlineTextBox::paintDecorationWithStyle):
        * rendering/svg/SVGInlineTextBox.h:
        * svg/SVGFont.cpp:
        (WebCore::Font::drawTextUsingSVGFont):

2010-11-30  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Darin Adler and Geoff Garen.

        https://bugs.webkit.org/show_bug.cgi?id=44152
        <rdar://problem/8324423> CSSOM should match DOM in discarding wrapper-less parents.

        We have existing behaviors where parent objects in detached subtrees are not preserved:
        - if a root of a node tree doesn't have a wrapper, it's immediately destroyed, making
        its children parentNode attribute null;
        - relationship between a <style> or <link> node and its stylesheet is immediately broken
        when the node is removed from document (in this case, regardless of wrapper existence).

        Both match Firefox. For consistency, CSSOM should do the same. In fact, it already partially
        does - CSSRule.parentRule gets zeroed out when the parent rule is destroyed.

        Tests: fast/dom/StyleSheet/detached-parent-rule-without-wrapper.html
               fast/dom/StyleSheet/detached-stylesheet-without-wrapper.html

        * css/StyleSheet.cpp: (WebCore::StyleSheet::~StyleSheet): Clear out child rule parent.

        * svg/SVGFontFaceElement.cpp: (WebCore::SVGFontFaceElement::insertedIntoDocument): Keep
        the new assertion from firing. This function was adding a rule to style sheet, without
        telling the rule about it.

2010-11-30  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Adam Roben.

        All projects on Windows should use cmd files for build events
        https://bugs.webkit.org/show_bug.cgi?id=50213

        * WebCore.vcproj/QTMovieWinCommon.vsprops:
        * WebCore.vcproj/QTMovieWinPostBuild.cmd: Added.
        * WebCore.vcproj/QTMovieWinPreBuild.cmd: Added.
        * WebCore.vcproj/WebCoreCommon.vsprops:
        * WebCore.vcproj/WebCorePostBuild.cmd: Added.
        * WebCore.vcproj/WebCorePreBuild.cmd: Added.

2010-11-30  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72914.
        http://trac.webkit.org/changeset/72914
        https://bugs.webkit.org/show_bug.cgi?id=50241

        "pfeldman has a revision management patch both for CSS and JS"
        (Requested by apavlov on #webkit).

        * English.lproj/localizedStrings.js:
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::InspectorStyleSheet::reparseStyleSheet):
        * inspector/front-end/CSSStyleModel.js:
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged.callback):
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged):
        (WebInspector.CSSStyleSheet.prototype.getText):
        (WebInspector.CSSStyleSheet.prototype.setText):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourceRevisionTreeElement.prototype.onattach):
        (WebInspector.ResourceRevisionTreeElement.prototype._ondragstart):

2010-11-25  Satish Sampath  <satish@chromium.org>

        Reviewed by Kent Tamura.

        Fix rendering of speech button when setting the attribute dynamically.
        https://bugs.webkit.org/show_bug.cgi?id=50077

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::parseMappedAttribute):
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::speechAttributeChanged):
        * rendering/RenderTextControlSingleLine.h:

2010-11-30  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: Enable switching between revisions of stylesheets
        https://bugs.webkit.org/show_bug.cgi?id=50227

        Drive-by fix: styleSheetChanged() call needed after a stylesheet reparsing on setStyleSheetText2().

        * English.lproj/localizedStrings.js:
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::InspectorStyleSheet::reparseStyleSheet):
        * inspector/front-end/CSSStyleModel.js:
        (WebInspector.CSSStyleModel.prototype.setStyleSheetText):
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged.callback):
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged):
        (WebInspector.CSSStyleSheet.prototype.getText):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourceRevisionTreeElement.prototype.onattach):
        (WebInspector.ResourceRevisionTreeElement.prototype._ondragstart):
        (WebInspector.ResourceRevisionTreeElement.prototype._handleContextMenuEvent):

2010-11-30  John Knottenbelt  <jknotten@chromium.org>

        Reviewed by David Levin.

        V8 binding for DOMTimeStamp should be Number, not Date
        https://bugs.webkit.org/show_bug.cgi?id=49963

        Test: fast/dom/domtimestamp-is-number.html

        * bindings/scripts/CodeGeneratorV8.pm:

2010-11-30  Renata Hodovan  <reni@inf.u-szeged.hu>

        Reviewed by Andreas Kling.

        [Qt] Leak with GraphicsContext::takeOwnershipOfPlatformContext()
        https://bugs.webkit.org/show_bug.cgi?id=49916

        Change the order of calling QPainter::device() and QPainter::end(), so device() will return with a valid device.
        No new test is needed.

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContextPlatformPrivate::~GraphicsContextPlatformPrivate):

2010-11-30  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Andreas Kling.

        Move generator logic into main CMakeLists.txt file
        https://bugs.webkit.org/show_bug.cgi?id=49885

        Also make the generator calls more portable.

        * CMakeLists.txt:

2010-11-30  Mario Sanchez Prada  <msanchez@igalia.com>

        Unreviewed, rolling out r72902.
        http://trac.webkit.org/changeset/72902
        https://bugs.webkit.org/show_bug.cgi?id=50062

        This change is causing layout test failures on the Tests bots
        for the mac platform.

        * dom/SelectElement.cpp:
        (WebCore::SelectElement::accessKeySetSelectedIndex):

2010-11-30  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72764.
        http://trac.webkit.org/changeset/72764
        https://bugs.webkit.org/show_bug.cgi?id=50215

        This change is causing assertion failures on the debug bots.
        (Requested by mrobinson on #webkit).

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (webkit_accessible_get_name):
        (webkit_accessible_detach):

2010-11-30  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: make copy(node) work in console.
        https://bugs.webkit.org/show_bug.cgi?id=50180

        * inspector/front-end/InjectedScript.js:
        (injectedScriptConstructor.):

2010-11-30  Mario Sanchez Prada  <msanchez@igalia.com>

        Reviewed by Darin Adler.

        ASSERT failing for combo boxes when selection changes
        https://bugs.webkit.org/show_bug.cgi?id=50062

        Don't call listBoxOnChange for elements using menu lists.

        Test: accessibility/select-menulist-crash.html

        * dom/SelectElement.cpp:
        (WebCore::SelectElement::accessKeySetSelectedIndex): Extra check
        to decide whether to call menuListOnChange() or listBoxOnChange()
        instead of always calling listBoxOnChange().

2010-11-30  Helder Correia  <helder@sencha.com>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] Path stroke shadow has incorrect behavior when using ctx.scale(x,y)
        https://bugs.webkit.org/show_bug.cgi?id=50198

        Handle the special case when scaling is used and translate the shadow
        offset accordingly. The correct behavior is ensured in ContextShadow
        already, the issue only happens when using a non-blur shadow.

        Test: fast/canvas/canvas-scale-strokePath-shadow.html

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::strokePath):

2010-11-30  Helder Correia  <helder@sencha.com>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] Path filling should keep shadow offset after context scaling
        https://bugs.webkit.org/show_bug.cgi?id=50194

        Handle the special case when scaling is used and translate the shadow
        offset accordingly. The correct behavior is ensured in ContextShadow
        already, the issue only happens when using a non-blur shadow.

        Test: fast/canvas/canvas-scale-fillPath-shadow.html

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::fillPath):

2010-11-30  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: make ScriptCallStack and ScriptArguments reference counted
        https://bugs.webkit.org/show_bug.cgi?id=50156

        No new tests. This refactoring is covered with existing inspector tests.

        * bindings/js/JSConsoleCustom.cpp:
        (WebCore::JSConsole::profile):
        (WebCore::JSConsole::profileEnd):
        * bindings/js/ScriptCallStackFactory.cpp:
        (WebCore::createScriptCallStack):
        (WebCore::createScriptArguments):
        * bindings/js/ScriptCallStackFactory.h:
        * bindings/scripts/CodeGeneratorJS.pm:
        * bindings/scripts/CodeGeneratorV8.pm:
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::jsTestObjPrototypeFunctionCustomArgsAndException):
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjInternal::customArgsAndExceptionCallback):
        * bindings/v8/ScriptCallStackFactory.cpp:
        (WebCore::createScriptCallStack):
        (WebCore::createScriptArguments):
        * bindings/v8/ScriptCallStackFactory.h:
        * bindings/v8/V8ConsoleMessage.cpp:
        (WebCore::V8ConsoleMessage::handler):
        (WebCore::V8ConsoleMessage::dispatchNow):
        * bindings/v8/V8ConsoleMessage.h:
        * bindings/v8/custom/V8ConsoleCustom.cpp:
        (WebCore::V8Console::traceCallback):
        (WebCore::V8Console::assertCallback):
        (WebCore::V8Console::profileCallback):
        (WebCore::V8Console::profileEndCallback):
        * inspector/ConsoleMessage.cpp:
        (WebCore::ConsoleMessage::ConsoleMessage):
        * inspector/ConsoleMessage.h:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::addMessageToConsole):
        (WebCore::InspectorController::startGroup):
        * inspector/InspectorController.h:
        * inspector/ScriptArguments.cpp:
        (WebCore::ScriptArguments::create):
        * inspector/ScriptArguments.h:
        * inspector/ScriptCallFrame.h:
        * inspector/ScriptCallStack.cpp:
        (WebCore::ScriptCallStack::create):
        (WebCore::ScriptCallStack::at):
        (WebCore::ScriptCallStack::size):
        * inspector/ScriptCallStack.h:
        * page/Console.cpp:
        (WebCore::Console::addMessage):
        (WebCore::Console::debug):
        (WebCore::Console::error):
        (WebCore::Console::info):
        (WebCore::Console::log):
        (WebCore::Console::dir):
        (WebCore::Console::dirxml):
        (WebCore::Console::trace):
        (WebCore::Console::assertCondition):
        (WebCore::Console::count):
        (WebCore::Console::markTimeline):
        (WebCore::Console::profile):
        (WebCore::Console::profileEnd):
        (WebCore::Console::timeEnd):
        (WebCore::Console::group):
        (WebCore::Console::groupCollapsed):
        (WebCore::Console::warn):
        * page/Console.h:

2010-11-29  Dan Bernstein  <mitz@apple.com>

        Build fix for non-ICU platforms after r72887.

        * editing/TextIterator.cpp:
        (WebCore::SearchBuffer::prependContext):

2010-11-29  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        WebCore part of <rdar://problem/8650085> adding word-prefix search options to the text search API.
        https://bugs.webkit.org/show_bug.cgi?id=50038

        Test: editing/text-iterator/findString.html

        * GNUmakefile.am: Added FindOptions.h.
        * WebCore.exp.in: Export the new methods that take FindOptions.
        * WebCore.gypi: Added FindOptions.h.
        * WebCore.pro: Added FindOptions.h and TextBoundaries.{cpp,h}.
        * WebCore.vcproj/WebCore.vcproj: Added FindOptions.h.
        * WebCore.xcodeproj/project.pbxproj: Added FindOptions.h and TextBoundaries.cpp.
        * editing/Editor.cpp:
        (WebCore::Editor::firstVisibleRange): Changed to use FindOptions.
        (WebCore::Editor::lastVisibleRange): Ditto.
        (WebCore::Editor::nextVisibleRange): Ditto.
        (WebCore::Editor::findString): Ditto.
        (WebCore::Editor::countMatchesForText): Ditto.
        * editing/Editor.h: Added a version of findString() that takes FindOptions. Changed
        countMatchesForText() to take FindOptions. Made nextVisibleRange() private and changed it
        and firstVisibleRange() and lastVisibleRange() to take FindOptions.
        * editing/FindOptions.h: Added.
        * editing/TextIterator.cpp:
        Augmented SearchBuffer with an optional prefix, which is not searched, but provides context
        for determining word boundaries.
        (WebCore::isSeparator): Added. Identifies a class of characters used to determine where
        “words” are embedded in a word.
        (WebCore::SearchBuffer::SearchBuffer): Changed to take FindOptions. Added initialization of
        m_options, m_prefixLength and m_needsMoreContext.
        (WebCore::SearchBuffer::append): Adjust m_prefixLength as part of the prefix gets pushed out
        of the buffer.
        (WebCore::SearchBuffer::needsMoreContext): Added.
        (WebCore::SearchBuffer::prependContext): Added.
        (WebCore::SearchBuffer::isWordStartMatch): Added.
        (WebCore::SearchBuffer::search): Changed to account for the context prefix. When searching
        only for word prefix matches, maintains enough context before a tentative match when moving
        it to the beginning of the buffer. Reject matches that are not at word starts if requested.
        Adjust m_prefixLength when pushing characters out of the buffer.
        (WebCore::findPlainText): Changed to work with FindOptions. Feed the search buffer with context
        if and as long as it requires more of it.
        * editing/TextIterator.h: Added a version of findPlainText() that takes FindOptions.
        * editing/visible_units.cpp: Moved {end,start}Of{First,Last}WordBoundary to TextBoundaries.cpp.
        * page/Page.cpp:
        (WebCore::Page::findString): Changed to work with FindOptions.
        (WebCore::Page::markAllMatchesForText): Ditto.
        * page/Page.h: Added FindOptions-based findString() and markAllMatchesForText().
        * platform/text/TextBoundaries.cpp:
        (WebCore::endOfFirstWordBoundaryContext): Moved here from visible_units.cpp.
        (WebCore::startOfLastWordBoundaryContext): Ditto.
        * platform/text/TextBoundaries.h:

2010-11-29  Dai Mikurube  <dmikurube@google.com>

        Reviewed by Kent Tamura.

        when empty, clicking "down" on outer-spin-button returns "max value"
        https://bugs.webkit.org/show_bug.cgi?id=45491

        Modified stepping-up/down from renderer
        - to clamp steps,
        - to handle empty values (described below), and
        - to apply them for range type inputs.

        Stepping-up/down for empty values are handled "the empty as 0."
        For example :
        * If 0 is in-range, and matches to step value
          "down" -> -step
          "up" -> +step
          If -step or +step is out of range, new value should be 0.

        * If 0 is smaller than the minimum value
          "down" -> the minimum value
          "up" -> the minimum value

        * If 0 is larger than the maximum value
          "down" -> the maximum value
          "up" -> the maximum value

        * If 0 is in-range, but not matched to step value
          "down" -> smaler matched value nearest to 0.
            e.g. <input type=number min=-100 step=3> -> -1
          "up" -> larger matched value nearest to 0.
            e.g. <input type=number min=-100 step=3> -> 2

        As for date/datetime-local/month/time/week types, the empty is assumed as "current local date/time".
        As for datetime type, the empty is assumed as "current date/time in UTC".

        As for range input types, changed stepping from renderer to use stepUpFromRenderer().
        It was calculated with stepUp() from RangeInputType::handleKeydownEvent().

        Test: fast/forms/input-stepup-stepdown-from-renderer.html

        * html/BaseDateAndTimeInputType.cpp:
        (WebCore::BaseDateAndTimeInputType::defaultValueForStepUp): Added defaultValueForStepUp() which returns the current local time
        * html/BaseDateAndTimeInputType.h:
        * html/DateTimeInputType.cpp:
        (WebCore::DateTimeInputType::defaultValueForStepUp): Added defaultValueForStepUp() which returns the current UTC time
        * html/DateTimeInputType.h:
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::stepUpFromRenderer): Modified it to clamp steps, support empty values and support range type inputs
        * html/HTMLInputElement.h:
        (WebCore::HTMLInputElement::isRangeControl):
        * html/InputType.cpp:
        (WebCore::InputType::defaultValueForStepUp): Added defaultValueForStepUp() which returns 0
        * html/InputType.h:
        * html/MonthInputType.cpp:
        (WebCore::MonthInputType::defaultValueForStepUp): Added defaultValueForStepUp() which returns the current local month
        * html/MonthInputType.h:
        * html/RangeInputType.cpp:
        (WebCore::RangeInputType::handleKeydownEvent): Added comments and modified it to use stepUpFromRenderer()
        * html/TimeInputType.cpp:
        (WebCore::TimeInputType::defaultValueForStepUp): Added defaultValueForStepUp() which returns the current local time
        * html/TimeInputType.h:
        * manual-tests/input-type-datetime-default-value.html: Added manual tests for default values of date/time inputs since they are "the current local/UTC time", which cannot be tested automatically.

2010-11-29  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Adler.

        Introduce the notion of a "display-isolated" URL scheme for use by Chrome-internal URLs
        https://bugs.webkit.org/show_bug.cgi?id=50182

        A display-isolated URL can only be displayed (e.g., put in an iframe,
        hyperlinked to) by documents from that scheme.  In a sense, this is a
        generalization of some of the protections we give file URLs, but
        instead of lumping them all together into one "local" bucket, this
        patch creates a separate bucket for each scheme.

        For a while, I tried using a separate bucket for each origin.  That
        would have played nicely with what Blob URLs are trying to do, but some
        "chrome" URL pages rely on being able to display other chrome URL
        pages, even in different origins.  For example, the New Tab Page shows
        thumbnails from the "thumbnail" host.

        This patch also removes a bunch of unused code.  I've also propagated
        the "deprecated" status of deprecatedCanDisplay to
        deprecatedShouldTreatURLAsLocal because that method has no other
        callers and is really asking for uppercase/lowercase bugs.  I dream of
        someday removing these functions.

        * page/SecurityOrigin.cpp:
        (WebCore::SecurityOrigin::canDisplay):
        (WebCore::SecurityOrigin::deprecatedCanDisplay):
        * platform/SchemeRegistry.cpp:
        (WebCore::displayIsolatedURLSchemes):
        (WebCore::SchemeRegistry::registerURLSchemeAsLocal):
        (WebCore::SchemeRegistry::deprecatedShouldTreatURLAsLocal):
        (WebCore::SchemeRegistry::shouldTreatURLSchemeAsLocal):
        (WebCore::SchemeRegistry::registerURLSchemeAsDisplayIsolated):
        (WebCore::SchemeRegistry::shouldTreatURLSchemeAsDisplayIsolated):
        * platform/SchemeRegistry.h:

2010-11-29  Sergio Villar Senin  <svillar@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Leaks in SoupCache code
        https://bugs.webkit.org/show_bug.cgi?id=50161

        Fixes some memory leaks in SoupCache code.

        * platform/network/soup/cache/soup-http-input-stream.c:
        (send_async_finished): Added a missing g_object_unref.
        * platform/network/soup/cache/webkit/soup-cache.c:
        (get_cacheability): Added soup_header_free_param_list.
        (webkit_soup_cache_entry_set_freshness): Ditto.
        (webkit_soup_cache_send_response): Ditto.
        (webkit_soup_cache_has_response): Ditto.

2010-11-29  Jian Li  <jianli@chromium.org>

        Reviewed by David Levin.

        Add send(ArrayBuffer) to XMLHttpRequest per XMLHttpRequest Level 2 spec
        https://bugs.webkit.org/show_bug.cgi?id=50199

        Test: http/tests/xmlhttprequest/send-array-buffer.html

        * bindings/js/JSXMLHttpRequestCustom.cpp:
        (WebCore::JSXMLHttpRequest::send):
        * bindings/v8/custom/V8XMLHttpRequestCustom.cpp:
        (WebCore::V8XMLHttpRequest::sendCallback):
        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::send):
        * xml/XMLHttpRequest.h:

2010-11-29  James Robinson  <jamesr@chromium.org>

        [chromium] REGRESSION(72470): Crash in skia on some images
        https://bugs.webkit.org/show_bug.cgi?id=50201

        Reverts r72470

        * platform/graphics/skia/ImageSkia.cpp:
        (WebCore::computeResamplingMode):
        (WebCore::drawResampledBitmap):

2010-11-29  Dmitry Titov  <dimich@chromium.org>

        Reviewed by David Levin.

        Crash when iframe transfers from one page to another and has child frames.
        https://bugs.webkit.org/show_bug.cgi?id=50200

        * page/Frame.cpp:
        (WebCore::Frame::transferChildFrameToNewDocument):
        avoid overriding 'didTransfer' which has the result of previous check.

2010-11-19  Ryosuke Niwa  <rniwa@webkit.org>

        Reviewed by David Hyatt.

        up arrow doesn't work with RTL text with word wrapping
        https://bugs.webkit.org/show_bug.cgi?id=41987

        The bug was caused by positionForPoint's not returning the correct affinity when the x coordiate
        is to the left of the first line, and startOfLine's incorrectly moving position to the previous candidate.

        Fixed the bug by returning upstream VisiblePosition in positionForPoint if the first inline text box's offset
        is greater than 0.  Also removed the code added by http://trac.webkit.org/changeset/23608 since this changeset
        does not add any test, and the problem described in the changelog reproduces regardless of the code's presence.

        Tests: editing/selection/click-left-of-rtl-wrapping-text.html
               editing/selection/modify-up-on-rtl-wrapping-text.html

        * editing/visible_units.cpp:
        (WebCore::startOfLine):
        * rendering/RenderText.cpp:
        (WebCore::RenderText::positionForPoint):

2010-11-29  Ilya Sherman  <isherman@chromium.org>

        Reviewed by Kent Tamura.

        Ensure that option elements are rendered with normal font weight on Windows/Linux
        https://bugs.webkit.org/show_bug.cgi?id=50055

        * WebCore.gyp/WebCore.gyp: include themeChromiumSkia.css
        * css/themeChromiumSkia.css: Added.
        (option): font-weight: normal !important;
        * rendering/RenderThemeChromiumSkia.cpp:
        (WebCore::RenderThemeChromiumSkia::extraDefaultStyleSheet): include themeChromiumSkia.css

2010-11-29  Brent Fulgham  <bfulgham@webkit.org>

        Unreviewed build fix.

        * WebCore.vcproj/WebCoreCairo.vsprops: Provide missing WIN_CAIRO
          definition so that proper targets are build.
        * platform/graphics/win/cairo/FontPlatformData.h:
        (WebCore::FontPlatformData::orientation): Add missing implementation.

2010-11-29  Chris Rogers  <crogers@google.com>

        Reviewed by Kenneth Russell.

        Switch web audio code to use FloatPoint3D instead of Vector3
        https://bugs.webkit.org/show_bug.cgi?id=50186

        No new tests since audio API is not yet implemented.

        * platform/audio/Cone.cpp:
        (WebCore::ConeEffect::gain):
        * platform/audio/Cone.h:
        * platform/graphics/FloatPoint3D.h:
        (WebCore::FloatPoint3D::isZero):
        (WebCore::operator*):
        (WebCore::FloatPoint3D::distanceTo):
        * webaudio/AudioListener.h:
        (WebCore::AudioListener::setPosition):
        (WebCore::AudioListener::position):
        (WebCore::AudioListener::setOrientation):
        (WebCore::AudioListener::orientation):
        (WebCore::AudioListener::setUpVector):
        (WebCore::AudioListener::upVector):
        (WebCore::AudioListener::setVelocity):
        (WebCore::AudioListener::velocity):
        * webaudio/AudioPannerNode.cpp:
        (WebCore::AudioPannerNode::AudioPannerNode):
        (WebCore::AudioPannerNode::getAzimuthElevation):
        (WebCore::AudioPannerNode::dopplerRate):
        (WebCore::AudioPannerNode::distanceConeGain):
        * webaudio/AudioPannerNode.h:
        (WebCore::AudioPannerNode::position):
        (WebCore::AudioPannerNode::setPosition):
        (WebCore::AudioPannerNode::orientation):
        (WebCore::AudioPannerNode::setOrientation):
        (WebCore::AudioPannerNode::velocity):
        (WebCore::AudioPannerNode::setVelocity):

2010-11-29  Xiaomei Ji  <xji@chromium.org>

        Reviewed by David Hyatt.

        Right-to-left pages should be scrollable to reveal left overflow.
        https://bugs.webkit.org/show_bug.cgi?id=23556

        For RTL page, save left layout overflow and include it into the document
        size during layout. Use the left layout overflow when scroll and paint
        the page. Behavior on LTR page should be untouched since left layout 
        overflow is set as 0 for LTR page.

        Tests: fast/dom/horizontal-scrollbar-in-rtl-doesnt-fire-onscroll.html
               fast/dom/horizontal-scrollbar-in-rtl.html
               fast/dom/horizontal-scrollbar-when-dir-change.html
               fast/dom/left-overflow-in-ltr.html
               fast/dom/right-overflow-in-rtl.html

        * page/FrameView.cpp:
        (WebCore::FrameView::adjustViewSize): Save negative of left layout overflow as scroll X origin. And includes left layout overflow into document size.
        * page/mac/WebCoreFrameView.h: Add methods for setting and getting scroll X origin.
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::ScrollView):
        (WebCore::ScrollView::maximumScrollPosition): Minus scroll X origin from maximum horizontal scroll position.
        (WebCore::ScrollView::minimumScrollPosition):
        (WebCore::ScrollView::adjustScrollPositionWithinRange):
        (WebCore::ScrollView::valueChanged):
        (WebCore::ScrollView::setScrollPosition):
        (WebCore::ScrollView::updateScrollbars):
        (WebCore::ScrollView::wheelEvent):
        * platform/ScrollView.h:
        * platform/mac/ScrollViewMac.mm:
        (WebCore::ScrollView::platformSetContentsSize):
        (WebCore::ScrollView::platformSetScrollPosition):
        (WebCore::ScrollView::platformSetScrollOriginX):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::styleDidChange):
        (WebCore::RenderBox::paintRootBoxDecorations): Include left layout overflow into canvas size.
        * rendering/RenderView.cpp:
        (WebCore::RenderView::layout): Save left layout overflow.
        (WebCore::RenderView::docLeft):
        (WebCore::RenderView::docWidth): Include left layout overflow into doc width for RTL page.
        * rendering/RenderView.h:

2010-11-29  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Ojan Vafai.

        bunch of pixel failures after http://trac.webkit.org/changeset/72839/
        https://bugs.webkit.org/show_bug.cgi?id=50188
        
        We need to call updateLayerTransform() for reflections, and
        table rows as well.

        * rendering/RenderReplica.cpp:
        (WebCore::RenderReplica::layout):
        * rendering/RenderTableRow.cpp:
        (WebCore::RenderTableRow::layout):
        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::layoutRows):

2010-11-29  Xiaomei Ji  <xji@chromium.org>

        Reviewed by David Hyatt.

        Fix tab overflow problem when alignment is not left.
        https://bugs.webkit.org/show_bug.cgi?id=25459

        I checked WordPad in Windows, TextEdit in Mac, OpenOffice, and Google doc. 
        In all of them, (when the writing mode is horizontal) when the alignment is not
        left alignment, the length of tab is computed based on the tab's position
        relative to the left start of line, not based on the tab's position relative 
        to the left edge of the document.

        WebKit should follow the same.

        The m_xPos in each TextRun should be relative to the left start of the line, 
        not left start of its containing block (in right alignment and center alignment,
        left start of the line is not the same as left start of the containing block).
        So, when the text is drawn, the width of tab is consistent with the width 
        computed in RenderBlock::computeInlineDirectionPositionsForLine().

        I did not test vertical writing mode, but I think the same rule should apply.

        Test: fast/dom/tab-in-right-alignment.html

        * platform/graphics/TextRun.h:
        * rendering/InlineTextBox.cpp:
        (WebCore::InlineTextBox::textPos):
        * rendering/InlineTextBox.h:

2010-11-29  Mikhail Naganov  <mnaganov@chromium.org>

        Reviewed by Pavel Feldman.

        WebInspector: Request JSON-serialized heap snapshot from JS engine.
        This simplifies heap snapshots interaction and API. Instead of
        having objects representing snapshot entities, the whole snapshot
        is transferred to WebInspector and parsed there.

        https://bugs.webkit.org/show_bug.cgi?id=49974

        * bindings/js/ScriptHeapSnapshot.h:
        (WebCore::ScriptHeapSnapshot::OutputStream::~OutputStream):
        (WebCore::ScriptHeapSnapshot::~ScriptHeapSnapshot):
        (WebCore::ScriptHeapSnapshot::writeJSON):
        (WebCore::ScriptHeapSnapshot::ScriptHeapSnapshot):
        * bindings/v8/ScriptHeapSnapshot.cpp:
        (WebCore::ScriptHeapSnapshot::writeJSON):
        * bindings/v8/ScriptHeapSnapshot.h:
        (WebCore::ScriptHeapSnapshot::OutputStream::~OutputStream):
        * inspector/Inspector.idl:
        * inspector/InspectorProfilerAgent.cpp:
        (WebCore::InspectorProfilerAgent::getProfile):
        * inspector/front-end/HeapSnapshotView.js:
        (WebInspector.HeapSnapshotEdgesIterator):
        (WebInspector.HeapSnapshotEdgesIterator.prototype.get done):
        (WebInspector.HeapSnapshotEdgesIterator.prototype.get isElement):
        (WebInspector.HeapSnapshotEdgesIterator.prototype.get isHidden):
        (WebInspector.HeapSnapshotEdgesIterator.prototype.get name):
        (WebInspector.HeapSnapshotEdgesIterator.prototype.next):
        (WebInspector.HeapSnapshotEdgesIterator.prototype.get node):
        (WebInspector.HeapSnapshotEdgesIterator.prototype.get nodeIndex):
        (WebInspector.HeapSnapshotEdgesIterator.prototype._getNameOrIndex):
        (WebInspector.HeapSnapshotEdgesIterator.prototype._getType):
        (WebInspector.HeapSnapshotNodeWrapper):
        (WebInspector.HeapSnapshotNodeWrapper.prototype.get edges):
        (WebInspector.HeapSnapshotNodeWrapper.prototype.get edgesCount):
        (WebInspector.HeapSnapshotNodeWrapper.prototype.get instancesCount):
        (WebInspector.HeapSnapshotNodeWrapper.prototype.get isHidden):
        (WebInspector.HeapSnapshotNodeWrapper.prototype.get name):
        (WebInspector.HeapSnapshotNodeWrapper.prototype.get selfSize):
        (WebInspector.HeapSnapshotNodeWrapper.prototype._getName):
        (WebInspector.HeapSnapshotNodeWrapper.prototype._getEdges):
        (WebInspector.HeapSnapshotNodeWrapper.prototype._getType):
        (WebInspector.HeapSnapshot):
        (WebInspector.HeapSnapshot.prototype._init):
        (WebInspector.HeapSnapshot.prototype.get rootEdges):
        (WebInspector.HeapSnapshotView.prototype.snapshotLoaded):
        (WebInspector.HeapSnapshotView.prototype._loadProfile.processLoadedSnapshot):
        (WebInspector.HeapSnapshotView.prototype._loadProfile):
        (WebInspector.HeapSnapshotView.prototype._convertSnapshot):
        (WebInspector.HeapSnapshotView.prototype._prepareProfile.mergeRetainers):
        (WebInspector.HeapSnapshotView.prototype._prepareProfile):
        (WebInspector.HeapSnapshotView.prototype._sortData):
        * inspector/front-end/ProfilesPanel.js:
        (WebInspector.ProfilesPanel):
        (WebInspector.ProfilesPanel.prototype.addHeapSnapshotChunk):
        (WebInspector.ProfilesPanel.prototype.finishHeapSnapshot):
        * inspector/front-end/inspector.js:
        (WebInspector.addHeapSnapshotChunk):
        (WebInspector.finishHeapSnapshot):

2010-11-29  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt.

        layer()->currentTransform() is stale when layout changes the box size
        https://bugs.webkit.org/show_bug.cgi?id=50175
        
        RenderLayer::updateTransform() is fairly expensive, so we
        have to avoid calling it from RenderBox::applyLayerTransformToRect()
        every time. This requires that we update the layer's transform
        during layout, instead of from updateLayerPositions() which is too late.
        
        So call updateLayerTransform() from the various layout methods
        on renderers that can be transformed, and remove it from 
        updateLayerPositions().

        Test: fast/overflow/overflow-update-transform.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::layoutBlock):
        (WebCore::RenderBlock::layoutOnlyPositionedObjects):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::applyLayerTransformToRect):
        (WebCore::RenderBox::updateLayerTransform):
        * rendering/RenderBox.h:
        * rendering/RenderEmbeddedObject.cpp:
        (WebCore::RenderEmbeddedObject::layout):
        * rendering/RenderFlexibleBox.cpp:
        (WebCore::RenderFlexibleBox::layoutBlock):
        * rendering/RenderIFrame.cpp:
        (WebCore::RenderIFrame::layout):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::updateLayerPositions):
        * rendering/RenderReplaced.cpp:
        (WebCore::RenderReplaced::layout):
        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::layout):

2010-11-29  Chris Rogers  <crogers@google.com>

        Reviewed by Kenneth Russell.

        Add remaining custom JSC web audio bindings
        https://bugs.webkit.org/show_bug.cgi?id=50172

        No new tests since audio API is not yet implemented.

        * bindings/js/JSAudioBufferSourceNodeCustom.cpp: Added.
        (WebCore::JSAudioBufferSourceNode::setBuffer):
        * bindings/js/JSConvolverNodeCustom.cpp: Added.
        (WebCore::JSConvolverNode::setBuffer):
        * bindings/js/JSJavaScriptAudioNodeCustom.cpp: Added.
        (WebCore::JSJavaScriptAudioNode::markChildren):
        * webaudio/AudioBufferSourceNode.idl:
        * webaudio/ConvolverNode.idl:

2010-11-29  Yael Aharon  <yael.aharon@nokia.com>

        Reviewed by Darin Adler.

        HTMLFormElement.elements doesn't include fieldsets
        https://bugs.webkit.org/show_bug.cgi?id=48193

        Add fieldset and keygen to the list of form collection elements, by making them enumeratable.
        This patch does not add object element to the list. A separate bug will do that.

        Test: fast/forms/form-collection-elements.html

        * html/HTMLFieldSetElement.h:
        (WebCore::HTMLFieldSetElement::isEnumeratable):
        * html/HTMLKeygenElement.h:
        (WebCore::HTMLKeygenElement::isEnumeratable):

2010-11-29  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Martin Robinson.

        Get distcheck going.

        * GNUmakefile.am:

2010-11-29  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=50181
        CSS style declarations don't GC protect parents

        Test: fast/dom/StyleSheet/gc-declaration-parent-rule.html

        * bindings/js/JSCSSStyleDeclarationCustom.cpp: (WebCore::JSCSSStyleDeclaration::markChildren):
        Protect the parent rule.

2010-11-29  Ilya Tikhonovsky  <loislo@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: UI fix. In Timeline, Paint events "Location" value is displayed
        in a confusing manner. The format string should be changed from %d x %d
        pattern to (%d, %d).

        https://bugs.webkit.org/show_bug.cgi?id=50178

        * English.lproj/localizedStrings.js:
        * inspector/front-end/TimelinePanel.js:
        (WebInspector.TimelinePanel.FormattedRecord.prototype._generatePopupContent):

2010-11-29  Darin Adler  <darin@apple.com>

        Reviewed by Andreas Kling.

        Remove a couple unneeded overflow checks
        https://bugs.webkit.org/show_bug.cgi?id=49816

        * platform/text/TextCodecUTF16.cpp:
        (WebCore::TextCodecUTF16::encode): Use an ASSERT instead of
        an overflow check with CRASH.

2010-11-29  Tony Chang  <tony@chromium.org>

        Unreviewed, disable warnings again on chromium linux

        * WebCore.gyp/WebCore.gyp:

2010-11-29  Cosmin Truta  <ctruta@chromium.org>

        Reviewed by Nikolas Zimmermann.

        getBoundingClientRect: Do not truncate the coordinates to integers
        https://bugs.webkit.org/show_bug.cgi?id=48110

        Remove the float-to-int coordinate conversions inside getBoundingClientRect,
        to comply with the CSSOM View Module API.

        Tests: fast/dom/Element/getBoundingClientRect.html
               fast/dom/Range/getBoundingClientRect.html
               svg/zoom/page/zoom-getBoundingClientRect.xhtml
               svg/zoom/page/zoom-zoom-coords.xhtml

        * dom/ClientRect.cpp:
        (WebCore::ClientRect::ClientRect): Added overload to allow a FloatRect argument.
        * dom/ClientRect.h:
        (WebCore::ClientRect::create): Ditto.
        * dom/Element.cpp:
        (Element::getBoundingClientRect): Removed conversion from FloatRect to IntRect.
        * dom/Range.cpp:
        (WebCore::Range::getBoundingClientRect): Ditto.
        * rendering/RenderObject.h:
        (adjustIntRectForAbsoluteZoom): Removed.
        (adjustFloatRectForAbsoluteZoom): Added.
        * rendering/style/RenderStyle.h:
        (adjustFloatForAbsoluteZoom): Added.

2010-11-29  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Darin Adler.

        Converge means of querying a parent node into one way, which is Node::parentNode.
        https://bugs.webkit.org/show_bug.cgi?id=49686

        A follow-up to r72259, which explicitly forbids further use of Node::parent by
        making it private.

        No change in behavior, so no new tests.

        * dom/Document.cpp:
        (WebCore::Document::styleForElementIgnoringPendingStylesheets): Changed to use parentNode.
        (WebCore::Document::hoveredNodeDetached): Ditto.
        (WebCore::Document::activeChainNodeDetached): Ditto.
        * dom/Node.h: Made Node::parent private.
        * page/SpatialNavigation.cpp:
        (WebCore::canBeScrolledIntoView): Changed to use parentNode.
        * xml/XSLTProcessorQt.cpp:
        (WebCore::XSLTProcessor::transformToString): Ditto.

2010-11-29  Tony Chang  <tony@chromium.org>

        Reviewed by James Robinson.

        [chromium] try to enable WebCore compiler warnings on linux
        https://bugs.webkit.org/show_bug.cgi?id=50168

        * WebCore.gyp/WebCore.gyp:
        * platform/graphics/chromium/FontLinux.cpp:
        (WebCore::TextRunWalker::setPadding):
        (WebCore::TextRunWalker::setGlyphXPositions):
        (WebCore::glyphIndexForXPositionInScriptRun):

2010-11-29  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=50165
        CSS style rules don't GC protect parents

        Tests: fast/dom/StyleSheet/gc-parent-rule.html
               fast/dom/StyleSheet/gc-parent-stylesheet.html

        * bindings/js/JSCSSRuleCustom.cpp: (WebCore::JSCSSRule::markChildren): Mark parents. The code
        is super naive compared to what we have for nodes - but CSSOM has shallow hierarchies, so
        it should be OK.

        * css/CSSRule.idl: Added CustomMarkFunction.

2010-11-29  Gavin Peters  <gavinp@chromium.org>

        Reviewed by Adam Barth.

        Web page can prevent WebKit from loading subresources on other
        pages (cache poisoning)
        https://bugs.webkit.org/show_bug.cgi?id=35404

        Tests: http/tests/misc/unloadable-script.html
               loader/reload-subresource-when-type-changes.html

        * loader/cache/MemoryCache.cpp:
        (WebCore::MemoryCache::requestResource):

2010-11-29  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        Crash in WebCore::CSSStyleSelector::loadPendingImages
        https://bugs.webkit.org/show_bug.cgi?id=50149
        
        Null-check style->boxReflect() when loading pending style images.

        Test: fast/reflections/pending-reflection-mask-crash.html

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::loadPendingImages):

2010-11-29  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: crash upon inspecting user style sheet.
        https://bugs.webkit.org/show_bug.cgi?id=50109

        * inspector/InspectorStyleSheet.cpp:
        (WebCore::InspectorStyleSheet::resourceStyleSheetText):

2010-11-29  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Adam Roben.

        [WINCE] Implement WebCore::directoryName
        https://bugs.webkit.org/show_bug.cgi?id=50031

        Also fix handling of paths without path separator.

        * platform/wince/FileSystemWinCE.cpp:
        (WebCore::reverseFindPathSeparator):
        (WebCore::makeAllDirectories):
        (WebCore::pathGetFileName):
        (WebCore::directoryName):

2010-11-29  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Adam Roben.

        Simplify directoryName in FileSystemWin.cpp
        https://bugs.webkit.org/show_bug.cgi?id=50028

        * platform/win/FileSystemWin.cpp:
        (WebCore::directoryName):

2010-11-24  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Darin Adler.

        REGRESSION (r71934): Main search field at Apple tech specs does not accept typing
        https://bugs.webkit.org/show_bug.cgi?id=49868

        The problem here was that the inner text element of search input was first laid out as
        disabled and thus with a 0-height. This would prevent a hit test to ever reach it, even
        if it's enabled.

        Test: fast/forms/disabled-search-input.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::hasLineIfEmpty): Removed a check for textarea that is no longer necessary.
        * rendering/TextControlInnerElements.cpp:
        (WebCore::RenderTextControlInnerBlock::hasLineIfEmpty): Added an override to ensure that
            an empty inner text element is always one-line high.

2010-11-29  W. James MacLean  <wjmaclean@chromium.org>

       Reviewed by Dirk Schulze.

       Large input numbers cause overflow during SVG parsing, leading to crash
       https://bugs.webkit.org/show_bug.cgi?id=49546

       Values outside the range supported by float lead to Infinity() or NaN()
       during parsing, leading to subsequent crashes. Modified
       parser to verify number is in the supported range, and return false if not.

       Tests: svg/custom/svg-parse-overflow-1.html
              svg/custom/svg-parse-overflow-2.html
              svg/custom/svg-parse-overflow-3.html
              svg/custom/svg-parse-overflow-4.html
              svg/custom/svg-parse-overflow-5.html

       * svg/SVGParserUtilities.cpp:
       (WebCore::isValidRange):
       (WebCore::genericParseNumber):

2010-11-29  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: display name of an object constructor as the object's type
        https://bugs.webkit.org/show_bug.cgi?id=50063

        Name of the function that has created given object is used as the object's
        type when it's displayed in the inspector front-end(in case of V8). Before
        this change, it was always a value of the object's constructor.name property
        which is confusing in some cases(see the test).

        Removed check for jsEngine from the InjectedScript.js, all VM-specific code
        is now encapsulated on the bindings layer.

        Test: inspector/console-object-constructor-name.html

        * bindings/js/JSInjectedScriptHostCustom.cpp:
        (WebCore::InjectedScriptHost::createInjectedScript):
        (WebCore::JSInjectedScriptHost::constructorName):
        * bindings/v8/custom/V8InjectedScriptHostCustom.cpp:
        (WebCore::InjectedScriptHost::createInjectedScript):
        (WebCore::V8InjectedScriptHost::constructorNameCallback):
        * inspector/InjectedScriptHost.idl:
        * inspector/front-end/InjectedScript.js:
        (injectedScriptConstructor.):

2010-11-29  Jeremy Moskovich  <jeremy@chromium.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=24346

        Remove temporary workaround to load Gears plugin.

        * html/HTMLObjectElement.cpp:
        (WebCore::HTMLObjectElement::rendererIsNeeded):

2010-11-29  Yael Aharon  <yael.aharon@nokia.com>

        Reviewed by Antonio Gomes.

        Spatial Navigation: Store more information in FocusCandidate
        https://bugs.webkit.org/show_bug.cgi?id=50153

        More information should be stored in FocusCandidate, to avoid
        recalculating it when running the spatial navigation algorithm.

        No new tests, since this is code refactoring only.

        * page/FocusController.cpp:
        (WebCore::updateFocusCandidateIfNeeded):
        (WebCore::FocusController::findFocusCandidateInContainer):
        (WebCore::FocusController::advanceFocusDirectionallyInContainer):
        * page/SpatialNavigation.cpp:
        (WebCore::FocusCandidate::FocusCandidate):
        (WebCore::canBeScrolledIntoView):
        * page/SpatialNavigation.h:
        (WebCore::FocusCandidate::FocusCandidate):

2010-11-29  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Darin Adler.

        Use the right focusable check to avoid multiple focus/blur events being fired from inside of the shadow DOM.
        https://bugs.webkit.org/show_bug.cgi?id=49977

        * editing/SelectionController.cpp:
        (WebCore::SelectionController::setFocusedNodeIfNeeded): Added a FIXME to remove redundant code.
        * page/EventHandler.cpp:
        (WebCore::EventHandler::dispatchMouseEvent): Changed to use isMouseFocusable, which is what shadow DOM elements
            override, and added a FIXME to convert to use shadow DOM-aware traversal instead of render tree traversal.

        Test: fast/events/shadow-boundary-crossing-2.html

2010-11-29  Adam Roben  <aroben@apple.com>

        Windows build fix after r72715

        * WebCore.vcproj/WebCore.vcproj: Add a missing </File> tag to fix an
        XML syntax error.

2010-11-29  Bernhard Bauer  <bauerb@chromium.org>

        Reviewed by Jeremy Orlow.

        Remove databaseFileName from IDBFactoryBackendImpl
        https://bugs.webkit.org/show_bug.cgi?id=50150

        No new tests, since functionality is unchanged.

        * storage/IDBFactoryBackendImpl.cpp:
        (WebCore::openSQLiteDatabase):
        * storage/IDBFactoryBackendImpl.h:

2010-11-29  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Xan Lopez.

        [GStreamer] take video sink ownership with gst_object API
        https://bugs.webkit.org/show_bug.cgi?id=49011

        Use gst_object_ref_sink instead of g_object_ref_sink to avoid
        possible leaks.

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::createGSTPlayBin):

2010-11-29  Jan Erik Hanssen  <jhanssen@sencha.com>

        Reviewed by Kenneth Rohde Christiansen.

        QtWebKit asserts when selecting elided text.
        https://bugs.webkit.org/show_bug.cgi?id=45391

        Ensure that the length passed to fromRawDataWithoutRef() does
        not exceed the length of the string.

        * platform/graphics/qt/FontQt.cpp:
        (WebCore::Font::selectionRectForSimpleText):

2010-11-26  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: Styles Gear Menu Choice to Display Colors "As Authored"
        https://bugs.webkit.org/show_bug.cgi?id=31614

        * English.lproj/localizedStrings.js:
        * inspector/front-end/Color.js:
        (WebInspector.Color.prototype.toString):
        (WebInspector.Color.prototype._parse.this.rgba.set 0):
        (WebInspector.Color.prototype._parse.set WebInspector):
        (WebInspector.Color.prototype._parse):
        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertyTreeElement.prototype.updateTitle.processColor.nextFormat):
        (WebInspector.StylePropertyTreeElement.prototype.updateTitle.processColor.changeColorDisplay):

2010-11-29  Helder Correia  <helder@sencha.com>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] fillRect shadow has incorrect behavior when using ctx.scale(x,y)
        https://bugs.webkit.org/show_bug.cgi?id=50141

        Don't apply scaling transformation to shadow offsets.

        Test: fast/canvas/canvas-scale-fillRect-shadow.html

        * platform/graphics/ContextShadow.h:
        * platform/graphics/qt/ContextShadowQt.cpp:
        (WebCore::ContextShadow::beginShadowLayer):
        (WebCore::ContextShadow::endShadowLayer):
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::fillRect):

2010-11-28  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Darin Adler.

        Default event handlers should also be using event retargeting.
        https://bugs.webkit.org/show_bug.cgi?id=49986

        Test: fast/events/shadow-boundary-crossing-2.html

        * dom/EventContext.cpp:
        (WebCore::EventContext::defaultEventHandler): Added.
        * dom/EventContext.h: Added decl.
        * dom/Node.cpp:
        (WebCore::Node::dispatchGenericEvent): Changed to use event retargeting for
            default event handlers.

2010-11-23  MORITA Hajime  <morrita@google.com>

        Reviewed by Kent Tamura.

        REGRESSION: Text on <input type="search"> is not spellchecked.
        https://bugs.webkit.org/show_bug.cgi?id=49651

        TextControlInnerElement::isSpellCheckingEnabled() didn't consider 
        non-root shadow elelements and always went false for <input type="search>.
        This change unifies shadow and host handling into Element::isSpellCheckingEnabled().
        
        Test: editing/spelling/spellcheck-attribute.html
        
        * dom/Element.cpp:
        (WebCore::Element::isSpellCheckingEnabled):
        * rendering/TextControlInnerElements.cpp:
        * rendering/TextControlInnerElements.h:

2010-11-28  Antonio Gomes  <agomes@rim.com>

        Reviewed by Kenneth Rohde Christiansen.

        Spatial Navigation: use isSpatialNaviagtionEnabled from SpatialNavigation.h in HTMLInputElement::defaultEventHandler
        https://bugs.webkit.org/show_bug.cgi?id=50131

        For all isSpatialNavigationEnabled calls throughout WebCore, we decided to use the static method in
        SpatialNavigation.h instead of directly checking from the one in Settings.h. Reason: in a soon future,
        there  will be a isCaretBrowsing check incorporated into this method (and probably renaming it accordingly)
        to avoid feature conflicts (spatial navigation x caret browsing).

        No new tests needed.

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::defaultEventHandler):

2010-11-27  Benjamin Kalman  <kalman@chromium.org>

        Reviewed by Darin Adler.

        Move Position::EditingBoundaryCrossingRule to a new header file
        https://bugs.webkit.org/show_bug.cgi?id=49630

        * GNUmakefile.am:
        * WebCore.exp.in:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/Position.cpp:
        (WebCore::downstreamIgnoringEditingBoundaries):
        (WebCore::upstreamIgnoringEditingBoundaries):
        * dom/Position.h:
        * editing/DeleteSelectionCommand.cpp:
        (WebCore::DeleteSelectionCommand::doApply):
        * editing/EditingBoundary.h: Added.
        * editing/visible_units.cpp:
        (WebCore::startOfParagraph):
        (WebCore::endOfParagraph):
        (WebCore::isStartOfParagraph):
        (WebCore::isEndOfParagraph):
        * editing/visible_units.h:
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::createVisiblePosition):

2010-11-26  Rob Buis  <rwlbuis@gmail.com>

        Reviewed by Simon Fraser.

        Percentage z offset in transform-origin should make the property invalid
        https://bugs.webkit.org/show_bug.cgi?id=48704

        Discard transform-origin property when parsing invalid Z value.

        Test: fast/css/transform-origin-parsing.html

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseTransformOriginShorthand):
        (WebCore::CSSParser::parseTransformOrigin):
        * css/CSSParser.h:

2010-11-26  Dan Bernstein  <mitz@apple.com>

        Reviewed by Antti Koivisto.

        <rdar://problem/8681368> Avoid unnecessary calls to CTFontGetPlatformFont()
        https://bugs.webkit.org/show_bug.cgi?id=50096

        No new test, since functionality is unchanged.

        * platform/graphics/chromium/CrossProcessFontLoading.mm:
        (WebCore::FontPlatformData::loadFont): Removed the ATSUFontID argument.
        * platform/graphics/cocoa/FontPlatformData.h:
        (WebCore::FontPlatformData::FontPlatformData): Ditto.
        (WebCore::FontPlatformData::operator==): Removed comparison of font IDs.
        * platform/graphics/cocoa/FontPlatformDataCocoa.mm:
        (WebCore::FontPlatformData::loadFont): Removed the ATSUFontID argument.
        (WebCore::FontPlatformData::FontPlatformData): Updated.
        (WebCore::FontPlatformData::operator=): Removed copying of font ID.
        (WebCore::FontPlatformData::setFont): Removed setting of font ID.
        * platform/graphics/mac/ComplexTextControllerATSUI.cpp:
        (WebCore::initializeATSUStyle): Call CTFontGetPlatformFont() here if necessary.
        * platform/graphics/mac/FontCustomPlatformData.cpp:
        (WebCore::FontCustomPlatformData::fontPlatformData): Updated for FontPlatformData change.
        (WebCore::createFontCustomPlatformData): Updated for FontCustomPlatformData change.
        * platform/graphics/mac/FontCustomPlatformData.h:
        (WebCore::FontCustomPlatformData::FontCustomPlatformData): Removed ATSUFontID argument and
        data member.
        * platform/graphics/mac/SimpleFontDataATSUI.mm:
        (WebCore::SimpleFontData::checkShapesArabic): Call CTFontGetPlatformFont() here if necessary.

2010-11-26  François Sausset  <sausset@gmail.com>

        Reviewed by Daniel Bates.

        MathML: code cleaning needed in MathMLInlineContainerElement.cpp
        https://bugs.webkit.org/show_bug.cgi?id=50069

        Unnecessary namespace was removed and style was adjusted.

        * mathml/MathMLInlineContainerElement.cpp:
        (WebCore::MathMLInlineContainerElement::createRenderer):

2010-11-26  Andrei Popescu  <andreip@google.com>

        Reviewed by Jeremy Orlow.

        IDBDatabase and IDBObjectStore remove* methods should be renamed to delete*
        https://bugs.webkit.org/show_bug.cgi?id=50113

        Modified exisiting layout tests to cover this change.

        * storage/IDBDatabase.cpp:
        (WebCore::IDBDatabase::deleteObjectStore):
        * storage/IDBDatabase.h:
        * storage/IDBDatabase.idl:
        * storage/IDBDatabaseBackendImpl.cpp:
        (WebCore::IDBDatabaseBackendImpl::deleteObjectStore):
        (WebCore::IDBDatabaseBackendImpl::deleteObjectStoreInternal):
        * storage/IDBDatabaseBackendImpl.h:
        * storage/IDBDatabaseBackendInterface.h:
        * storage/IDBObjectStore.cpp:
        (WebCore::IDBObjectStore::deleteFunction):
        (WebCore::IDBObjectStore::deleteIndex):
        * storage/IDBObjectStore.h:
        * storage/IDBObjectStore.idl:
        * storage/IDBObjectStoreBackendImpl.cpp:
        (WebCore::IDBObjectStoreBackendImpl::deleteFunction):
        (WebCore::IDBObjectStoreBackendImpl::deleteInternal):
        (WebCore::IDBObjectStoreBackendImpl::deleteIndex):
        (WebCore::IDBObjectStoreBackendImpl::deleteIndexInternal):
        * storage/IDBObjectStoreBackendImpl.h:
        * storage/IDBObjectStoreBackendInterface.h:

2010-11-26  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72701.
        http://trac.webkit.org/changeset/72701
        https://bugs.webkit.org/show_bug.cgi?id=50114

        REGRESSION: bad transform matrix on content layer (Requested
        by backer on #webkit).

        * WebCore.gypi:
        * platform/graphics/chromium/Canvas2DLayerChromium.cpp:
        (WebCore::Canvas2DLayerChromium::updateContents):
        * platform/graphics/chromium/Canvas2DLayerChromium.h:
        * platform/graphics/chromium/ContentLayerChromium.cpp:
        (WebCore::ContentLayerChromium::cleanupResources):
        (WebCore::ContentLayerChromium::updateContents):
        (WebCore::ContentLayerChromium::updateTextureRect):
        (WebCore::ContentLayerChromium::draw):
        * platform/graphics/chromium/ContentLayerChromium.h:
        * platform/graphics/chromium/ImageLayerChromium.cpp:
        (WebCore::ImageLayerChromium::updateContents):
        * platform/graphics/chromium/ImageLayerChromium.h:
        * platform/graphics/chromium/LayerChromium.h:
        (WebCore::LayerChromium::contentsDirty):
        (WebCore::LayerChromium::updateContents):
        (WebCore::LayerChromium::draw):
        * platform/graphics/chromium/LayerRendererChromium.cpp:
        (WebCore::LayerRendererChromium::LayerRendererChromium):
        (WebCore::LayerRendererChromium::prepareToDrawLayers):
        (WebCore::LayerRendererChromium::drawLayers):
        (WebCore::LayerRendererChromium::updateLayersRecursive):
        (WebCore::LayerRendererChromium::useRenderSurface):
        (WebCore::LayerRendererChromium::drawLayer):
        (WebCore::LayerRendererChromium::initializeSharedObjects):
        (WebCore::LayerRendererChromium::cleanupSharedObjects):
        * platform/graphics/chromium/LayerRendererChromium.h:
        * platform/graphics/chromium/LayerTexture.cpp: Removed.
        * platform/graphics/chromium/LayerTexture.h: Removed.
        * platform/graphics/chromium/PluginLayerChromium.cpp:
        (WebCore::PluginLayerChromium::updateContents):
        * platform/graphics/chromium/PluginLayerChromium.h:
        * platform/graphics/chromium/RenderSurfaceChromium.cpp:
        (WebCore::RenderSurfaceChromium::RenderSurfaceChromium):
        (WebCore::RenderSurfaceChromium::cleanupResources):
        (WebCore::RenderSurfaceChromium::prepareContentsTexture):
        * platform/graphics/chromium/RenderSurfaceChromium.h:
        * platform/graphics/chromium/TextureManager.cpp: Removed.
        * platform/graphics/chromium/TextureManager.h: Removed.
        * platform/graphics/chromium/VideoLayerChromium.cpp:
        (WebCore::VideoLayerChromium::updateContents):
        * platform/graphics/chromium/VideoLayerChromium.h:
        * platform/graphics/chromium/WebGLLayerChromium.cpp:
        (WebCore::WebGLLayerChromium::updateContents):
        * platform/graphics/chromium/WebGLLayerChromium.h:

2010-11-26  Jeremy Orlow  <jorlow@chromium.org>

        Unreviewed build fix.

        * storage/IDBIndex.cpp:
        (WebCore::IDBIndex::openCursor):
        (WebCore::IDBIndex::openKeyCursor):
        * storage/IDBObjectStore.cpp:
        (WebCore::IDBObjectStore::openCursor):

2010-11-26  Sergio Villar Senin  <svillar@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] SoupCache should not ignore loader's conditional requests
        https://bugs.webkit.org/show_bug.cgi?id=50101

        SoupCache must not handle WebKit loader conditional requests and
        thus should never return its own cached response if any. This was
        causing frequent resource load failures as WebCore was trying to
        revalidate its own resources and was not getting any expected
        result.

        * platform/network/soup/cache/webkit/soup-cache.c:
        (webkit_soup_cache_has_response): check the presence of
        conditional request headers when deciding whether the cache has a
        valid response for a given request.

2010-11-26  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Steve Block.

        Make IDBKeyRange match the spec
        https://bugs.webkit.org/show_bug.cgi?id=50105

        Remove flags and instead add two booleans for being open.
        Change left to lower and right to upper everywhere.

        * storage/IDBIndexBackendImpl.cpp:
        (WebCore::IDBIndexBackendImpl::openCursorInternal):
        * storage/IDBKey.cpp:
        (WebCore::IDBKey::lowerCursorWhereFragment):
        (WebCore::IDBKey::upperCursorWhereFragment):
        * storage/IDBKey.h:
        * storage/IDBKeyRange.cpp:
        (WebCore::IDBKeyRange::IDBKeyRange):
        (WebCore::IDBKeyRange::only):
        (WebCore::IDBKeyRange::lowerBound):
        (WebCore::IDBKeyRange::upperBound):
        (WebCore::IDBKeyRange::bound):
        (WebCore::IDBKeyRange::lowerWhereClauseComparisonOperator):
        (WebCore::IDBKeyRange::upperWhereClauseComparisonOperator):
        * storage/IDBKeyRange.h:
        (WebCore::IDBKeyRange::create):
        (WebCore::IDBKeyRange::lower):
        (WebCore::IDBKeyRange::upper):
        (WebCore::IDBKeyRange::lowerOpen):
        (WebCore::IDBKeyRange::upperOpen):
        * storage/IDBKeyRange.idl:
        * storage/IDBObjectStoreBackendImpl.cpp:
        (WebCore::IDBObjectStoreBackendImpl::openCursorInternal):

2010-11-25  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Steve Block.

        Convert open*Cursor and createIndex over to using OptionsObject
        https://bugs.webkit.org/show_bug.cgi?id=50093

        Add IDBKeyRange to OptionsObject's parsing abilities. Switch
        more APIs over to using it.

        * bindings/v8/OptionsObject.cpp:
        (WebCore::OptionsObject::getKeyDOMStringList):
        (WebCore::OptionsObject::getKeyKeyRange):
        * bindings/v8/OptionsObject.h:
        * storage/IDBIndex.cpp:
        (WebCore::IDBIndex::openCursor):
        (WebCore::IDBIndex::openKeyCursor):
        * storage/IDBIndex.h:
        (WebCore::IDBIndex::openCursor):
        (WebCore::IDBIndex::openKeyCursor):
        * storage/IDBIndex.idl:
        * storage/IDBObjectStore.cpp:
        (WebCore::IDBObjectStore::createIndex):
        (WebCore::IDBObjectStore::openCursor):
        * storage/IDBObjectStore.h:
        (WebCore::IDBObjectStore::createIndex):
        (WebCore::IDBObjectStore::openCursor):
        * storage/IDBObjectStore.idl:

2010-11-25  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Steve Block.

        Clean up IDBDatabase.transaction and add checks to IDBTransaction.objectStore
        https://bugs.webkit.org/show_bug.cgi?id=50081

        IDBDatabase.transaction should use the new optional OptionsObject way
        of taking optional paramters. Modify that object to get numbers and
        domStringLists from it. Verify that any requested resources exist and
        return an exception if not.

        When IDBTransaction.objectStore is called, verify that it's one of the
        requested resources. Also verify that it still exists. Plumb the
        exception code to make this work.

        Tests: storage/indexeddb/create-and-remove-object-store.html
               storage/indexeddb/transaction-and-objectstore-calls.html

        * bindings/v8/OptionsObject.cpp:
        (WebCore::OptionsObject::getKeyInteger):
        (WebCore::OptionsObject::getKeyString):
        (WebCore::OptionsObject::getKeyDOMStringList):
        * bindings/v8/OptionsObject.h:
        * storage/IDBDatabase.cpp:
        (WebCore::IDBDatabase::createObjectStore):
        (WebCore::IDBDatabase::transaction):
        * storage/IDBDatabase.h:
        (WebCore::IDBDatabase::transaction):
        * storage/IDBDatabase.idl:
        * storage/IDBDatabaseBackendImpl.cpp:
        (WebCore::IDBDatabaseBackendImpl::transaction):
        * storage/IDBTransaction.cpp:
        (WebCore::IDBTransaction::objectStore):
        * storage/IDBTransactionBackendImpl.cpp:
        (WebCore::IDBTransactionBackendImpl::IDBTransactionBackendImpl):
        (WebCore::IDBTransactionBackendImpl::objectStore):
        * storage/IDBTransactionBackendImpl.h:
        * storage/IDBTransactionBackendInterface.h:

2010-11-26  Mario Sanchez Prada  <msanchez@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] events missing when a document is (re)loaded
        https://bugs.webkit.org/show_bug.cgi?id=25831

        Make sure webArea returns a proper name and that a signal
        'state-change::defunct' is emitted when detaching the wrapper.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (webkit_accessible_get_name): Returns the current document's title
        as fallback mechanism for webArea objects.
        (webkit_accessible_detach): Emit 'state-change::defunct' function
        as soon as the wrapper is detached from the related core object.

2010-11-26  Sergio Villar Senin  <svillar@igalia.com>

        Reviewed by Xan Lopez.

        [Gtk] ASSERT(d->m_response.isNull()) in contentSniffedCallback
        https://bugs.webkit.org/show_bug.cgi?id=50083

        ResourceHandleSoup should not listen to content-sniffed signal
        when content sniffing is not enabled. This will prevent us
        reaching an assertion on content-sniffed callback

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::startHttp):
        * platform/network/soup/cache/soup-request-http.c:
        (conditional_get_ready_cb): added a comment with the
        possible fix for a pure libsoup HTTP cache.
        (send_async_cb): prevent an early object finalization adding a
        reference.
        (webkit_soup_request_http_send_async): Ditto.

2010-11-26  Renata Hodovan  <reni@inf.u-szeged.hu>

        Reviewed by Antonio Gomes.

        [Qt] Remove empty ScrollView::platformInit/platformDestroy
        https://bugs.webkit.org/show_bug.cgi?id=50079

        No new test is needed.

        * platform/ScrollView.cpp:
        (WebCore::ScrollView::wheelEvent):
        * platform/qt/ScrollViewQt.cpp:

2010-11-26  Pavel Feldman  <pfeldman@chromium.org>

        Not reviewed. Fixing inspector tests.

        * inspector/front-end/Resource.js:
        (WebInspector.Resource.prototype.set timing):

2010-11-25  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: UI polish for Network and Resources panels.
        https://bugs.webkit.org/show_bug.cgi?id=50100

        - Fixed timing inconsistencies
        - Made grid user-selectable
        - Selection in network panel is made on name column only

        * inspector/front-end/NetworkPanel.js:
        (WebInspector.NetworkPanel):
        (WebInspector.NetworkPanel.prototype._toggleGridMode):
        (WebInspector.NetworkDataGridNode.prototype.createCells):
        (WebInspector.NetworkDataGridNode.prototype.select):
        (WebInspector.NetworkDataGridNode.prototype.get selectable):
        (WebInspector.NetworkDataGridNode.prototype._createTimelineCell):
        (WebInspector.NetworkDataGridNode.prototype.refreshGraph):
        (WebInspector.NetworkDataGridNode.prototype._refreshLabelPositions):
        * inspector/front-end/Popover.js:
        (WebInspector.PopoverHelper):
        (WebInspector.PopoverHelper.prototype.setTimeout):
        (WebInspector.PopoverHelper.prototype._mouseMove):
        (WebInspector.PopoverHelper.prototype._handleMouseAction):
        * inspector/front-end/Resource.js:
        (WebInspector.Resource.prototype.get responseReceivedTime):
        (WebInspector.Resource.prototype.set endTime):
        (WebInspector.Resource.prototype.set timing):
        * inspector/front-end/ResourceManager.js:
        (WebInspector.ResourceManager.prototype.didReceiveResponse):
        (WebInspector.ResourceManager.prototype.didFinishLoading):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.FrameResourceTreeElement.prototype._ondragstart):
        * inspector/front-end/networkPanel.css:
        (.network-sidebar .data-grid td:not(.network-summary)):
        (.network-sidebar .data-grid td.name-column):
        (.network.panel:not(.viewing-resource) .network-sidebar td.name-column:hover):
        (.network-timing-row):
        (.network-timing-bar):
        (.network-timing-bar-title):
        (.resource-timing-view):

2010-11-26  Helder Correia  <helder@sencha.com>

        Reviewed by Ariya Hidayat.

        [Qt] Blur shadow for rectangle fill
        https://bugs.webkit.org/show_bug.cgi?id=44488

        Shadow color opacity needs to be set when blurring shadow with
        ContextShadow.

        Test: fast/canvas/canvas-fillRect-shadow.html

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::fillRect):

2010-11-26  Hans Wennborg  <hans@chromium.org>

        Reviewed by Jeremy Orlow.

        IndexedDB: Rename IDBDatabase.objectStores to objectStoreNames
        https://bugs.webkit.org/show_bug.cgi?id=50102

        Rename as per the spec: http://dvcs.w3.org/hg/IndexedDB/raw-file/tip/Overview.html#database-interface

        * manual-tests/indexeddb-persists.html:
        * storage/IDBDatabase.h:
        (WebCore::IDBDatabase::objectStoreNames):
        * storage/IDBDatabase.idl:
        * storage/IDBDatabaseBackendImpl.cpp:
        (WebCore::IDBDatabaseBackendImpl::objectStoreNames):
        (WebCore::IDBDatabaseBackendImpl::setVersion):
        (WebCore::IDBDatabaseBackendImpl::transaction):
        * storage/IDBDatabaseBackendImpl.h:
        * storage/IDBDatabaseBackendInterface.h:

2010-11-26  Andrei Popescu  <andreip@google.com>

        Reviewed by Jeremy Orlow.

        IDBFactory::open should not have a description argument.
        https://bugs.webkit.org/show_bug.cgi?id=50087

        Modified exisiting tests to cover this change.

        * storage/IDBDatabaseBackendImpl.cpp:
        (WebCore::setMetaData):
        (WebCore::IDBDatabaseBackendImpl::IDBDatabaseBackendImpl):
        (WebCore::IDBDatabaseBackendImpl::setVersionInternal):
        * storage/IDBDatabaseBackendImpl.h:
        (WebCore::IDBDatabaseBackendImpl::create):
        * storage/IDBDatabaseBackendInterface.h:
        * storage/IDBFactory.cpp:
        (WebCore::IDBFactory::open):
        * storage/IDBFactory.h:
        * storage/IDBFactory.idl:
        * storage/IDBFactoryBackendImpl.cpp:
        (WebCore::IDBFactoryBackendImpl::open):
        * storage/IDBFactoryBackendImpl.h:
        * storage/IDBFactoryBackendInterface.h:

2010-11-25  Kenichi Ishibashi  <bashi@google.com>

        Reviewed by Kent Tamura.

        Assertion failure by resetting <output> twice
        https://bugs.webkit.org/show_bug.cgi?id=50095

        Don't call setTextContentInternal() when the value wouldn't
        be changed.

        Test: fast/forms/output-reset-assertion-failed.html

        * html/HTMLOutputElement.cpp:
        (WebCore::HTMLOutputElement::HTMLOutputElement): Calls
        setTextContentInternal() if and only if needed.
        (WebCore::HTMLOutputElement::reset): Ditto.
        (WebCore::HTMLOutputElement::setValue): Ditto.
        (WebCore::HTMLOutputElement::setDefaultValue): Ditto.

2010-11-24  Ryosuke Niwa  <rniwa@webkit.org>

        Crash when moving caret around a word with a first-letter rule and whitespace is not collapsible.
        https://bugs.webkit.org/show_bug.cgi?id=49652

        Fixed the crash by giving the correct end offset to emitText in handleTextNode.

        This patch does not fix a bug in TextIterator that incorrectly calculates
        the end offset of a word with a first-letter rule as demonstrated in the layout test
        because fixing the bug requires an overhaul of TextIterator and new behavior is consistent
        with the case when whitespace is collapsible.

        Test: editing/text-iterator/first-letter-word-boundary.html

        * editing/TextIterator.cpp:
        (WebCore::TextIterator::handleTextNode):

2010-11-25  Mike Lawther  <mikelawther@chromium.org>

        Reviewed by Kent Tamura.

        Fix typos in CSS grammar (HERZ -> HERTZ)
        https://bugs.webkit.org/show_bug.cgi?id=50094

        * css/CSSGrammar.y:
        * css/CSSParser.cpp:
        (WebCore::CSSParser::lex):
        * css/tokenizer.flex:

2010-11-25  Antti Koivisto  <antti@apple.com>

        Reviewed by Dan Bernstein.

        https://bugs.webkit.org/show_bug.cgi?id=50078
        Simplify CachedResource error handling code by getting rid of the m_httpStatusCodeErrorOccurred boolean.

        * loader/cache/CachedImage.cpp:
        (WebCore::CachedImage::CachedImage):
        * loader/cache/CachedImage.h:
        (WebCore::CachedImage::shouldIgnoreHTTPStatusCodeErrors):
        * loader/cache/CachedResource.h:
        (WebCore::CachedResource::shouldIgnoreHTTPStatusCodeErrors):
        (WebCore::CachedResource::httpStatusCodeErrorOccurred):
        * loader/loader.cpp:
        (WebCore::Loader::didReceiveData):

2010-11-25  Andreas Kling  <kling@webkit.org>

        Reviewed by Tor Arne Vestbø.

        [Qt] Remove unnecessary save/restore in GraphicsContext::drawConvexPolygon()
        https://bugs.webkit.org/show_bug.cgi?id=50085

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::drawConvexPolygon):
        Remember the previous antialiasing mode and reset it after we're done.

2010-11-25  Ben Murdoch  <benm@google.com>

        Reviewed by Steve Block.

        Potential crash in JavaClassV8.cpp
        https://bugs.webkit.org/show_bug.cgi?id=50016

        It is possible that we attempt to free uninitialised
        memory in the JavaClass destrctor when using V8 in the
        case that the JVM could not find the class in the constructor.

        It turns out that the troublesome m_name is not acutally
        used anywhere, so we remove it in this patch.

        No new tests, just removing dead code.

        * bridge/jni/v8/JavaClassV8.cpp: Remove unused m_name.
        * bridge/jni/v8/JavaClassV8.h: Ditto.

2010-11-25  Hans Wennborg  <hans@chromium.org>

        Reviewed by Jeremy Orlow.

        IndexedDB: Better errors for not yet implemented features
        https://bugs.webkit.org/show_bug.cgi?id=50075

        Raise an exception if createObjectStore is called with autoIncrement
        set to true.

        Be a little bit more explicit in IDBBindingUtilities that we don't
        allow using Date objects as keys yet.

        * bindings/v8/IDBBindingUtilities.cpp:
        (WebCore::createIDBKeyFromValue):
        * storage/IDBDatabase.cpp:
        (WebCore::IDBDatabase::createObjectStore):
        * storage/IDBObjectStoreBackendImpl.cpp:
        (WebCore::IDBObjectStoreBackendImpl::putInternal):

2010-11-25  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: highlight diffs of revisions against base version.
        https://bugs.webkit.org/show_bug.cgi?id=50088

        * inspector/front-end/CSSStyleModel.js:
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged.callback):
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel):
        (WebInspector.ResourcesPanel.prototype.show):
        (WebInspector.ResourcesPanel.prototype._showResourceView.callback):
        (WebInspector.ResourcesPanel.prototype._showResourceView):
        (WebInspector.ResourcesPanel.prototype._applyDiffMarkup):
        (WebInspector.FrameResourceTreeElement.prototype._contentChanged):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame.prototype.markDiff):
        (WebInspector.SourceFrame.prototype._createViewerIfNeeded):
        (WebInspector.SourceFrame.prototype._updateDiffDecorations.addDecorations):
        (WebInspector.SourceFrame.prototype._updateDiffDecorations):
        (WebInspector.SourceFrame.prototype._removeDiffDecorations):
        * inspector/front-end/SourceView.js:
        * inspector/front-end/textViewer.css:
        (.webkit-line-number):
        (.diff-container .webkit-added-line .webkit-line-content):
        (.diff-container .webkit-removed-line .webkit-line-content):
        (.diff-container .webkit-changed-line .webkit-line-content):
        * inspector/front-end/utilities.js:

2010-11-25  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72732.
        http://trac.webkit.org/changeset/72732
        https://bugs.webkit.org/show_bug.cgi?id=50089

        Made Qt bot sad and crashy (Requested by Ossy on #webkit).

        * platform/network/qt/QNetworkReplyHandler.cpp:
        (WebCore::QNetworkReplyHandler::QNetworkReplyHandler):
        * platform/network/qt/QNetworkReplyHandler.h:
        * platform/network/qt/ResourceHandleQt.cpp:
        (WebCore::WebCoreSynchronousLoader::didFinishLoading):
        (WebCore::WebCoreSynchronousLoader::didFail):
        (WebCore::ResourceHandle::loadResourceSynchronously):

2010-11-25  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72734.
        http://trac.webkit.org/changeset/72734
        https://bugs.webkit.org/show_bug.cgi?id=50086

        Backing out 72732 which made Qt sad and crashy (Requested by
        kling on #webkit).

        * platform/network/qt/ResourceHandleQt.cpp:
        (WebCore::ResourceHandle::loadResourceSynchronously):

2010-11-25  Andreas Kling  <kling@webkit.org>

        Unreviewed crash fix for Qt 4.6.x.

        Check that QNetworkReplyHandler::reply() doesn't return null before
        using it (this code needs to work for Qt 4.6 as well.)

        * platform/network/qt/ResourceHandleQt.cpp:
        (WebCore::ResourceHandle::loadResourceSynchronously):

2010-11-25  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72727.
        http://trac.webkit.org/changeset/72727
        https://bugs.webkit.org/show_bug.cgi?id=50084

        Broke dom-breakpoints test on chromium win (Requested by
        podivilov on #webkit).

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::setNativeBreakpoint):
        * inspector/InspectorDOMAgent.cpp:
        (WebCore::InspectorDOMAgent::InspectorDOMAgent):
        (WebCore::InspectorDOMAgent::discardBindings):
        (WebCore::InspectorDOMAgent::setDOMBreakpoint):
        (WebCore::InspectorDOMAgent::removeDOMBreakpoint):
        (WebCore::InspectorDOMAgent::descriptionForDOMEvent):
        (WebCore::InspectorDOMAgent::removeBreakpointsForNode):
        (WebCore::InspectorDOMAgent::createBreakpointId):
        * inspector/InspectorDOMAgent.h:
        * inspector/front-end/BreakpointManager.js:
        (WebInspector.BreakpointManager.prototype.reset):
        (WebInspector.BreakpointManager.prototype.createDOMBreakpoint):
        (WebInspector.BreakpointManager.prototype._updateNativeBreakpointsInSettings):
        (WebInspector.BreakpointManager.prototype.restoreBreakpoints):
        (WebInspector.BreakpointManager.prototype.restoreDOMBreakpoints):
        (WebInspector.DOMBreakpoint):
        (WebInspector.DOMBreakpoint.prototype.populateLabelElement):
        (WebInspector.EventListenerBreakpoint):
        (WebInspector.XHRBreakpoint):
        * inspector/front-end/BreakpointsSidebarPane.js:
        (WebInspector.BreakpointsSidebarPane):
        (WebInspector.BreakpointsSidebarPane.prototype.reset):
        (WebInspector.EventListenerBreakpointsSidebarPane):
        (WebInspector.EventListenerBreakpointsSidebarPane.prototype.reset):
        * inspector/front-end/DOMAgent.js:
        (WebInspector.DOMAgent.prototype._setDocument):
        * inspector/front-end/ElementsPanel.js:
        (WebInspector.ElementsPanel.prototype.reset):
        * inspector/front-end/ElementsTreeOutline.js:
        (WebInspector.ElementsTreeElement.prototype._populateTagContextMenu.handlerFunction):
        (WebInspector.ElementsTreeElement.prototype._populateTagContextMenu):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.reset):
        * inspector/front-end/inspector.js:
        (WebInspector.reset):
        (WebInspector.didCommitLoad):

2010-11-25  Peter Hartmann  <peter.hartmann@nokia.com>

        Reviewed by Andreas Kling.

        [Qt] enable usage of synchronous HTTP feature in Qt
        https://bugs.webkit.org/show_bug.cgi?id=37191

        Currently, we spin an event loop when doing synchronous calls to
        wait for completion. This patch uses synchronous requests in Qt,
        if available, and spins the event loop as a fallback solution.
        Patch by Simon Hausmann and Peter Hartmann.

        * platform/network/qt/QNetworkReplyHandler.cpp:
        (WebCore::QNetworkReplyHandler::QNetworkReplyHandler):
        * platform/network/qt/QNetworkReplyHandler.h:
        * platform/network/qt/ResourceHandleQt.cpp:
        (WebCore::WebCoreSynchronousLoader::setReplyFinished):
        (WebCore::WebCoreSynchronousLoader::WebCoreSynchronousLoader):
        (WebCore::WebCoreSynchronousLoader::didFinishLoading):
        (WebCore::WebCoreSynchronousLoader::didFail):
        (WebCore::WebCoreSynchronousLoader::waitForCompletion):
        (WebCore::ResourceHandle::loadResourceSynchronously):

2010-11-25  Hans Wennborg  <hans@chromium.org>

        Reviewed by Jeremy Orlow.

        V8 Bindings: remove faulty include in OptionsObject.h
        https://bugs.webkit.org/show_bug.cgi?id=50073

        There is no <wtf/NonCopyable.h>, and the code doesn't try to use it
        either.

        No new functionality, no new tests.

        * bindings/v8/OptionsObject.h:

2010-11-25  Kenneth Rohde Christiansen  <kenneth@webkit.org>

        Reviewed by Simon Hausmann.

        Actually handle targetDensityDpi in computeViewportAttributes
        https://bugs.webkit.org/show_bug.cgi?id=50068

        * dom/ViewportArguments.cpp:
        (WebCore::computeViewportAttributes):

2010-11-25  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Steve Block.

        Add an OptionsObject class for IndexedDB (and later Geolocation)
        https://bugs.webkit.org/show_bug.cgi?id=50030

        Geolocation and IndexedDB both have the concept of an optional
        parameter that has various options supplied with it.  In
        Geolocation this was done with custom bindings, but I'm trying to
        avoid that for IndexedDB.  

        This first patch implements it in V8 and makes createObjectStore use it.
        The next patch will cover Geolocation and JSC.

        Test: storage/indexeddb/create-object-store-options.html

        * WebCore.gypi:
        * bindings/scripts/CodeGeneratorV8.pm:
        * bindings/scripts/test/CPP/WebDOMTestObj.cpp:
        (WebDOMTestObj::optionsObject):
        * bindings/scripts/test/CPP/WebDOMTestObj.h:
        * bindings/scripts/test/GObject/WebKitDOMTestCallback.cpp:
        * bindings/scripts/test/GObject/WebKitDOMTestInterface.cpp:
        * bindings/scripts/test/GObject/WebKitDOMTestMediaQueryListListener.cpp:
        * bindings/scripts/test/GObject/WebKitDOMTestObj.cpp:
        (webkit_dom_test_obj_options_object):
        * bindings/scripts/test/GObject/WebKitDOMTestObj.h:
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::jsTestObjPrototypeFunctionOptionsObject):
        * bindings/scripts/test/JS/JSTestObj.h:
        * bindings/scripts/test/ObjC/DOMTestObj.h:
        * bindings/scripts/test/ObjC/DOMTestObj.mm:
        (-[DOMTestObj optionsObject:ooo:]):
        * bindings/scripts/test/TestObj.idl:
        * bindings/scripts/test/V8/V8TestMediaQueryListListener.cpp:
        (WebCore::ConfigureV8TestMediaQueryListListenerTemplate):
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjInternal::optionsObjectCallback):
        * bindings/v8/OptionsObject.cpp: Added.
        (WebCore::OptionsObject::OptionsObject):
        (WebCore::OptionsObject::~OptionsObject):
        (WebCore::OptionsObject::operator=):
        (WebCore::OptionsObject::undefinedOrNull):
        (WebCore::OptionsObject::getKeyBool):
        (WebCore::OptionsObject::getKeyString):
        (WebCore::OptionsObject::getKey):
        * bindings/v8/OptionsObject.h:
        * bindings/js/OptionsObject.h:
        * storage/IDBDatabase.cpp:
        (WebCore::IDBDatabase::createObjectStore):
        * storage/IDBDatabase.h:
        (WebCore::IDBDatabase::createObjectStore):
        * storage/IDBDatabase.idl:

2010-11-24  Pavel Podivilov  <podivilov@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: set DOM breakpoints by path.
        https://bugs.webkit.org/show_bug.cgi?id=50017

        This change is needed to be able to push DOM breakpoints for all URL's to backend
        at frontend load.

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::setNativeBreakpoint):
        * inspector/InspectorDOMAgent.cpp:
        (WebCore::InspectorDOMAgent::InspectorDOMAgent):
        (WebCore::InspectorDOMAgent::discardBindings):
        (WebCore::InspectorDOMAgent::setDOMBreakpoint):
        (WebCore::InspectorDOMAgent::removeDOMBreakpoint):
        (WebCore::InspectorDOMAgent::descriptionForDOMEvent):
        (WebCore::InspectorDOMAgent::removeBreakpointsForNode):
        * inspector/InspectorDOMAgent.h:
        * inspector/front-end/BreakpointManager.js:
        (WebInspector.BreakpointManager.prototype.reset):
        (WebInspector.BreakpointManager.prototype.createDOMBreakpoint):
        (WebInspector.BreakpointManager.prototype._updateNativeBreakpointsInSettings):
        (WebInspector.BreakpointManager.prototype.restoreBreakpoints):
        (WebInspector.DOMBreakpoint):
        (WebInspector.DOMBreakpoint.prototype._setNodeId):
        (WebInspector.DOMBreakpoint.prototype.populateLabelElement):
        (WebInspector.EventListenerBreakpoint):
        (WebInspector.XHRBreakpoint):
        * inspector/front-end/BreakpointsSidebarPane.js:
        (WebInspector.BreakpointsSidebarPane):
        (WebInspector.BreakpointsSidebarPane.prototype._reset):
        (WebInspector.EventListenerBreakpointsSidebarPane):
        (WebInspector.EventListenerBreakpointsSidebarPane.prototype._reset):
        * inspector/front-end/DOMAgent.js:
        (WebInspector.DOMAgent.prototype._setDocument):
        * inspector/front-end/ElementsPanel.js:
        (WebInspector.ElementsPanel.prototype.reset):
        * inspector/front-end/ElementsTreeOutline.js:
        (WebInspector.ElementsTreeElement.prototype._populateTagContextMenu.handlerFunction):
        (WebInspector.ElementsTreeElement.prototype._populateTagContextMenu):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.reset):
        * inspector/front-end/inspector.js:
        (WebInspector.reset):
        (WebInspector.didCommitLoad):

2010-11-25  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: reuse code for recreating resource views.
        https://bugs.webkit.org/show_bug.cgi?id=50066

        * inspector/front-end/NetworkItemView.js:
        (WebInspector.NetworkItemView):
        * inspector/front-end/NetworkPanel.js:
        (WebInspector.NetworkPanel.prototype.refreshResource):
        * inspector/front-end/ResourceManager.js:
        (WebInspector.ResourceManager.resourceViewTypeMatchesResource):
        (WebInspector.ResourceManager.resourceViewForResource):
        (WebInspector.ResourceManager.recreateResourceView):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.FrameResourceTreeElement.prototype._contentChanged):

2010-11-25  Hans Wennborg  <hans@chromium.org>

        Reviewed by Jeremy Orlow.

        IndexedDB: Disallow inserting records with NULL keys
        https://bugs.webkit.org/show_bug.cgi?id=50033

        Disallow inserting records with null keys into the object store.

        * storage/IDBKey.h:
        * storage/IDBObjectStoreBackendImpl.cpp:
        (WebCore::IDBObjectStoreBackendImpl::putInternal):

2010-11-25  Philippe Normand  <pnormand@igalia.com>

        Rubber-stamped by Xan Lopez.

        g_signal_accumulator_first_wins was introduced in glib 2.27.1 so
        no need to use our version if that version of glib is used during
        the build.

        * platform/gtk/GtkVersioning.c:
        * platform/gtk/GtkVersioning.h:

2010-11-24  Jian Li  <jianli@chromium.org>

        Reviewed by Kenneth Russell.

        Implement DataView interface from Typed Array specification
        https://bugs.webkit.org/show_bug.cgi?id=46541

        Test: fast/canvas/webgl/data-view-test.html

        * CMakeLists.txt:
        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pri:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/generic/RuntimeEnabledFeatures.h:
        (WebCore::RuntimeEnabledFeatures::dataViewEnabled):
        * bindings/js/JSArrayBufferViewHelper.h:
        (WebCore::constructArrayBufferViewWithArrayBufferArgument):
        (WebCore::constructArrayBufferView):
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::dataView):
        * bindings/js/JSDataViewCustom.cpp: Added.
        * bindings/js/JSFloat32ArrayCustom.cpp:
        (WebCore::JSFloat32ArrayConstructor::constructJSFloat32Array):
        * bindings/js/JSInt16ArrayCustom.cpp:
        (WebCore::JSInt16ArrayConstructor::constructJSInt16Array):
        * bindings/js/JSInt32ArrayCustom.cpp:
        (WebCore::JSInt32ArrayConstructor::constructJSInt32Array):
        * bindings/js/JSInt8ArrayCustom.cpp:
        (WebCore::JSInt8ArrayConstructor::constructJSInt8Array):
        * bindings/js/JSUint16ArrayCustom.cpp:
        (WebCore::JSUint16ArrayConstructor::constructJSUint16Array):
        * bindings/js/JSUint32ArrayCustom.cpp:
        (WebCore::JSUint32ArrayConstructor::constructJSUint32Array):
        * bindings/js/JSUint8ArrayCustom.cpp:
        (WebCore::JSUint8ArrayConstructor::constructJSUint8Array):
        * bindings/v8/custom/V8ArrayBufferViewCustom.h:
        (WebCore::constructWebGLArrayWithArrayBufferArgument):
        (WebCore::constructWebGLArray):
        * bindings/v8/custom/V8DataViewCustom.cpp: Added.
        * html/canvas/ArrayBufferView.h:
        (WebCore::ArrayBufferView::isDataView):
        * html/canvas/DataView.cpp: Added.
        * html/canvas/DataView.h: Added.
        * html/canvas/DataView.idl: Added.
        * page/DOMWindow.idl:

2010-11-24  Nicolas Dufresne  <nicolas.dufresne@collabora.co.uk>

        Reviewed by Martin Robinson.

        [GTK] Windowless plugins gets broken key input
        https://bugs.webkit.org/show_bug.cgi?id=49927

        When converting the GdkEvent to XEvent we need to send the
        hardware_keycode as XEvent::keycode. Instead we where sending
        the GdkEvent::keyval. This is already tested by
        plugins/keyboard-events.html, but a bug in the test plugin was
        resulting in false positive.

        * plugins/gtk/PluginViewGtk.cpp:
        (WebCore::PluginView::handleKeyboardEvent):

2010-11-24  Eric Uhrhane  <ericu@chromium.org>

        Reviewed by David Levin.

        Implement FileWriterSync
        https://bugs.webkit.org/show_bug.cgi?id=49939

        Tests to follow in a separate CL, once the test framework in 47680 goes in.

        Build file changes to add FileWriterBase and FileWriterBaseCallback.
        * CMakeLists.txt:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:

        FileWriterSync doesn't turn out to need to be an ActiveDOMObject.
        * bindings/scripts/CodeGeneratorV8.pm:

        Added new AsyncFileWriter::waitForOperationToComplete to enable
        synchronous calls.
        * fileapi/AsyncFileWriter.h:

        Added a way to get a FileSystemSync.
        * fileapi/DOMFileSystemSync.cpp:
        * fileapi/FileEntrySync.cpp:
        * fileapi/FileEntrySync.h:
        * fileapi/FileEntrySync.idl:

        Added an error code for OK, rather than just having 0 everywhere.
        * fileapi/FileError.h:

        Turned FileWriterCallback into FileWriterBaseCallback.
        * fileapi/FileSystemCallbacks.cpp:
        * fileapi/FileSystemCallbacks.h:

        Refactored out a common base class, FileWriterBase, for FileWriter and
        FileWriterSync.
        * fileapi/FileWriter.cpp:
        * fileapi/FileWriter.h:
        * fileapi/FileWriterBase.cpp: Added.
        * fileapi/FileWriterBase.h: Added.
        * fileapi/FileWriterBaseCallback.h: Added.
        * fileapi/FileWriterSync.cpp:
        * fileapi/FileWriterSync.h:

        Small tweaks to deal with the base class refactoring.
        * fileapi/DOMFileSystem.cpp:
        * fileapi/DOMFileSystemSync.h:

        Removed "CallWith=ScriptExecutionContext", as FileWriterSync doesn't actually need it.
        * fileapi/FileWriterSync.idl:

2010-11-24  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        Build fix for GTK+. There were some typos in my last build fix
        and the empty command (semicolon) seems to be necessary for wildcard
        rule chains.

        * GNUmakefile.am: Small build fixes.

2010-11-24  James Robinson  <jamesr@chromium.org>

        Reviewed by Kenneth Russell.

        [chromium] Compositor needs to manage its VRAM use
        https://bugs.webkit.org/show_bug.cgi?id=49629

        This adds a basic texture manager to the Chromium compositor to limit the amount of VRAM
        used by compositor textures and switches ContentLayerChromium, ImageLayerChromium, and
        RenderSurfaceChromium to use managed LayerTexture.  The other *LayerChromium classes (Canvas,
        Video, and WebGL) and the root layer are still unmanaged.

        The TextureManager works by providing tokens to callers that want to use a managed texture.
        The token can be used to request a texture, see if the previously requested texture is still
        available, and to protect/unprotect textures when they cannot be collected.  Whenever a
        texture is created the manager attempts to free up the least recently used textures until the
        total memory use is below the provided threshhold.  If the manager cannot satisfy the memory
        limit it will not return any new textures until some old textures are released.

        A LayerTexture wraps a TextureManager token, size, and format.  A LayerChromium can check if a
        previously requested texture is still available for use and reserve the LayerTexture's underlying
        storage between the updateContentsIfDirty() and the draw() call.

        Also changes LayerChromium from having separate contentsDirty()/updateContents() calls to a single
        updateContentsIfDirty().

        Tests: compositing/lots-of-img-layers-with-opacity.html
               compositing/lots-of-img-layers.html

        * WebCore.gypi:
        * platform/graphics/chromium/Canvas2DLayerChromium.cpp:
        (WebCore::Canvas2DLayerChromium::updateContentsIfDirty):
        * platform/graphics/chromium/Canvas2DLayerChromium.h:
        * platform/graphics/chromium/ContentLayerChromium.cpp:
        (WebCore::ContentLayerChromium::cleanupResources):
        (WebCore::ContentLayerChromium::updateContentsIfDirty):
        (WebCore::ContentLayerChromium::updateTextureRect):
        (WebCore::ContentLayerChromium::draw):
        * platform/graphics/chromium/ContentLayerChromium.h:
        * platform/graphics/chromium/ImageLayerChromium.cpp:
        (WebCore::ImageLayerChromium::updateContentsIfDirty):
        * platform/graphics/chromium/ImageLayerChromium.h:
        * platform/graphics/chromium/LayerChromium.h:
        (WebCore::LayerChromium::updateContentsIfDirty):
        (WebCore::LayerChromium::draw):
        * platform/graphics/chromium/LayerRendererChromium.cpp:
        (WebCore::LayerRendererChromium::LayerRendererChromium):
        (WebCore::LayerRendererChromium::prepareToDrawLayers):
        (WebCore::LayerRendererChromium::drawLayers):
        (WebCore::LayerRendererChromium::updateLayersRecursive):
        (WebCore::LayerRendererChromium::useRenderSurface):
        (WebCore::LayerRendererChromium::drawLayer):
        (WebCore::LayerRendererChromium::initializeSharedObjects):
        (WebCore::LayerRendererChromium::cleanupSharedObjects):
        * platform/graphics/chromium/LayerRendererChromium.h:
        (WebCore::LayerRendererChromium::renderSurfaceSharedValues):
        (WebCore::LayerRendererChromium::textureManager):
        * platform/graphics/chromium/LayerTexture.cpp: Added.
        (WebCore::LayerTexture::LayerTexture):
        (WebCore::LayerTexture::~LayerTexture):
        (WebCore::LayerTexture::isValid):
        (WebCore::LayerTexture::reserve):
        (WebCore::LayerTexture::unreserve):
        (WebCore::LayerTexture::bindTexture):
        (WebCore::LayerTexture::framebufferTexture2D):
        * platform/graphics/chromium/LayerTexture.h: Added.
        (WebCore::LayerTexture::create):
        * platform/graphics/chromium/PluginLayerChromium.cpp:
        (WebCore::PluginLayerChromium::updateContentsIfDirty):
        * platform/graphics/chromium/PluginLayerChromium.h:
        * platform/graphics/chromium/RenderSurfaceChromium.cpp:
        (WebCore::RenderSurfaceChromium::SharedValues::SharedValues):
        (WebCore::RenderSurfaceChromium::SharedValues::~SharedValues):
        (WebCore::RenderSurfaceChromium::RenderSurfaceChromium):
        (WebCore::RenderSurfaceChromium::cleanupResources):
        (WebCore::RenderSurfaceChromium::prepareContentsTexture):
        (WebCore::RenderSurfaceChromium::draw):
        * platform/graphics/chromium/RenderSurfaceChromium.h:
        (WebCore::RenderSurfaceChromium::SharedValues::shaderProgram):
        (WebCore::RenderSurfaceChromium::SharedValues::shaderSamplerLocation):
        (WebCore::RenderSurfaceChromium::SharedValues::shaderMatrixLocation):
        (WebCore::RenderSurfaceChromium::SharedValues::shaderAlphaLocation):
        (WebCore::RenderSurfaceChromium::SharedValues::initialized):
        * platform/graphics/chromium/TextureManager.cpp: Added.
        (WebCore::memoryUseBytes):
        (WebCore::TextureManager::TextureManager):
        (WebCore::TextureManager::getToken):
        (WebCore::TextureManager::releaseToken):
        (WebCore::TextureManager::hasTexture):
        (WebCore::TextureManager::protectTexture):
        (WebCore::TextureManager::unprotectTexture):
        (WebCore::TextureManager::reduceMemoryToLimit):
        (WebCore::TextureManager::addTexture):
        (WebCore::TextureManager::removeTexture):
        (WebCore::TextureManager::requestTexture):
        * platform/graphics/chromium/TextureManager.h: Added.
        (WebCore::TextureManager::create):
        * platform/graphics/chromium/VideoLayerChromium.cpp:
        (WebCore::VideoLayerChromium::updateContentsIfDirty):
        * platform/graphics/chromium/VideoLayerChromium.h:
        * platform/graphics/chromium/WebGLLayerChromium.cpp:
        (WebCore::WebGLLayerChromium::updateContentsIfDirty):
        * platform/graphics/chromium/WebGLLayerChromium.h:

2010-11-24  Nicolas Dufresne  <nicolas.dufresne@collabora.co.uk>

        Reviewed by Martin Robinson.

        [GTK] response.isNull() assert when using directory file URI
        https://bugs.webkit.org/show_bug.cgi?id=49018

        Do ensure that didReceiveResponse happens before any call to
        didReceiveData. That was not true for file:// URIs pointing to
        directories and thus was triggering an assertion.

        Test: platform/gtk/fast/loader/crash-display-local-directory.html

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::gotHeadersCallback):
        (WebCore::contentSniffedCallback):
        (WebCore::parseDataUrl):
        (WebCore::sendRequestCallback):
        (WebCore::readCallback):

2010-11-24  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Martin Robinson.

        * bindings/gobject/WebKitDOMBinding.h: fix stlye nit.

2010-11-24  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Make kit() methods return the proper type instead of gpointer
        https://bugs.webkit.org/show_bug.cgi?id=50034

        Change kit() methods to return proper type pointer.

        * bindings/gobject/WebKitDOMBinding.cpp: change implementions of
        kit methods.
        * bindings/gobject/WebKitDOMBinding.h: change their declarations.
        * bindings/scripts/CodeGeneratorGObject.pm: change the generated
        kit() methods.

2010-11-24  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] DerivedSources/WebCore/DocTypeStrings.cpp is generated for every build
        https://bugs.webkit.org/show_bug.cgi?id=50032

        Instead of listing two targets for rules that have two outputs, make
        a dependency chain. This fixes the issue where some files are generated
        unconditionally. Also remove all unnecessary semicolons from the file.

        No new tests as this is just a build fix.

        * GNUmakefile.am: Fix GNUmake dependency issue.

2010-11-24  Nico Weber  <nicolasweber@gmx.de>

        Reviewed by Adam Barth.

        Chromium/Mac: Make scaled images un-ugly when using the webkit image decoders
        https://bugs.webkit.org/show_bug.cgi?id=49965

        Probably covered by existing tests whose expectations were overwritten
        in http://trac.webkit.org/changeset/70858

        * platform/image-decoders/cg/ImageDecoderCG.cpp:
        (WebCore::RGBA32Buffer::asNewNativeImage):

2010-11-24  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: Crash when inspecting http://alphaarnhem.nl/beta/
        https://bugs.webkit.org/show_bug.cgi?id=50025

        @font-face rules were improperly handled by source data extractor.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::CSSParser):
        (WebCore::CSSParser::parseDeclaration):
        (WebCore::CSSParser::createStyleRule):
        (WebCore::CSSParser::markRuleBodyStart):
        (WebCore::CSSParser::markPropertyStart):
        (WebCore::CSSParser::markPropertyEnd):
        * css/CSSParser.h:

2010-11-24  Cris Neckar  <cdn@chromium.org>

        Reviewed by Adam Barth.

        Added check when parsing local fonts to ensure that a value's unit type is either string or ident.
        https://bugs.webkit.org/show_bug.cgi?id=49883

        Test: fast/css/local_font_invalid.html

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseFontFaceSrc):

2010-11-24  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: place local modifications to under original
        resource nodes in the resource panel.
        https://bugs.webkit.org/show_bug.cgi?id=50029

        * English.lproj/localizedStrings.js:
        * inspector/Inspector.idl:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::resourceRetrievedByXMLHttpRequest):
        (WebCore::InspectorController::scriptImported):
        * inspector/InspectorResourceAgent.cpp:
        (WebCore::InspectorResourceAgent::setInitialContent):
        * inspector/InspectorResourceAgent.h:
        * inspector/front-end/CSSStyleModel.js:
        (WebInspector.CSSStyleModel.prototype.setRuleSelector):
        (WebInspector.CSSStyleModel.prototype.addRule):
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged.callback):
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged):
        (WebInspector.CSSStyleDeclaration.prototype.insertPropertyAt):
        (WebInspector.CSSProperty.prototype.setText):
        (WebInspector.CSSProperty.prototype.setDisabled.callback):
        (WebInspector.CSSProperty.prototype.setDisabled):
        (WebInspector.CSSStyleSheet.prototype.setText):
        * inspector/front-end/NetworkPanel.js:
        (WebInspector.NetworkPanel.prototype.refreshResource):
        * inspector/front-end/Resource.js:
        (WebInspector.Resource.prototype.set content):
        (WebInspector.Resource.prototype.get contentTimestamp):
        (WebInspector.Resource.prototype.setInitialContent):
        * inspector/front-end/ResourceManager.js:
        (WebInspector.ResourceManager):
        (WebInspector.ResourceManager.prototype.setInitialContent):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel):
        (WebInspector.ResourcesPanel.prototype.reset):
        (WebInspector.ResourcesPanel.prototype._innerShowView):
        (WebInspector.FrameResourceTreeElement):
        (WebInspector.FrameResourceTreeElement.prototype._errorsWarningsUpdated):
        (WebInspector.FrameResourceTreeElement.prototype._contentChanged.else.finished):
        (WebInspector.FrameResourceTreeElement.prototype._contentChanged):
        (WebInspector.ResourceRevisionTreeElement):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame.prototype.get scrollTop):
        (WebInspector.SourceFrame.prototype.set scrollTop):
        * inspector/front-end/SourceView.js:
        (WebInspector.SourceView.prototype.get scrollTop):
        (WebInspector.SourceView.prototype.set scrollTop):
        (WebInspector.SourceView.prototype._editLine):
        (WebInspector.SourceView.prototype._editLineComplete):
        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertyTreeElement.prototype):

2010-11-24  Andrey Kosyakov  <caseq@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: extension API cleanup
        https://bugs.webkit.org/show_bug.cgi?id=50019

        * inspector/front-end/ElementsPanel.js:
        (WebInspector.ElementsPanel.this.treeOutline.focusedNodeChanged):
        (WebInspector.ElementsPanel):
        * inspector/front-end/ExtensionAPI.js: See bug for summary of extension API changes.
        (WebInspector.injectedExtensionAPI.Resources.resourceDispatch):
        (WebInspector.injectedExtensionAPI):
        (WebInspector.injectedExtensionAPI.Resources.prototype.getHAR):
        (WebInspector.injectedExtensionAPI.ResourceImpl.prototype.getContent):
        (WebInspector.injectedExtensionAPI.Panels.prototype.create):
        (WebInspector.injectedExtensionAPI.PanelImpl):
        (WebInspector.injectedExtensionAPI.PanelWithSidebarImpl):
        (WebInspector.injectedExtensionAPI.PanelWithSidebarImpl.prototype.createSidebarPane):
        (WebInspector.injectedExtensionAPI.PanelWithSidebarImpl.prototype.createWatchExpressionSidebarPane):
        (WebInspector.injectedExtensionAPI.ElementsPanel):
        (WebInspector.injectedExtensionAPI.ExtensionSidebarPaneImpl.prototype.setHeight):
        (WebInspector.injectedExtensionAPI.Audits.prototype.addCategory):
        (WebInspector.injectedExtensionAPI.AuditCategoryImpl.auditResultDispatch):
        (WebInspector.injectedExtensionAPI.AuditCategoryImpl):
        (WebInspector.injectedExtensionAPI.AuditResultImpl.prototype.get Severity):
        (WebInspector.injectedExtensionAPI.InspectedWindow):
        (WebInspector.injectedExtensionAPI.InspectedWindow.prototype.eval):
        * inspector/front-end/ExtensionCommon.js:
        (WebInspector.commonExtensionSymbols):
        * inspector/front-end/ExtensionServer.js:
        (WebInspector.ExtensionServer):
        (WebInspector.ExtensionServer.prototype.notifyObjectSelected):
        (WebInspector.ExtensionServer.prototype.notifyResourceFinished):
        (WebInspector.ExtensionServer.prototype.notifyPageLoaded):
        (WebInspector.ExtensionServer.prototype.notifyPageDOMContentLoaded):
        (WebInspector.ExtensionServer.prototype._onCreatePanel):
        (WebInspector.ExtensionServer.prototype._onReload):
        (WebInspector.ExtensionServer.prototype._onGetHAR):
        (WebInspector.ExtensionServer.prototype._onGetResourceContent):
        (WebInspector.ExtensionServer.prototype._onAddAuditCategory):
        (WebInspector.ExtensionServer.prototype._buildExtensionAPIInjectedScript):
        * inspector/front-end/HAREntry.js:
        (WebInspector.HARLog):
        (WebInspector.HARLog.prototype.build):
        (WebInspector.HARLog.prototype._convertResource):
        * inspector/front-end/inspector.js:
        (WebInspector.domContentEventFired):
        (WebInspector.loadEventFired):
        (WebInspector.didCommitLoad):

2010-11-23  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Steve Block.

        Fix minor errors in IndexedDB
        https://bugs.webkit.org/show_bug.cgi?id=49970

        * Remove SNAPSHOT_READ per spec.
        * Assert that the transaction that changes the db is a setVersion
          transaction.
        * When an objectStore already exists, throw a CONSTRAINT_ERR.
        * When not in a setVersion transaction, throw a NOT_ALLOWED_ERR.

        Test: storage/indexeddb/createAndRemoveObjectStore.html

        * storage/IDBDatabase.cpp:
        (WebCore::IDBDatabase::createObjectStore):
        * storage/IDBDatabaseBackendImpl.cpp:
        (WebCore::IDBDatabaseBackendImpl::createObjectStore):
        * storage/IDBTransaction.h:
        * storage/IDBTransaction.idl:

2010-11-24  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Xan Lopez.

        [GStreamer] pause webkitvideosink during fullscreen video playback
        https://bugs.webkit.org/show_bug.cgi?id=48824

        Added an identity element before the webkitvideosink so that when
        fullscreen video is active the element can drop the incoming
        buffers so that webkitvideosink appears paused.

        * platform/graphics/gstreamer/GStreamerGWorld.cpp:
        (WebCore::GStreamerGWorld::enterFullscreen):
        (WebCore::GStreamerGWorld::exitFullscreen):
        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivateGStreamer::createGSTPlayBin):

2010-11-24  Avi Drissman  <avi@google.com>

        Reviewed by Antonio Gomes.

        Add preference to not select when right-clicked
        https://bugs.webkit.org/show_bug.cgi?id=23351

        Test: editing/selection/context-menu-text-selection.html

        * editing/EditingBehavior.h:
        (WebCore::EditingBehavior::shouldSelectOnContextualMenuClick):
        * page/EventHandler.cpp:
        (WebCore::EventHandler::sendContextMenuEvent):

2010-11-24  Andras Becsi  <abecsi@inf.u-szeged.hu>

        Reviewed by Csaba Osztrogonác.

        Make build-webkit --minimal build with ENABLE_INSPECTOR=0.
        https://bugs.webkit.org/show_bug.cgi?id=49975

        No new tests needed.

        * features.pri: Make the Qt buildsystem aware
        that the inspector is enabled by default.

2010-11-24  Martin Robinson  <mrobinson@igalia.com>

        Reviewed by Xan Lopez.

        [GTK] The WebKitWebView should expose a set of signals encapsulating the behavior of the EditorClient
        https://bugs.webkit.org/show_bug.cgi?id=49143

        * platform/gtk/GtkVersioning.c:
        (g_signal_accumulator_first_wins): Add g_signal_accumulator_first_wins for versions of
        GLib before 2.28.
        * platform/gtk/GtkVersioning.h:

2010-11-24  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72499.
        http://trac.webkit.org/changeset/72499
        https://bugs.webkit.org/show_bug.cgi?id=50022

        This change is causing crashes on the bots. (Requested by
        mrobinson on #webkit).

        * accessibility/AccessibilityMenuListOption.cpp:
        (WebCore::AccessibilityMenuListOption::nameForMSAA):
        * accessibility/AccessibilityMenuListOption.h:
        * accessibility/gtk/AXObjectCacheAtk.cpp:
        (WebCore::AXObjectCache::postPlatformNotification):
        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (setAtkStateSetFromCoreObject):
        (optionFromList):
        (optionFromSelection):
        (webkit_accessible_selection_add_selection):
        (webkit_accessible_selection_clear_selection):
        (webkit_accessible_selection_get_selection_count):
        (webkit_accessible_selection_is_child_selected):
        (webkit_accessible_selection_remove_selection):
        (webkit_accessible_text_get_text):
        (getInterfaceMaskFromObject):
        * platform/gtk/PopupMenuGtk.cpp:
        (WebCore::PopupMenuGtk::show):

2010-11-24  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Csaba Osztrogonác.

        Simplify makeprop.pl
        https://bugs.webkit.org/show_bug.cgi?id=49925

        Don't generate CSSPropertyNamesHash.h.
        Instead generate CSSPropertyNames directly.

        * GNUmakefile.am: Removed rule for CSSPropertyNamesHash.h.
        * css/makeprop.pl:

2010-11-24  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Csaba Osztrogonác.

        Remove Bakefile build system files
        https://bugs.webkit.org/show_bug.cgi?id=49983

        r53757 only removed the content, but not the files.
        This patch removes that empty files.

        * WebCoreSources.bkl: Removed.
        * webcore-base.bkl: Removed.
        * webcore-wx.bkl: Removed.

2010-11-24  Renata Hodovan  <reni@inf.u-szeged.hu>

        Reviewed by Andreas Kling.

        [Qt] GraphicsContext: Clean up Qt/WebCore type conversion functions
        https://bugs.webkit.org/show_bug.cgi?id=49919

        Add ASSERT_NOT_REACHED() if the given WebCore type doesn't have an equivalent type in Qt.
        Also change the return value of toQtLineJoin() from Qt::MiterJoin to the default Qt::SvgMiterJoin,
        because the previous one doesn't work currently.

        No new test is needed.

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::toQtCompositionMode):
        (WebCore::toQtLineCap):
        (WebCore::toQtLineJoin):
        (WebCore::toQPenStyle):
        (WebCore::toQtFillRule):

2010-11-24  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Csaba Osztrogonác.

        Simplify makevalues.pl
        https://bugs.webkit.org/show_bug.cgi?id=49926

        Don't generate CSSValueKeywordsHash.h.
        Instead generate CSSValueKeywords.cpp directly. 

        * GNUmakefile.am: Removed rule for CSSValueKeywordsHash.h.
        * css/makevalues.pl:

2010-11-24  Andras Becsi  <abecsi@inf.u-szeged.hu>

        Reviewed by Kenneth Rohde Christiansen.

        Make WebKit2 compile with !ENABLE(INSPECTOR).
        https://bugs.webkit.org/show_bug.cgi?id=49973

        No new tests needed.

        * bindings/js/ScriptHeapSnapshot.h:
        * bindings/js/ScriptProfile.cpp:
        * bindings/js/ScriptProfile.h:
        * inspector/InspectorDebuggerAgent.cpp:
        * inspector/InspectorDebuggerAgent.h:
        * inspector/InspectorProfilerAgent.cpp:
        * inspector/InspectorProfilerAgent.h:
        * inspector/ScriptBreakpoint.h:

2010-11-24  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Csaba Osztrogonác.

        Simplify make-hash-tools.pl
        https://bugs.webkit.org/show_bug.cgi?id=49922

        HashTools.h does not need to be generated, because it only contains static code.

        * html/DocTypeStrings.gperf: Include findDoctypeEntry function.
        * make-hash-tools.pl: Do not generate HashTools.h.
        * platform/ColorData.gperf: Include findColor function.
        * platform/HashTools.h: Added.

2010-11-24  Andreas Kling  <kling@webkit.org>

        Reviewed by Simon Hausmann.

        [Qt] Pass Qt::TextBypassShaping flag when calculating shadow layer rects

        Without this, we could end up with a slightly too small shadow layer
        for some string/font combinations.

        * platform/graphics/qt/FontQt.cpp:
        (WebCore::drawTextCommon):

2010-11-22  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: add timing tab to the network item view.
        https://bugs.webkit.org/show_bug.cgi?id=49920

        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * inspector/front-end/NetworkItemView.js:
        (WebInspector.NetworkItemView):
        * inspector/front-end/NetworkPanel.js:
        (WebInspector.NetworkPanel.prototype._showPopover):
        * inspector/front-end/Resource.js:
        (WebInspector.Resource.prototype.set timing):
        * inspector/front-end/ResourceTimingView.js: Added.
        (WebInspector.ResourceTimingView):
        (WebInspector.ResourceTimingView.prototype.show):
        (WebInspector.ResourceTimingView.prototype._refresh):
        (WebInspector.ResourceTimingView.createTimingTable):
        * inspector/front-end/WebKit.qrc:
        * inspector/front-end/inspector.html:
        * inspector/front-end/networkPanel.css:
        (#network-views .network-item-view .tabbed-pane-header):
        (.resource-timing-view):
        (.resource-timing-view table):
        (.resource-timing-view .network-timing-bar):
        (.resource-timing-view .network-timing-bar.proxy):
        (.resource-timing-view .network-timing-bar.dns):
        (.resource-timing-view .network-timing-bar.connecting):
        (.resource-timing-view .network-timing-bar.ssl):
        (.resource-timing-view .network-timing-bar.sending):
        (.resource-timing-view .network-timing-bar.waiting):
        (.resource-timing-view .network-timing-bar.receiving):
        (.resource-timing-view.visible):

2010-11-24  Pavel Feldman  <pfeldman@chromium.org>

        Not reviewed. Follow up to r72652 (style id change in inspector).

        * inspector/front-end/AuditRules.js:
        (WebInspector.AuditRules.UnusedCssRule.prototype.doRun.evalCallback.selectorsCallback):

2010-11-22  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: refactor ResourceView hierarchy.
        https://bugs.webkit.org/show_bug.cgi?id=49864

        This refactoring splits ResourceView.js into:
            NetworkItemView.js (tabbed pane)
            ResourceHeadersView.js (header tab)
            ResourceCookiesView.js (cookies tab)
            ResourceView.js (base class for content tab).
        CookiesTable was extracted from CookieItemsView and
        brushed up. headersVisible flag has been removed.

        * English.lproj/localizedStrings.js:
        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * inspector/front-end/CookieItemsView.js:
        (WebInspector.CookieItemsView):
        (WebInspector.CookieItemsView.prototype.get statusBarItems):
        (WebInspector.CookieItemsView.prototype.hide):
        (WebInspector.CookieItemsView.prototype.resize):
        (WebInspector.CookieItemsView.prototype._updateWithCookies):
        (WebInspector.CookieItemsView.prototype._filterCookiesForDomain):
        (WebInspector.CookieItemsView.prototype._deleteCookie):
        (WebInspector.CookieItemsView.prototype._deleteButtonClicked):
        (WebInspector.CookieItemsView.prototype._refreshButtonClicked):
        (WebInspector.SimpleCookiesTable):
        (WebInspector.SimpleCookiesTable.prototype.setCookies):
        (WebInspector.SimpleCookiesTable.prototype.resize):
        * inspector/front-end/CookiesTable.js: Added.
        (WebInspector.CookiesTable):
        (WebInspector.CookiesTable.prototype.updateWidths):
        (WebInspector.CookiesTable.prototype.setCookies):
        (WebInspector.CookiesTable.prototype.addCookiesFolder):
        (WebInspector.CookiesTable.prototype.get selectedCookie):
        (WebInspector.CookiesTable.prototype._rebuildTable):
        (WebInspector.CookiesTable.prototype.reset):
        (WebInspector.CookiesTable.prototype._populateNode):
        (WebInspector.CookiesTable.prototype._totalSize):
        (WebInspector.CookiesTable.prototype._sortCookies.localeCompare):
        (WebInspector.CookiesTable.prototype._sortCookies.numberCompare):
        (WebInspector.CookiesTable.prototype._sortCookies.expiresCompare):
        (WebInspector.CookiesTable.prototype._sortCookies):
        (WebInspector.CookiesTable.prototype._createGridNode):
        (WebInspector.CookiesTable.prototype._onDeleteFromGrid):
        * inspector/front-end/FileSystemView.js:
        (WebInspector.FileSystemView.prototype._selectFileSystemTab):
        (WebInspector.FileSystemView.prototype.selectTemporaryFileSystemTab):
        * inspector/front-end/FontView.js:
        (WebInspector.FontView.prototype.hasContent):
        (WebInspector.FontView.prototype._createContentIfNeeded):
        (WebInspector.FontView.prototype.show):
        (WebInspector.FontView.prototype.updateFontPreviewSize):
        * inspector/front-end/ImageView.js:
        (WebInspector.ImageView.prototype.hasContent):
        (WebInspector.ImageView.prototype.show):
        * inspector/front-end/NetworkItemView.js: Added.
        (WebInspector.NetworkItemView):
        (WebInspector.NetworkItemView.prototype.show):
        (WebInspector.NetworkItemView.prototype._selectTab):
        (WebInspector.NetworkItemView.prototype._tabSelected):
        (WebInspector.NetworkItemView.prototype.resize):
        (WebInspector.NetworkItemView.prototype.selectContentTab):
        * inspector/front-end/NetworkPanel.js:
        (WebInspector.NetworkPanel.prototype.show):
        (WebInspector.NetworkPanel.prototype.refreshResource):
        (WebInspector.NetworkPanel.prototype._showResource):
        (WebInspector.NetworkPanel.prototype._closeVisibleResource):
        * inspector/front-end/ResourceCookiesView.js: Added.
        (WebInspector.ResourceCookiesView):
        (WebInspector.ResourceCookiesView.prototype.show):
        * inspector/front-end/ResourceHeadersView.js: Added.
        (WebInspector.ResourceHeadersView):
        (WebInspector.ResourceHeadersView.prototype._refreshURL):
        (WebInspector.ResourceHeadersView.prototype._refreshQueryString):
        (WebInspector.ResourceHeadersView.prototype._refreshFormData):
        (WebInspector.ResourceHeadersView.prototype._refreshRequestPayload):
        (WebInspector.ResourceHeadersView.prototype._refreshParms):
        (WebInspector.ResourceHeadersView.prototype._toggleURLdecoding):
        (WebInspector.ResourceHeadersView.prototype._getHeaderValue):
        (WebInspector.ResourceHeadersView.prototype._refreshRequestHeaders):
        (WebInspector.ResourceHeadersView.prototype._refreshResponseHeaders):
        (WebInspector.ResourceHeadersView.prototype._refreshHTTPInformation):
        (WebInspector.ResourceHeadersView.prototype._refreshHeaders):
        * inspector/front-end/ResourceView.js:
        (WebInspector.ResourceView):
        (WebInspector.ResourceView.prototype.hasContent):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel.prototype.show):
        (WebInspector.ResourcesPanel.prototype.showResource):
        (WebInspector.ResourcesPanel.prototype._showResourceView):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.show):
        (WebInspector.ScriptsPanel.prototype._showScriptOrResource):
        * inspector/front-end/SourceView.js:
        (WebInspector.SourceView):
        (WebInspector.SourceView.prototype.show):
        (WebInspector.SourceView.prototype.hide):
        (WebInspector.SourceView.prototype.resize):
        (WebInspector.SourceView.prototype.setupSourceFrameIfNeeded):
        (WebInspector.SourceView.prototype.hasContent):
        (WebInspector.SourceView.prototype.updateLocalContent):
        (WebInspector.SourceView.prototype.selectLocalContentTab):
        * inspector/front-end/StylesSidebarPane.js:
        * inspector/front-end/TabbedPane.js:
        (WebInspector.TabbedPane):
        (WebInspector.TabbedPane.prototype.appendTab):
        (WebInspector.TabbedPane.prototype.selectTab):
        (WebInspector.TabbedPane.prototype._showTab):
        (WebInspector.TabbedPane.prototype._hideTab):
        * inspector/front-end/WebKit.qrc:
        * inspector/front-end/inspector.css:
        (.webkit-line-gutter-backdrop):
        (.resource-view):
        (.resource-view.visible):
        (.resource-view.font):
        (.resource-view.image > .image):
        (.resource-view.image > .info):
        (.storage-view):
        (.storage-view .data-grid):
        (.storage-empty-view, .storage-view .storage-table-error):
        (.storage-view .storage-table-error):
        * inspector/front-end/inspector.html:
        * inspector/front-end/networkPanel.css:
        (.network-cell-subtitle):
        (.network-header-subtitle):
        (#network-views .network-item-view .tabbed-pane-header):
        (#network-views.small .network-item-view .tabbed-pane-header):
        (.network-item-view):
        (.network-item-view.visible):
        (.network-item-view .tabbed-pane-header):
        (.network-item-view .scope-bar li):
        (.resource-headers-view):
        (.resource-headers-view.visible):
        (.resource-headers-view .outline-disclosure .parent):
        (.resource-headers-view .outline-disclosure .children li):
        (.resource-headers-view .outline-disclosure li.expanded .header-count):
        (.resource-headers-view .outline-disclosure .header-name):
        (.resource-headers-view .outline-disclosure .header-value):
        (.resource-headers-view .outline-disclosure .raw-form-data):
        (.resource-cookies-view):
        (.resource-cookies-view.visible):
        (.resource-cookies-view .data-grid):
        (.resource-cookies-view .data-grid .row-group):

2010-11-24  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: add "Locally modified" group into the resource panel.
        https://bugs.webkit.org/show_bug.cgi?id=50005

        * English.lproj/localizedStrings.js:
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel):
        (WebInspector.ResourcesPanel.prototype.reset):
        (WebInspector.ResourcesPanel.prototype.addLocallyModifiedRevision):
        (WebInspector.ResourcesPanel.prototype._innerShowView):
        (WebInspector.BaseStorageTreeElement.prototype.set titleText):
        (WebInspector.LocallyModifiedResourceTreeElement):
        (WebInspector.LocallyModifiedResourceTreeElement.prototype.onselect):
        (WebInspector.LocallyModifiedResourceTreeElement.prototype.gcRevisions):
        (WebInspector.LocallyModifiedRevisionTreeElement):
        (WebInspector.LocallyModifiedRevisionTreeElement.prototype.onattach):
        (WebInspector.LocallyModifiedRevisionTreeElement.prototype.onselect):
        (WebInspector.LocallyModifiedRevisionTreeElement.prototype._ondragstart):

2010-11-24  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Yury Semikhatsky.

        Web Inspector: pass style id to front-end as Object, not string.
        https://bugs.webkit.org/show_bug.cgi?id=49971

        * inspector/Inspector.idl:
        * inspector/InspectorCSSAgent.cpp:
        (WebCore::InspectorCSSAgent::getStylesForNode2):
        (WebCore::InspectorCSSAgent::getStyleSheetText2):
        (WebCore::InspectorCSSAgent::setPropertyText2):
        (WebCore::InspectorCSSAgent::toggleProperty2):
        (WebCore::InspectorCSSAgent::setRuleSelector2):
        * inspector/InspectorCSSAgent.h:
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::InspectorStyle::buildObjectForStyle):
        (WebCore::InspectorStyleSheet::finalURL):
        (WebCore::InspectorStyleSheet::ruleForId):
        (WebCore::InspectorStyleSheet::buildObjectForStyleSheet):
        (WebCore::InspectorStyleSheet::buildObjectForRule):
        (WebCore::InspectorStyleSheet::text):
        (WebCore::InspectorStyleSheet::ruleOrStyleId):
        (WebCore::InspectorStyleSheetForInlineStyle::InspectorStyleSheetForInlineStyle):
        (WebCore::InspectorStyleSheetForInlineStyle::text):
        * inspector/InspectorStyleSheet.h:
        (WebCore::InspectorCSSId::InspectorCSSId):
        (WebCore::InspectorCSSId::isEmpty):
        (WebCore::InspectorCSSId::styleSheetId):
        (WebCore::InspectorCSSId::ordinal):
        (WebCore::InspectorCSSId::asInspectorValue):
        (WebCore::InspectorStyleSheet::id):
        (WebCore::InspectorStyleSheetForInlineStyle::styleForId):
        * inspector/front-end/CSSStyleModel.js:
        (WebInspector.CSSStyleModel.prototype.setRuleSelector):
        (WebInspector.CSSStyleModel.prototype.addRule):
        (WebInspector.CSSStyleModel.prototype._styleSheetChanged):
        (WebInspector.CSSStyleDeclaration.prototype.insertPropertyAt):
        (WebInspector.CSSProperty.prototype.setText):
        (WebInspector.CSSProperty.prototype.setDisabled.callback):
        (WebInspector.CSSProperty.prototype.setDisabled):
        (WebInspector.CSSStyleSheet.createForId):
        (WebInspector.CSSStyleSheet.prototype.setText):

2010-11-24  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72647.
        http://trac.webkit.org/changeset/72647
        https://bugs.webkit.org/show_bug.cgi?id=50009

        breaks the http layout tests (Requested by philn-tp on
        #webkit).

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::sendRequestCallback):
        (WebCore::startHttp):
        (WebCore::ResourceHandle::platformSetDefersLoading):

2010-11-23  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Martin Robinson.

        [soup] implement ResourceHandle::platformSetDefersLoading
        https://bugs.webkit.org/show_bug.cgi?id=44158

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::platformSetDefersLoading): Implemented
        using the soup_session_{,un}pause_message APIs.

2010-11-22  Abhishek Arya  <inferno@chromium.org>

        Reviewed by Adam Barth.

        r71925 broke the chrome new tab page. r71925 blocked drag and drop
        of same security origin objects onto themselves if their origin is
        marked unique. We need to allow drag and drop in that scenario.
        https://bugs.webkit.org/show_bug.cgi?id=49098

        Test: http/tests/security/drag-drop-same-unique-origin.html

        * page/SecurityOrigin.cpp:
        (WebCore::SecurityOrigin::canReceiveDragData):

2010-11-23  Cris Neckar  <cdn@chromium.org>

        Reviewed by Dimitri Glazkov.

        Removed unneeded conversions to RenderBlock.
        https://bugs.webkit.org/show_bug.cgi?id=49896

        Test: fast/css/input-search-table-column-crash.html

        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::adjustControlHeightBasedOnLineHeight):

2010-11-23  Ryosuke Niwa  <rniwa@webkit.org>

        Reviewed by Adam Barth.

        XMLDocumentParser::notifyFinished calls ScriptController's executeScript without updating isEvaluated flag
        https://bugs.webkit.org/show_bug.cgi?id=49701

        Fixed the bug by calling ScriptElement's executeScript, which sets isEvaluated flag to true.

        Test: fast/dom/script-clone-rerun-src.xhtml

        * dom/XMLDocumentParser.cpp:
        (WebCore::XMLDocumentParser::notifyFinished):

2010-11-23  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72628.
        http://trac.webkit.org/changeset/72628
        https://bugs.webkit.org/show_bug.cgi?id=49994

        This patch is causing layout-test failtures on GTK Linux
        64-bit Debug (Requested by ctguil on #webkit).

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::renderParentObject):
        (WebCore::AccessibilityRenderObject::addChildren):
        * accessibility/AccessibilityRenderObject.h:
        * accessibility/chromium/AccessibilityObjectChromium.cpp:
        (WebCore::AccessibilityObject::accessibilityIgnoreAttachment):

2010-11-23  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Martin Robinson.

        [GTK] Fix IFrame DOM bindings API
        https://bugs.webkit.org/show_bug.cgi?id=49980

        Fix IFrame API naming. It needs special casing because of the two
        consecutive capital letters.

        * bindings/scripts/CodeGeneratorGObject.pm:

2010-11-23  Shimeng (Simon) Wang  <swang@google.com>

        Reviewed by Steve Block.

        Use platform bridge to set scroll position.
        https://bugs.webkit.org/show_bug.cgi?id=49550

        Refactoring only.  Existing tests shall suffice.

        * platform/android/PlatformBridge.h:
        * platform/android/ScrollViewAndroid.cpp:
        (WebCore::ScrollView::platformSetScrollPosition):

2010-11-23  Andreas Kling  <kling@webkit.org>

        Reviewed by Tor Arne Vestbø.

        [Qt] Selecting shadowed text causes rendering artifacts
        https://bugs.webkit.org/show_bug.cgi?id=49990

        When selecting text starting from the end of a word, we need to use
        the X coordinate of the start of the substring when calculating the
        bounding rect for a ContextShadow.

        * platform/graphics/qt/FontQt.cpp:
        (WebCore::drawTextCommon):

2010-11-23  Chris Guillory  <chris.guillory@google.com>

        Reviewed by Dimitri Glazkov.

        Include the FrameView widget of a RenderWidget in the accessibility tree.
        https://bugs.webkit.org/show_bug.cgi?id=49106

        Include render widget children in the accessibility tree for not mac webkit ports.

        Test: accessibility/iframe-has-document.html

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::renderParentObject):
        (WebCore::AccessibilityRenderObject::addChildren):
        (WebCore::AccessibilityRenderObject::addRenderWidgetChildren):
        * accessibility/AccessibilityRenderObject.h:
        * accessibility/chromium/AccessibilityObjectChromium.cpp:
        (WebCore::AccessibilityObject::accessibilityIgnoreAttachment):

2010-11-23  Chris Rogers  <crogers@google.com>

        Reviewed by Alexey Proskuryakov.

        Add .responseType and .response to XMLHttpRequest
        https://bugs.webkit.org/show_bug.cgi?id=49633

        Tests: fast/xmlhttprequest/xmlhttprequest-responsetype-abort.html
               fast/xmlhttprequest/xmlhttprequest-responsetype-arraybuffer.html
               fast/xmlhttprequest/xmlhttprequest-responsetype-document.html
               fast/xmlhttprequest/xmlhttprequest-responsetype-text.html

        * bindings/js/JSXMLHttpRequestCustom.cpp:
        (WebCore::JSXMLHttpRequest::markChildren):
        (WebCore::JSXMLHttpRequest::open):
        (WebCore::JSXMLHttpRequest::response):
        * bindings/v8/custom/V8XMLHttpRequestCustom.cpp:
        (WebCore::V8XMLHttpRequest::responseAccessorGetter):
        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::XMLHttpRequest):
        (WebCore::XMLHttpRequest::responseText):
        (WebCore::XMLHttpRequest::responseXML):
        (WebCore::XMLHttpRequest::responseBlob):
        (WebCore::XMLHttpRequest::responseArrayBuffer):
        (WebCore::XMLHttpRequest::setResponseType):
        (WebCore::XMLHttpRequest::responseType):
        (WebCore::XMLHttpRequest::setAsBlob):
        (WebCore::XMLHttpRequest::open):
        (WebCore::XMLHttpRequest::clearResponse):
        (WebCore::XMLHttpRequest::didFinishLoading):
        (WebCore::XMLHttpRequest::didReceiveData):
        * xml/XMLHttpRequest.h:
        (WebCore::XMLHttpRequest::asBlob):
        (WebCore::XMLHttpRequest::optionalResponseXML):
        (WebCore::XMLHttpRequest::optionalResponseBlob):
        (WebCore::XMLHttpRequest::responseTypeCode):
        (WebCore::XMLHttpRequest::optionalResponseArrayBuffer):
        * xml/XMLHttpRequest.idl:

2010-11-23  Abhishek Arya  <inferno@chromium.org>

        Reviewed by Adam Barth.

        dispatchEvent call in EventSource endRequest can lead to calling endRequest
        again which frees up the pending activity. Make sure we have request in flight
        to prevent that from happening.
        https://bugs.webkit.org/show_bug.cgi?id=49448

        Test: http/tests/eventsource/eventsource-status-error-iframe-crash.html

        * page/EventSource.cpp:
        (WebCore::EventSource::endRequest):
        (WebCore::EventSource::close):

2010-11-23  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r72618.
        http://trac.webkit.org/changeset/72618
        https://bugs.webkit.org/show_bug.cgi?id=49987

        "Newly added test is failing on Chromium-linux, patch author
        said to rollout" (Requested by jparent on #webkit).

        * editing/EditingBehavior.h:
        * page/EventHandler.cpp:
        (WebCore::EventHandler::sendContextMenuEvent):

2010-11-23  Avi Drissman  <avi@google.com>

        Reviewed by Antonio Gomes.

        Add preference to not select when right-clicked
        https://bugs.webkit.org/show_bug.cgi?id=23351

        Test: editing/selection/context-menu-text-selection.html

        * editing/EditingBehavior.h:
        (WebCore::EditingBehavior::shouldSelectOnContextualMenuClick):
        * page/EventHandler.cpp:
        (WebCore::EventHandler::sendContextMenuEvent):

2010-11-23  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: [STYLES] invalid color values are not marked as such.
        https://bugs.webkit.org/show_bug.cgi?id=49960

        Properties having a valid structure but invalid values will also
        be marked as non-parsedOk in the Styles pane.

        * css/CSSGrammar.y:
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::InspectorStyle::populateObjectWithStyleProperties):

2010-11-23  Adam Bergkvist  <adam.bergkvist@ericsson.com>

        Reviewed by Martin Robinson.

        [GTK] Building with Blob support fails
        https://bugs.webkit.org/show_bug.cgi?id=49724

        Build fix.

        * GNUmakefile.am:
        * platform/gtk/FileSystemGtk.cpp:
        (WebCore::seekFile): Not implemented.

2010-11-23  Kenneth Rohde Christiansen  <kenneth@webkit.org>

        Reviewed by Andreas Kling.

        Make setShouldDelegateScrolling not a real setting, so that it works
        similar to the related setUseFixedLayout and setPaintEntireContents
        options which are all in ScrollView.

        * page/FrameView.cpp:
        * page/FrameView.h:
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        * page/Settings.h:
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::ScrollView):
        (WebCore::ScrollView::setDelegatesScrolling):
        * platform/ScrollView.h:
        (WebCore::ScrollView::delegatesScrolling):

2010-11-23  Adam Roben  <aroben@apple.com>

        Don't rely on DocumentLoader outliving the load/unload events

        DocumentLoader::m_documentLoadTiming is used to record how long firing
        the load event took. But the DocumentLoader was being destroyed while
        the event was being dispatched (due to a call to document.open), which
        meant that when we tried to record the time when the load event
        finished, we were writing into freed memory. We now protect the
        DocumentLoader using a RefPtr. (I initially made a change where we
        would only access the DocumentLoader after the event has finished
        firing, but it seemed possible that a different DocumentLoader could
        have come into existence by then, which would cause us to record the
        times on the wrong DocumentLoadTiming struct.)

        I only saw a crash when firing the load event, but the code for timing
        the unload event seemed like it was vulnerable to the same issue, so I
        made the same fix for it.

        Fixes <http://webkit.org/b/49972> REGRESSION (r72415?): Crash in
        DOMWindow::dispatchTimedEvent when running fast/dom/onload-open.html

        Reviewed by Darin Fisher.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::stopLoading):
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::dispatchLoadEvent):
        Protect the DocumentLoader (and thus its DocumentLoadTiming) with a
        RefPtr.

2010-11-17  Zhenyao Mo  <zmo@google.com>

        Reviewed by Kenneth Russell.

        readPixels should generate INVALID_ENUM if only one of type/format mismatch UNSIGNED_BYTE/RGBA
        https://bugs.webkit.org/show_bug.cgi?id=49673

        Test: fast/canvas/webgl/read-pixels-test.html

        * html/canvas/WebGLRenderingContext.cpp:
        (WebCore::WebGLRenderingContext::readPixels):

2010-11-23  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: [STYLES] Use strike through as an 'overridden' marker.
        https://bugs.webkit.org/show_bug.cgi?id=49961

        "line-through" is used for inactive properties overridden within the same style.

        * inspector/front-end/inspector.css:
        (.styles-section .properties .overloaded, .styles-section .properties .inactive, .styles-section .properties .disabled):

2010-11-23  Yael Aharon  <yael.aharon@nokia.com>

        Reviewed by Antonio Gomes.

        Spatial Navigation: Code cleanup
        https://bugs.webkit.org/show_bug.cgi?id=49442

        Remove code that is not used anymore after http://trac.webkit.org/changeset/72522.
        Added const to canBeScrolledIntoView.
        No new tests because this is only code cleanup.

        * page/FocusController.cpp:
        * page/FocusController.h:
        * page/SpatialNavigation.cpp:
        (WebCore::canBeScrolledIntoView):
        * page/SpatialNavigation.h:

2010-11-23  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Steve Block.

        Remove unimplemented (and untested) methods from IndexedDB
        https://bugs.webkit.org/show_bug.cgi?id=49911

        * storage/IDBCursor.idl:
        * storage/IDBDatabase.idl:

2010-11-18  Satish Sampath  <satish@chromium.org>

        Reviewed by Jeremy Orlow.

        For speech input event, send an event object containing all the recognition results and metadata.
        https://bugs.webkit.org/show_bug.cgi?id=49736

        Currently the speech input event 'onwebkitspeechchange' receives no parameters. WebCore already
        has the full list of recognition results and populates only the top result into the input field
        automatically. In this patch we pass a SpeechInputEvent object to the event handler, and the JS
        code can access the full list of results via "event.results.length", "results[i].utterance" and
        "results[i].confidence". Also updated mock object with appropriate methods to test multiple results.

        Test: fast/speech/input-onspeechchange-event.html

        * CMakeLists.txt:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pri:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSEventCustom.cpp:
        (WebCore::toJS): Added new event
        * bindings/v8/custom/V8EventCustom.cpp:
        (WebCore::toV8): Added new event
        * dom/Event.cpp:
        (WebCore::Event::isSpeechInputEvent):
        * dom/Event.h:
        * html/HTMLInputElement.cpp:
        * html/HTMLInputElement.h:
        * page/SpeechInputEvent.h: New file implementing SpeechInputEvent.idl
        (WebCore::SpeechInputEvent::~SpeechInputEvent):
        (WebCore::SpeechInputEvent::create):
        (WebCore::SpeechInputEvent::isSpeechInputEvent):
        (WebCore::SpeechInputEvent::results):
        (WebCore::SpeechInputEvent::SpeechInputEvent):
        * page/SpeechInputEvent.idl: New file defining SpeechInputEvent object
        * page/SpeechInputListener.h:
        * page/SpeechInputResult.cpp:
        (WebCore::SpeechInputResult::create):
        * page/SpeechInputResult.h:
        * page/SpeechInputResult.idl: New file defining a single SpeechInputResult object
        * page/SpeechInputResultList.h: New file implementing SpeechInputResultList.idl
        (WebCore::SpeechInputResultList::create):
        (WebCore::SpeechInputResultList::length):
        (WebCore::SpeechInputResultList::item):
        (WebCore::SpeechInputResultList::SpeechInputResultList):
        * page/SpeechInputResultList.idl: New file defining a list of SpeechInputResult objects
        * platform/mock/SpeechInputClientMock.cpp:
        (WebCore::SpeechInputClientMock::addRecognitionResult): Renamed method and added one parameter.
        (WebCore::SpeechInputClientMock::clearResults):
        (WebCore::SpeechInputClientMock::timerFired):
        * platform/mock/SpeechInputClientMock.h:
        * rendering/TextControlInnerElements.cpp:
        (WebCore::InputFieldSpeechButtonElement::setRecognitionResult): Pass new event object to handler.

2010-11-22  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=49860
        CSS style rules don't GC protect objects reachable as their properties

        Test: fast/dom/StyleSheet/gc-rule-children-wrappers.html

        * Android.jscbindings.mk:
        * CMakeLists.txt:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSBindingsAllInOne.cpp:
        Added new files, sorted appropriate sections for easier adding.

        * bindings/js/JSCSSFontFaceRuleCustom.cpp: Added.
        (WebCore::JSCSSFontFaceRule::markChildren):
        * bindings/js/JSCSSImportRuleCustom.cpp: Added.
        (WebCore::JSCSSImportRule::markChildren):
        * bindings/js/JSCSSMediaRuleCustom.cpp: Added.
        (WebCore::JSCSSMediaRule::markChildren):
        * bindings/js/JSCSSPageRuleCustom.cpp: Added.
        (WebCore::JSCSSPageRule::markChildren):
        * bindings/js/JSCSSStyleRuleCustom.cpp: Added.
        (WebCore::JSCSSStyleRule::markChildren):
        * bindings/js/JSWebKitCSSKeyframeRuleCustom.cpp: Added.
        (WebCore::JSWebKitCSSKeyframeRule::markChildren):
        * bindings/js/JSWebKitCSSKeyframesRuleCustom.cpp: Added.
        (WebCore::JSWebKitCSSKeyframesRule::markChildren):
        Mark objects reachable through these ones.

        * css/CSSFontFaceRule.idl:
        * css/CSSImportRule.idl:
        * css/CSSMediaRule.idl:
        * css/CSSPageRule.idl:
        * css/CSSStyleRule.idl:
        * css/WebKitCSSKeyframeRule.idl:
        * css/WebKitCSSKeyframesRule.idl:
        Added CustomMarkFunction IDL attribute.

2010-11-23  Helder Correia  <helder@sencha.com>

        Reviewed by Ariya Hidayat.

        [Qt] Drawing an image on canvas with shadowBlur draws a solid shadow
        https://bugs.webkit.org/show_bug.cgi?id=49878

        Add support for blurry shadows when drawing images on canvas.

        Test: fast/canvas/canvas-drawImage-shadow.html

        * platform/graphics/qt/ContextShadowQt.cpp:
        (WebCore::ContextShadow::endShadowLayer): Make composition work for solid shadow too.
        * platform/graphics/qt/ImageQt.cpp:
        (WebCore::BitmapImage::draw): Remove old shadow code and introduce ContextShadow.

2010-11-22  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Adam Roben.

        Port ContextMenuWin.cpp to WinCE
        https://bugs.webkit.org/show_bug.cgi?id=48408

        * platform/ContextMenu.h:
        * platform/win/ContextMenuWin.cpp:
        (WebCore::ContextMenu::ContextMenu):
        (WebCore::ContextMenu::itemCount):
        (WebCore::insertMenuItem):
        (WebCore::ContextMenu::insertItem):
        (WebCore::contextMenuItemByIdOrPosition):
        (WebCore::ContextMenu::setPlatformDescription):
        (WebCore::contextMenuItemVector):
        (WebCore::platformMenuDescription):

2010-11-22  David Hyatt  <hyatt@apple.com>

        Back out r72527 since it caused multiple rendering regressions.  Details in bug.

        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::placeBoxesInInlineDirection):
        * rendering/RenderListItem.cpp:
        (WebCore::RenderListItem::positionListMarker):

2010-11-22  John Knottenbelt  <jknotten@chromium.org>

        Reviewed by Steve Block.

        Implement mocks for client-based Geolocation.
        https://bugs.webkit.org/show_bug.cgi?id=49258

        * Android.mk:
        * CMakeLists.txt:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/mock/GeolocationClientMock.cpp: Added.
        (WebCore::GeolocationClientMock::GeolocationClientMock):
        (WebCore::GeolocationClientMock::~GeolocationClientMock):
        (WebCore::GeolocationClientMock::setController):
        (WebCore::GeolocationClientMock::setPosition):
        (WebCore::GeolocationClientMock::setError):
        (WebCore::GeolocationClientMock::geolocationDestroyed):
        (WebCore::GeolocationClientMock::startUpdating):
        (WebCore::GeolocationClientMock::stopUpdating):
        (WebCore::GeolocationClientMock::setEnableHighAccuracy):
        (WebCore::GeolocationClientMock::lastPosition):
        (WebCore::GeolocationClientMock::timerFired):
        (WebCore::GeolocationClientMock::makeGeolocationCallback):
        * platform/mock/GeolocationClientMock.h: Added.

2010-11-22  Tony Gentilcore  <tonyg@chromium.org>

        Reviewed by Adam Barth.

        Fix bogus include guard.

        * loader/NavigationScheduler.h:

2010-11-22  Andreas Kling  <kling@webkit.org>

        Reviewed by Ariya Hidayat.

        [Qt] Canvas: strokeText() and fillText() produce same shadow
        https://bugs.webkit.org/show_bug.cgi?id=48845

        Test: fast/canvas/canvas-strokeText-strokes-shadow.html

        * platform/graphics/qt/FontQt.cpp:
        (WebCore::drawTextCommon): Stroke the shadow rather than filling it in the cTextStroke case.

2010-11-22  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Sam Weinig.

        Use WTF::FixedArray::size()
        https://bugs.webkit.org/show_bug.cgi?id=49891

        * dom/Document.cpp:
        (WebCore::Document::~Document):

2010-11-22  Ryosuke Niwa  <rniwa@webkit.org>

        Reviewed by Tony Chang.

        SelectionController::typingStyle() should return EditingStyle*
        https://bugs.webkit.org/show_bug.cgi?id=49813

        Changed the return type of SelectionController::typingStyle to EditingStyle*.

        Extracted textDirection from Editor::textDirectionForSelection to hide the underlying
        CSSMutableStyleDeclaration.

        Also extracted the code to preserve unicode-bidi and direction CSS properties in
        InsertTextCommand::input, and moved into EditingStyle::prepareToApplyAt. ShouldPreserveWritingDirection,
        which is added to the argument list of EditingStyle::prepareToApplyAt, decides whether or not
        these two properties are preserved.

        Also added SelectionController::copyTypingStyle() to copy the typing style as an instance of
        CSSMutableStyleDeclaration.

        No new tests are added since this is a refactoring.

        * editing/EditingStyle.cpp:
        (WebCore::EditingStyle::textDirection): Extracted from Editor::textDirectionForSelection.
        (WebCore::EditingStyle::removeStyleConflictingWithStyleOfNode): Added a missing null check.
        (WebCore::EditingStyle::prepareToApplyAt): See above.
        (WebCore::editingStyleIncludingTypingStyle): Calls SelectionController::typingStyle.
        * editing/EditingStyle.h: Moved WritingDirection from Editor.h
        * editing/Editor.cpp:
        (WebCore::Editor::textDirectionForSelection): Calls EditingStyle::textDirection.
        (WebCore::Editor::computeAndSetTypingStyle): Calls SelectionController::typingStyle.
        (WebCore::Editor::selectionComputedStyle): Ditto.
        (WebCore::Editor::styleForSelectionStart): Ditto.
        * editing/Editor.h:
        * editing/InsertLineBreakCommand.cpp:
        (WebCore::InsertLineBreakCommand::doApply): Ditto.
        * editing/InsertTextCommand.cpp:
        (WebCore::InsertTextCommand::input): Calls EditingStyle::prepareToApplyAt with PreserveWritingDirection.
        * editing/SelectionController.h:
        (WebCore::SelectionController::typingStyle): Returns EditingStyle* rather than CSSMutableStyleDeclaration*.
        (WebCore::SelectionController::copyTypingStyle): Added.

2010-11-22  Patrick Gansterer  <paroga@webkit.org>

        Reviewed by Adam Roben.

        [WINCE] Set correct preprocessor definitions
        https://bugs.webkit.org/show_bug.cgi?id=49887

        * config.h:

2010-11-22  James Robinson  <jamesr@chromium.org>

        Reviewed by Dimitri Glazkov.

        [chromium] font-size:0 text runs should have zero width
        https://bugs.webkit.org/show_bug.cgi?id=49871

        Returns 0 from platformWidthForGlyph if the specified font size is 0.

        Test: fast/text/font-size-zero.html

        * platform/graphics/chromium/SimpleFontDataChromiumWin.cpp:
        (WebCore::SimpleFontData::platformWidthForGlyph):
        * platform/graphics/chromium/SimpleFontDataLinux.cpp:
        (WebCore::SimpleFontData::platformWidthForGlyph):

2010-11-22  Charlie Reis  <creis@chromium.org>

        Reviewed by Darin Fisher.

        Update correct content state during back/forward navigations
        https://bugs.webkit.org/show_bug.cgi?id=48809

        Ensures that history's previousItem is non-null when clients try to
        update content state (e.g., Chromium's UpdateSessionHistory).  We now
        track load completions with a boolean field rather than by clearing
        previousItem.

        Test: fast/history/saves-state-after-frame-nav.html

        * loader/HistoryController.cpp:
        * loader/HistoryController.h:

2010-11-22  Luiz Agostini  <luiz.agostini@openbossa.org>

        Unreviewed, Windows build fix.

        Adding JSMediaQueryList to DerivedSources.cpp.

        * DerivedSources.cpp:

2010-11-22  Adam Roben  <aroben@apple.com>

        Use paths relative to $WebKitVSPropsRedirectionDir to access shared .vsprops files

        Apple's Windows build allows placing header files and import libraries for WebKit's
        dependencies (CoreGraphics, CFNetwork, SQLite, etc.) outside the source tree via the
        $WebKitLibrariesDir environment variable. This is both required for production builds and
        convenient for Apple-internal developer builds. Apple's production builds also require that
        WebKit's shared .vsprops files be accessed relative to $WebKitLibrariesDir. In production
        builds, the files are copied into that directory tree by the
        WebKitLibraries/win/tools/WinTools.make file. In Apple-internal developer builds, the
        copying is done by
        JavaScriptCore/JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreGenerated.make.

        This .vsprops copying is problematic in one very important case: when a developer updates
        their source tree and then tries to build. Visual Studio only reads .vsprops files when a
        project is first loaded. So, when Visual Studio is first opened after the .vsprops files are
        updated, it reads in the old files that were already residing in $WebKitLibrariesDir. When a
        build is started, JavaScriptCoreGenerated.make copies the new .vsprops files into
        $WebKitLibrariesDir, but Visual Studio will not pick up the changes.  The rest of the build
        will proceed with out-of-date .vsprops files, which will likely result in a build failure.

        To fix this, we now use normal relative paths to access the .vsprops files in the source
        tree rather than in $WebKitLibrariesDir, but prefix those paths with a new environment
        variable, $WebKitVSPropsRedirectionDir. In developer builds, this environment variable is
        unset, so the normal relative paths are used to read the .vsprops files out of the source
        tree directly. In production builds, this environment variable is set to a fake directory
        that will cause the .vsprops files in $WebKitLibrariesDir to be found when the relative path
        is resolved.
        
        For example, JavaScriptCore.vcproj uses this path for FeatureDefines.vsprops:

        $(WebKitVSPropsRedirectionDir)..\..\..\WebKitLibraries\win\tools\vsprops\FeatureDefines.vsprops

        In developer builds, where $WebKitVSPropsRedirectionDir is unset, this will point to the
        files in WebKitLibraries\win\tools\vsprops in the source tree. In production builds,
        JavaScriptCore.make sets $WebKitVSPropsRedirectionDir to
        "$(SRCROOT)\AppleInternal\tools\vsprops\OpenSource\1\2\3\", so the full path for
        FeatureDefines.vsprops becomes:

        $(SRCROOT)\AppleInternal\tools\vsprops\OpenSource\1\2\3\..\..\..\WebKitLibraries\win\tools\vsprops\FeatureDefines.vsprops

        which resolves to:

        $(SRCROOT)\AppleInternal\tools\vsprops\OpenSource\WebKitLibraries\win\tools\vsprops\FeatureDefines.vsprops

        (We rely on the fact that Windows doesn't care whether the directories "1", "2", and "3"
        actually exist since they are matched by an equal number of ".." path components.)

        Note that Visual Studio still won't pick up changes made to .vsprops files while Visual
        Studio is open, but that problem hasn't seemed to cause developers many headaches so far.

        Fixes <http://webkit.org/b/49181> Windows build fails mysteriously when .vsprops files are
        updated

        Reviewed by Dave Hyatt.

        * WebCore.vcproj/WebCore.make: Set $WebKitVSPropsRedirectionDir so that
        production builds can find the .vsprops files.

        * WebCore.vcproj/QTMovieWin.vcproj:
        * WebCore.vcproj/WebCore.vcproj:
        Changed to use paths relative to $WebKitVSPropsRedirectionDir to access shared .vsprops
        files.

2010-10-21  Luiz Agostini  <luiz.agostini@openbossa.org>

        Reviewed by Darin Adler.

        Implement CSSOM View matchMedia interface
        https://bugs.webkit.org/show_bug.cgi?id=37205

        New interfaces may be used to evaluate media queries and to associate listeners
        to media queries. Those listeners are called whenever the associated query changes.
        Specification may be found at http://dev.w3.org/csswg/cssom-view/#the-mediaquerylist-interface

        operator== added to JS version of ScriptValue.
        Method isFunction added to JS and V8 versions of ScriptValue.

        * bindings/js/ScriptValue.cpp:
        (WebCore::ScriptValue::isFunction):
        * bindings/js/ScriptValue.h:
        (WebCore::ScriptValue::operator==):
        * bindings/v8/ScriptValue.h:
        (WebCore::ScriptValue::isFunction):

        Some changes were needed to the code generators to handle type MediaQueryListListener.

        * bindings/scripts/CodeGeneratorGObject.pm:
        * bindings/scripts/CodeGeneratorJS.pm:
        * bindings/scripts/CodeGeneratorV8.pm:

        Some changes to the bindings test results that were previously added.

        * bindings/scripts/test/GObject/WebKitDOMTestMediaQueryListListener.cpp:
        * bindings/scripts/test/GObject/WebKitDOMTestMediaQueryListListener.h:
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.cpp:
        (WebCore::jsTestMediaQueryListListenerPrototypeFunctionMethod):
        * bindings/scripts/test/V8/V8TestMediaQueryListListener.cpp:
        (WebCore::TestMediaQueryListListenerInternal::methodCallback):
        (WebCore::ConfigureV8TestMediaQueryListListenerTemplate):

        New interfaces:

        * css/MediaQueryList.cpp: Added.
        * css/MediaQueryList.h: Added.
        * css/MediaQueryList.idl: Added.

        * css/MediaQueryListListener.cpp: Added.
        * css/MediaQueryListListener.h: Added.
        * css/MediaQueryListListener.idl: Added.

        To avoid adding code to classes DOMWindow and Document a new class MediaQueryMatcher was created.

        * css/MediaQueryMatcher.cpp: Added.
        * css/MediaQueryMatcher.h: Added.

        Document and DOMWindow have changed to support new features. DOMWindow is the class that
        publishes methods matchMedia but for page cache to work properly the reference to the
        MediaQueryMatcher must be in Document.

        * dom/Document.cpp:
        (WebCore::Document::~Document):
        (WebCore::Document::mediaQueryMatcher):
        (WebCore::Document::styleSelectorChanged):
        * dom/Document.h:
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::matchMedia):
        * page/DOMWindow.h:
        * page/DOMWindow.idl:

        Build systems

        * CMakeLists.txt:
        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pri:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/gobject/GNUmakefile.am:

        Tests: fast/media/media-query-list-01.html
               fast/media/media-query-list-02.html
               fast/media/media-query-list-03.html
               fast/media/media-query-list-04.html
               fast/media/media-query-list-05.html
               fast/media/media-query-list-06.html
               fast/media/media-query-list-07.html

2010-11-22  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: [REGRESSION] Contents of rules inside @media not displayed/editable
        https://bugs.webkit.org/show_bug.cgi?id=49804

        * css/CSSImportRule.cpp:
        (WebCore::CSSImportRule::insertedIntoParent):
        * inspector/InspectorCSSAgent.cpp:
        (WebCore::InspectorCSSAgent::setStyleSheetText2):
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::asCSSRuleList):
        (WebCore::InspectorStyleSheet::reparseStyleSheet):
        (WebCore::InspectorStyleSheet::setText):
        (WebCore::InspectorStyleSheet::addRule):
        (WebCore::InspectorStyleSheet::ruleForId):
        (WebCore::InspectorStyleSheet::ruleIndexByStyle):
        (WebCore::InspectorStyleSheet::ensureText):
        (WebCore::InspectorStyleSheet::ensureSourceData):
        (WebCore::InspectorStyleSheet::ensureFlatRules):
        (WebCore::InspectorStyleSheet::revalidateStyle):
        (WebCore::InspectorStyleSheet::buildArrayForRuleList):
        (WebCore::InspectorStyleSheet::fixUnparsedPropertyRanges):
        (WebCore::InspectorStyleSheet::collectFlatRules):
        * inspector/InspectorStyleSheet.h:

2010-11-22  Ilya Tikhonovsky  <loislo@chromium.org>

        Reviewed by Pavel Feldman.

        Web Inspector: dump inspector protocol messages into console.
        Sometimes I need to dump inspector messages into console.
        It'd be much simple to have this code in repository and
        enable protocol dumping just by a flag.

        https://bugs.webkit.org/show_bug.cgi?id=49905

        * inspector/CodeGeneratorInspector.pm:
        * inspector/front-end/WorkersSidebarPane.js:
        (WebInspector.WorkersSidebarPane.prototype.reset):
        * inspector/front-end/inspector.js:
        (WebInspector_syncDispatch):

2010-11-22  Andreas Kling  <kling@webkit.org>

        Reviewed by Nikolas Zimmermann.

        GraphicsContext: Make drawFocusRing() take a Path instead of a Vector<Path>
        https://bugs.webkit.org/show_bug.cgi?id=49840

        This avoid copying a Path object when drawing focus rings.

        * platform/graphics/GraphicsContext.h:
        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/haiku/GraphicsContextHaiku.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/mac/GraphicsContextMac.mm:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/skia/GraphicsContextSkia.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/win/GraphicsContextCGWin.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/wince/GraphicsContextWinCE.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/wx/GraphicsContextWx.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * rendering/RenderImage.h:
        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::paint):
        (WebCore::RenderImage::paintFocusRing):
        Renamed from paintFocusRings since it only paints one ring.

2010-11-22  Renata Hodovan  <reni@webkit.org>

        Reviewed by Andreas Kling.

        Outside list bullets ignore text-align style.
        https://bugs.webkit.org/show-bug.cgi?id=15713

        Fix the position of outside markers by setting its logicalLeft member. Embedded markers need special treatment.
        First, the total width of markers should be calculated. Subtracting it from logicalLeft we get the outermost bullet's
        position. As for the others, this sum should be decremented with the previous marker's width.
        In case of vertical markers the padding is unneeded.

        Test: fast/lists/outSideListMarkers.html

        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::placeBoxesInInlineDirection):
        * rendering/RenderListItem.cpp:
        (WebCore::RenderListItem::positionListMarker):

2010-11-22  Yael Aharon  <yael.aharon@nokia.com>, Chang Shu  <chang.shu@nokia.com>

        Reviewed by Antonio Gomes.

        Spatial Navigation: issues with the node selection algorithm.
        https://bugs.webkit.org/show_bug.cgi?id=49382

        Modify the Spatial Navigation algorithm, to better handle initial focus and
        navigation between frames.
        The new algorithm takes the rect of the focused node as the startingRect,
        instead of the node itself. That allows us to construct a virtual rect if
        there is no focused node, or if it is off the screen.
        The virtual rect is the edge of the container in the direction of the navigation.

        With this patch, scrollable containers and frames will scroll regardless of weather
        they have focusable content. Users will be able to use arrow keys to view all the
        content of such a container. The only exception is if the container has style overflow:hidden. 
        We will not scroll in that case.

        With this patch, we handle z-index and positioning so that if there are 2 overlapping focusable nodes,
        we do a hit test and only the node on top can get focus.

        hasOffScreenRect() was modified so that it can check if a node will be off-screen even after we scrolled
        its parent container. We do not add the scrolling conditions for containers that have overflow:hidden
        and cannot scroll.

        calculateScrollbarModesForLayout is used to decide if a frame can scroll or not. We cannot rely on
        the exsistance of the scrollbar, because it could be removed via the API, while the frame is still
        allowed to scroll.

        * page/FocusController.cpp:
        (WebCore::updateFocusCandidateIfNeeded):
        (WebCore::FocusController::findFocusCandidateInContainer):
        (WebCore::FocusController::advanceFocusDirectionallyInContainer):
        (WebCore::FocusController::advanceFocusDirectionally):
        * page/FocusController.h:
        * page/FrameView.h:
        * page/SpatialNavigation.cpp:
        (WebCore::FocusCandidate::FocusCandidate):
        (WebCore::distanceDataForNode):
        (WebCore::alignmentForRects):
        (WebCore::areRectsMoreThanFullScreenApart):
        (WebCore::isRectInDirection):
        (WebCore::hasOffscreenRect):
        (WebCore::scrollInDirection):
        (WebCore::isScrollableContainerNode):
        (WebCore::scrollableEnclosingBoxOrParentFrameForNodeInDirection):
        (WebCore::canScrollInDirection):
        (WebCore::rectToAbsoluteCoordinates):
        (WebCore::nodeRectInAbsoluteCoordinates):
        (WebCore::frameRectInAbsoluteCoordinates):
        (WebCore::entryAndExitPointsForDirection):
        (WebCore::canBeScrolledIntoView):
        (WebCore::virtualRectForDirection):
        * page/SpatialNavigation.h:

2010-11-22  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Dirk Schulze.

        Fix various problems with the SVG*List code
        https://bugs.webkit.org/show_bug.cgi?id=49880

        Write tests for SVGNumberList/SVGPointList/SVGStringList/SVGTransformList and extend SVGLengthList tests.
        SVG DOM <-> XML DOM synchronization is now tested for all these types, and works great. Unify the string format produced
        by the various valueAsString() functions for maximum compatibility with Firefox / Opera.

        * Build a real transform string for SVGTransformList, instead of dumping the elements of the concatted matrix.
        * Add SVGStringList XML dom synchronization, only affects SVGTests requiredFeatures/requiredExtensions/systemLanguage.
        * Make all animVal properties readonly, tested by types-dom-07-f.svg (from SVG 1.1 2nd edition).
        * Enable StrictTypeChecking/RequiresAllArguments=Raise for all SVGList types.

        Tests: svg/W3C-SVG-1.1-SE/types-dom-07-f.svg
               svg/dom/SVGNumberList-basics.xhtml
               svg/dom/SVGPointList-basics.xhtml
               svg/dom/SVGStringList-basics.xhtml
               svg/dom/SVGTransformList-basics.xhtml

        * bindings/js/JSSVGLengthCustom.cpp:
        (WebCore::JSSVGLength::setValue): Throw NO_MODIFICATION_ALLOWED_ERR when the SVGPropertyTearOffs role is AnimValRole.
        (WebCore::JSSVGLength::convertToSpecifiedUnits): Ditto.
        * bindings/scripts/CodeGeneratorJS.pm: Ditto.
        * bindings/scripts/CodeGeneratorObjC.pm: Ditto.
        * bindings/scripts/CodeGeneratorV8.pm: Ditto.
        * bindings/v8/custom/V8SVGLengthCustom.cpp:
        (WebCore::V8SVGLength::valueAccessorSetter): Ditto.
        (WebCore::V8SVGLength::convertToSpecifiedUnitsCallback): Ditto.
        * svg/SVGAElement.cpp:
        (WebCore::SVGAElement::synchronizeProperty): Also synchronize the SVGTests SVGStringLists.
        * svg/SVGAnimationElement.cpp:
        (WebCore::SVGAnimationElement::synchronizeProperty): Ditto.
        * svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::synchronizeProperty): Ditto.
        * svg/SVGClipPathElement.cpp:
        (WebCore::SVGClipPathElement::synchronizeProperty): Ditto.
        * svg/SVGCursorElement.cpp:
        (WebCore::SVGCursorElement::synchronizeProperty): Ditto.
        * svg/SVGDefsElement.cpp:
        (WebCore::SVGDefsElement::synchronizeProperty): Ditto.
        * svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::synchronizeProperty): Ditto.
        * svg/SVGForeignObjectElement.cpp:
        (WebCore::SVGForeignObjectElement::synchronizeProperty): Ditto.
        * svg/SVGGElement.cpp:
        (WebCore::SVGGElement::synchronizeProperty): Ditto.
        * svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::synchronizeProperty): Ditto.
        * svg/SVGLengthList.cpp:
        (WebCore::SVGLengthList::valueAsString): Use ' ' instead of ',' as seperator.
        * svg/SVGLengthList.idl: Enable StrictTypeChecking, RequiresAllArguments=Raise.
        * svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::synchronizeProperty): Also synchronize the SVGTests SVGStringLists.
        * svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::synchronizeProperty): Ditto.
        * svg/SVGNumberList.cpp:
        (WebCore::SVGNumberList::valueAsString): Use ' ' instead of ',' as seperator.
        * svg/SVGNumberList.idl: Enable StrictTypeChecking, RequiresAllArguments=Raise.
        * svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::synchronizeProperty): Also synchronize the SVGTests SVGStringLists.
        * svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::synchronizeProperty): Ditto.
        * svg/SVGPointList.idl: Enable StrictTypeChecking, RequiresAllArguments=Raise.
        * svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::synchronizeProperty): Also synchronize the SVGTests SVGStringLists.
        * svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::synchronizeProperty): Ditto.
        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::synchronizeProperty): Ditto.
        * svg/SVGStringList.cpp:
        (WebCore::SVGStringList::valueAsString): Add valueAsString() implementation, necessary for SVG DOM <-> XML DOM synchronization.
        * svg/SVGStringList.h:
        * svg/SVGStringList.idl: Enable StrictTypeChecking, RequiresAllArguments=Raise.
        * svg/SVGSwitchElement.cpp:
        (WebCore::SVGSwitchElement::synchronizeProperty): Also synchronize the SVGTests SVGStringLists.
